#ifndef __GBACOMPRESS_H__
#define __GBACOMPRESS_H__

#ifdef __cplusplus
extern "C"
{
#endif

#include "agb.h"

/**
 * Compress a part of memory to a destination buffer
 * \param src the source memory pointer
 * \param src_len the length of the source in bytes
 * \param dst the destination memory pointer. This should be at least sourcesize + (sourcesize/8) + 256 in size
 * \param dst_len the pointer for the length of the destination buffer. 
 * \param level the compression level from 1 to 10 where 10 is the best compression
 * \return An error code or 0 for no error
 */
extern int GBACompress( const u8*src, u32 src_len,u8 *dst, u32 *dst_len,int level);

#ifdef __cplusplus
};
#endif

#endif
