// pagemap l:\project\graphics\maps\Le_Wahi\MUAKABD.bmp muakabd 4 -k
// pagemap L:\project\graphics\maps\Ta_Wahi\bossBackdrop2.bmp boss2bd 4 -k
// pagemap L:\project\graphics\maps\onu_wahi\bossBackdrop3.bmp boss3bd 4 -k

// *** Don't forget to change u16 to u8
// pagemap l:\project\graphics\baddies\muakawithground.bmp muakabody 8 -n MuakaBody -k
// pagemap l:\project\graphics\baddies\rahibosswground.bmp rahibody 8 -n RahiBody -k
// pagemap l:\project\graphics\baddies\baragbosswithground.bmp baragbody 8 -n BaragBody -k
// Get palette from...
// pagemap l:\project\graphics\baddies\baragbosswithground2.bmp tempy 8 -n BaragBody2 -k


// Muako Boss

#include <AGB.h>
#include "asldefines.h"
#include "Muakabody.h" 
#include "rahibody.h"
#include "baragbody.h"
#include "baragbits.h"
#include "main.h"
//#include "data.h"
#include "player.h"
#include "muakaheadsprites.h"
#include "muakaarm.h"
#include "rahiarm.h"
#include "rocksandstuff.h"
#include "SampleManager.h"
#include "muakabreath.h"
#include "muakaboss.h"
#include "rocks.h"
#include "particles.h"
#include "platform.h"
#include "switch.h"
#include "enemybohrok.h"
#include "GBADecompress.h"
#include "muakabd.h"
#include "powerupfx.h"
#include "boss2bd.h"
#include "boss3bd.h"

extern s16 game_x,game_y;
extern s16 CameraPush;
extern bohrokparms Bohrok[16];

u8 boss_end_time;
u8 boss_end;
s8 Boss_dx;
u8 muakahead,muakahead2,muakajaw,muakachomp,muakashoulder;
s16 muakahead_x,muakahead_y,muakagrab_y;
u16 Boss_Roar;
u16 Boss_Gob;
u16 Boss_Taunt;
s8 Bossdy;
s16 Boss_Floor;

u8 muakaneck[4];
u8 muakaneckframe;
u8 muakagrabtime;
u8 muakahits,muakaflash;
u8 muakaarmslam,muakaarmlift;
s16 muaka_left,muaka_right;
u8 breathframe[8];
u8 breathgobsprite;
u8 breathscale;
int breathtimer;
u8 rahisnooze;

u8 muakaseqptr;
s16 muakaseqtime;

s16	muakadropxpos;
s16	muakadropypos;
s8	muakadrophits;
u8	muakadrophitsmax;
u8	muakadropflash;
s16	muakadropdy;
s16 muakadropstarty;
u8 muakadropframe;
u8 muakahittime;
u8 MFlashFirstSeen;

const u8 BPlatSequence[16] = {0,1,2,1,0,2,0,1,0,2,1,2};
u8 BPlatPtr;
s8 BPlatlasttime;
u8 BPlatlast;
u8 rahiplayerhead,rahithrowplayer;
int roarpos;

int minimodedelta;

int bossgobcounter;
int bossgobout;
int bossgobrot;
int temprot;

int tweakx;
int tweaky;
int globalblend;
//int cycleon;

//const u8 muakasequence[16] = {0,5,3,5,0,5,3,5,0,5,3,5,3,5,3,5};
const u8 muakasequence[16] = {0,5,1,2,3,0,1,4,5,0,1,2,5,0,1,5};

static int commonskip;

/* Boss configuration values */
int gBossConfig_HeightY;
int gBossScreen_OffsetX;
int gBossScreen_OffsetY;
int gBossScreen_MasterY;
int gBossScreen_StartX;
int gBossScreen_FeetOffsetX;
int gBossConfig_AttackOffsetX;
int gBossConfig_AttackOffsetY;
int gBossSwitchToSecond;
int gBossConfigSpeed;
int gBossLifeAdd;

int backupbossy;

void HandleGenericBoss(void);
void HandleBossFireball(void);
void CommonBossPostInitAlways(void);

int bossonscreentick;
u16 localpal[16];


const u32 BossLifeBarChar[32] = { // sprite data in 1D formation
0x0cc00000,0xfcecc000,0xfcddecc0,0xfcddddec,0xfcddecc0,0xfceccff0,0xfccff000,0xfff00000,
0x0cc00000,0xfcecc000,0xfcdefcc0,0xfcddfffc,0xfcdefcc0,0xfceccff0,0xfccff000,0xfff00000,
0x0cc00000,0xfcfcc000,0xfcfffcc0,0xfcfffffc,0xfcfffcc0,0xfcfccff0,0xfccff000,0xfff00000,
};

const u16 BossLifeBarPalette[16] ={ // palette data
0x7c1f,0x0cd2,0x0cd2,0x0cd2,0x0cd2,0x0cd2,0x0cd2,0x0cd2,0x0cd2,0x0cd2,0x0cd2,0x7fff,0x2906,0x001f,0x0018,0x0000,
};

const u16 BaragBody2Palette[256] ={ // palette data
0x7c1f,0x5f38,0x4a72,0x39cc,0x2948,0x1863,0x0000,0x7d48,0x7e46,0x5880,0x0001,0x0c66,0x7fff,0x08c7,0x0831,0x0047,
0x581f,0x0047,0x0000,0x0001,0x0831,0x0458,0x005a,0x005c,0x007f,0x1006,0x0c66,0x08c7,0x0948,0x05a9,0x020a,0x028b,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,0x03e0,
};

int ScaleToFit(int value)
{
	int scalar;

	if (MiniMode == 0 || MiniMode == 64)
	{
		return value;
	}

	scalar = 64 - MiniMode;		// Range 0 -> 32
	scalar = 32 - scalar;		// Range 32 -> 0
	scalar += 32;				// Range 64 -> 32

	return (value * scalar)/64;	// Range value -> value/2;
}

int ScaleZeroToHalf(int value)
{
	int scalar;

	if (MiniMode == 0 || MiniMode == 64)
	{
		return 0;
	}

	scalar = 64 - MiniMode;		// Range 0 -> 32

	return (value * scalar)/64;	// Range 0 -> value/2;
}

void initbossbreath(void)
{
	u8 a,frame;
	
	breathgobsprite = GrabASprite();
	Sprite[breathgobsprite].ObjMode = 0;
	Sprite[breathgobsprite].AffineMode = 0;
	Sprite[breathgobsprite].AffineParamNo_L = 0;
	Sprite[breathgobsprite].Shape = 0;	// Square
	Sprite[breathgobsprite].Size = 3;	// 64
	Sprite[breathgobsprite].CharNo = ENEMY_SPRITE;
	Sprite[breathgobsprite].Priority = 2;
	Sprite[breathgobsprite].Pltt = 7;

	Object[num_strats].handle = HandleBossBreath;
	Object[num_strats].remover = 0;
	for(a = 0; a < 8; a++)
	{
		frame = GrabASprite();
		breathframe[a] = frame;
		


		Sprite[frame].ObjMode = 0; // window
	   	Sprite[frame].AffineMode = 0; // off 3; // on and double size
		Sprite[frame].AffineParamNo_L = 0; // use affine 0
	   	Sprite[frame].Shape = MuakaBreathSizeShape[1];
	   	Sprite[frame].Size = MuakaBreathSizeShape[0];

	   	Sprite[frame].CharNo = ENEMY_SPRITE;
		Sprite[frame].Priority = 2;
	   	Sprite[frame].Pltt = 7;
   	
	}

	breathscale = 1;
	breathtimer = 0;
}

int fireball_xpos;
int fireball_ypos;
int fireball_vely;
int fireball_sprite;
int fireball_frame;
int fireball_targetx;
int fireball_splash;
int fireball_hit;

#include "ParticleSprites.h"

void initbossfireball(void)
{
	int a;

	a = GrabASprite();
	Sprite[a].ObjMode = 0;
	Sprite[a].AffineMode = 0;
	Sprite[a].AffineParamNo_L = 0;
	Sprite[a].Shape = 0;	// Square
	Sprite[a].Size = 3;	// 64
	Sprite[a].CharNo = ENEMY_SPRITE;
	Sprite[a].Priority = 2;
	Sprite[a].Pltt = 7;

	fireball_sprite = a;
	Object[num_strats].handle = HandleBossFireball;
	Object[num_strats].remover = 0;

	fireball_frame = 0;
	fireball_splash = 2;
	fireball_hit = 0;
}

void SpriteRotateScaleBig(u8 myaffine, u8 ang, int scalex,int scaley)
{
	u8 aff;
	aff = myaffine << 2;
	
	Sprite[aff].AffineParam = (((int)fsin[(ang + 64) & 255])) / scalex;
	Sprite[aff + 1].AffineParam = (((int)fsin[ang])) / scalex;
	Sprite[aff + 2].AffineParam = (-((int)fsin[ang])) / scaley;
	Sprite[aff + 3].AffineParam = (((int)fsin[(ang + 64) & 255])) / scaley;
}

void HandleBossFireball(void)
{
	int sprx,spry,delta;

	if (!fireball_hit)
	{
		fireball_ypos += fireball_vely;
		fireball_vely = min(fireball_vely+(GameClock&1),4);

		delta = fireball_targetx - fireball_xpos;
		delta = min(delta,2);
		delta = max(delta,-2);

		fireball_xpos += delta;
	}

	if (fireball_ypos >= Boss_ypos + 96 - gBossScreen_MasterY - 32 && !fireball_hit)
	{
		fireball_ypos = Boss_ypos + 96 - gBossScreen_MasterY - 32;
		fireball_hit = 1;
		Sample_Play(SMPL_WALL_SMASH01);
		Sample_Play(SMPL_WALL_SMASH01);
	}
	if (fireball_hit)
	{
		fireball_splash--;
		if (fireball_splash < 0)
		{
			fireball_splash = 2;
			fireball_frame++;
			if (fireball_frame >= 6)
			{
				remove();
				Sprite[fireball_sprite].VPos = 161;
				return;
			}
		}
	}
	
	sprx = fireball_xpos - game_x;
	spry = fireball_ypos - game_y;
	if (fireball_hit)
	{
		sprx -= 16;
		spry -= 16;
	}

	if(sprx > -64 && sprx < 240 && spry > -64 && spry < 160)
	{
		if (fireball_hit)
		{
			LoadEnemySprite((int)((u8*)PowerupSplashSprite)+(fireball_frame*2048), 2048);
			LoadEnemyPalette((int)PowerupFXPalette[0],nxtenemypal);

			Sprite[fireball_sprite].HPos = sprx & 511;
			Sprite[fireball_sprite].VPos = (spry + 256) & 255;
			
			Sprite[fireball_sprite].Pltt = 2 + PalCache;
			Sprite[fireball_sprite].CharNo = EnemySprite[SpriteCache];
			Sprite[fireball_sprite].Size = 3;	// 64
	   		Sprite[fireball_sprite].AffineMode = 0;
			Sprite[fireball_sprite].AffineParamNo_L = 0;
		}
		else
		{
			LoadEnemySprite((int)((u8*)Particle2TaSprite/*PowerupFXSprite*/)/*+(4*2048)*/, 128);
			LoadEnemyPalette((int)ParticleTaPalette,nxtenemypal);

			Sprite[fireball_sprite].HPos = sprx & 511;
			Sprite[fireball_sprite].VPos = (spry + 256) & 255;
			
			Sprite[fireball_sprite].Pltt = 2 + PalCache;
			Sprite[fireball_sprite].CharNo = EnemySprite[SpriteCache];
			Sprite[fireball_sprite].Size = 1;	// 16
	   		Sprite[fireball_sprite].AffineMode = 3;
			Sprite[fireball_sprite].AffineParamNo_L = 4;
			SpriteRotateScaleBig(4,(GameClock*4) & 255,2,2);
		}
	}
	else
	{
		Sprite[fireball_sprite].VPos = 160;
	}


	sprx += game_x;
	spry += game_y;
	
	if((sprx > player.xpos - ScaleToFit(24)) && (sprx < player.xpos + ScaleToFit(24)) && (spry > player.ypos - ScaleToFit(32)) && (spry < player.ypos))
	{
		if (!fireball_hit)
		{
			HitPlayer(1);
			fireball_hit = 1;
			Sample_Play(SMPL_WALL_SMASH01);
			Sample_Play(SMPL_WALL_SMASH01);
		}
	}

}

void HandleBossBreath(void)
{
	u16 a,frame;
	int sprx,spry;
	u32 sprite_ptr;

	
	if(player_state == player_state_notatalldead)
	{
  		Boss_Roar = 0;	
	}


	if(Boss_Roar)
	{
		int i,j;

		for (i=0;i<16;i++)
		{
			localpal[i] = MuakaBreathPalette[i];
		}
		a = GameClock & 7;
		while (a--)
		{
			j = localpal[11];
			for (i=11;i<15;i++)
			{
				localpal[i] = localpal[i+1];
			}
			localpal[15] = j;
		}


		breathtimer++;

		if (breathtimer < 120)
		{
			int b;
			sprx = Boss_xpos + ScaleToFit(muakahead_x+gBossScreen_OffsetX);
			spry = Boss_ypos + ScaleToFit(muakahead_y+gBossScreen_OffsetY) + ScaleZeroToHalf(gBossConfig_HeightY);

			b = rndfast(255);

			spawnparticle(sprx + ScaleToFit((int)fsin[(b + 64) & 255]/2),spry + ScaleToFit((int)fsin[b]/2),ScaleToFit(-fsin[(b + 64) & 255]/8),ScaleToFit(-fsin[b]/8),0,0,16,1,0);

			sprx = Boss_xpos + ScaleToFit(muakahead_x+gBossScreen_OffsetX) - game_x  - ScaleZeroToHalf(32);
			spry = Boss_ypos + ScaleToFit(muakahead_y+gBossScreen_OffsetY) - game_y + ScaleZeroToHalf(gBossConfig_HeightY)  - ScaleZeroToHalf(32);

			if(sprx > -64 && sprx < 240 && spry > -64 && spry < 160 && (GameClock & 1))
			{
				LoadEnemySprite((int)((u8*)PowerupFXSprite)+(4*2048), 2048);
				LoadEnemyPalette(PowerupFXPalette[0],nxtenemypal);

				Sprite[breathgobsprite].HPos = sprx & 511;
				Sprite[breathgobsprite].VPos = (spry + 256) & 255;
				
				Sprite[breathgobsprite].Pltt = 2 + PalCache;
				Sprite[breathgobsprite].CharNo = EnemySprite[SpriteCache];
			}
			else
			{
				Sprite[breathgobsprite].VPos = 160;
			}

			return;
		}

		sprx = Boss_xpos + ScaleToFit(muakahead_x+gBossScreen_OffsetX) - game_x - ScaleToFit(16) - ScaleZeroToHalf(32) - 32 - (breathscale/4);
		spry = Boss_ypos + ScaleToFit(muakahead_y+gBossScreen_OffsetY) - game_y + ScaleZeroToHalf(gBossConfig_HeightY) - ScaleZeroToHalf(32) - 32;

		LoadEnemySprite((int)PowerupBreathSprite, 2048);
		LoadEnemyPalette((int)PowerupFXPalette[0],nxtenemypal);

		if(sprx > -64 && sprx < 240 && spry > -64 && spry < 160 && (GameClock & 1))
		{

			Sprite[breathgobsprite].HPos = sprx & 511;
			Sprite[breathgobsprite].VPos = (spry + 256) & 255;
			
			Sprite[breathgobsprite].Pltt = 2 + PalCache;
			Sprite[breathgobsprite].CharNo = EnemySprite[SpriteCache];

	   		Sprite[breathgobsprite].AffineMode = 3; // off 3; // on and double size
			Sprite[breathgobsprite].AffineParamNo_L = 2; // use affine 0
			SpriteScaleFine(2,64+breathscale,64);
		}
		else
		{
			Sprite[breathgobsprite].VPos = 160;
		}

		breathscale = min(32, breathscale + 2/*(GameClock & 1)*/);

		sprite_ptr = (u32)MuakaBreathSprite;
		LoadEnemySprite((int)((u8*)sprite_ptr), 1024);
//		LoadPalette((int)localpal,6);
		LoadEnemyPalette((int)localpal,nxtenemypal);

#if 1
		for(a = 0; a< 5; a++)
		{
			frame = breathframe[a];
			sprx = Boss_xpos + ScaleToFit(muakahead_x+gBossScreen_OffsetX) - (a * ScaleToFit(breathscale)) - game_x - ScaleZeroToHalf(16);
			spry = Boss_ypos + ScaleToFit(muakahead_y+gBossScreen_OffsetY) + ScaleZeroToHalf(gBossConfig_HeightY) + ScaleToFit(16) - game_y + ScaleToFit((GameClock & 2) >> 1) - ScaleZeroToHalf(16);

			if (a==4)
			{
				sprx -= ScaleToFit(32) - ScaleToFit(breathscale);
			}

			// Turn it off
//			spry = 255;
			
			if(sprx > -64 && sprx < 240 && spry > -64 && spry < 160 && (GameClock & 1))
			{
				Sprite[frame].HPos = sprx & 511;
				Sprite[frame].VPos = (spry + 256) & 255;
				
//				Sprite[frame].Pltt = 6;
				Sprite[frame].Pltt = 2 + PalCache;
				if (a!=4)
				{
					Sprite[frame].CharNo = EnemySprite[SpriteCache]+16;
				}
				else
				{
					Sprite[frame].CharNo = EnemySprite[SpriteCache];
				}
				sprx += game_x;
				spry += game_y;
				
				if(player.ActionFlags & ACTION_DUCKED)
					spry-= ScaleToFit(48);
				if((sprx > player.xpos - ScaleToFit(64)) && (sprx < player.xpos + ScaleToFit(32)) && (spry > player.ypos - ScaleToFit(80)) && (spry < player.ypos))
				{
					HitPlayer(1);
				}
			
			}
			else
			{
				Sprite[frame].VPos = 160;
			}
		}
#endif
	}
	else
	{
		for(a = 0; a< 8; a++)
		{
			Sprite[breathframe[a]].VPos = 161;
		}
		Sprite[breathgobsprite].VPos = 161;
		remove();
	}
}

void InitBossVars(void)
{
	muakadrophits = 20 + (Game_Difficulty*4) + gBossLifeAdd;
	muakadrophitsmax = muakadrophits;
	muakaseqptr = 0;
	muakaseqtime = 30;
	muakadropflash = 0;
	
	ForegroundMode = 3; // no foreground
	boss_end = 0;
 	boss_end_time = 0;

	Object[num_strats].handle = HandleGenericBoss;
	Object[num_strats].remover = 0;
	
	muakahead_x = -64;
	muakahead_y = 0;

	Boss_armrot = 0;
	Boss_dx = -1;
	muakagrab_y = 0;
	muakagrabtime = 0;
	muakahits = 3 + Game_Difficulty;
	muakaflash = 0;
	muakaarmslam = 0;
	Boss_armlift = 0;
	muakaarmlift = 0;
}

void InitGenericBoss(void)
{
	u8 a;
	u32 ptr;
	u32 dest;

	player.xpos = 32;
	
	InitBossVars();

	Boss_xpos = parm_xpos;
	muaka_left = parm_xpos;
	muaka_right = parm_xpos;

	Boss_xpos = gBossScreen_StartX;
	backupbossy = parm_ypos;
	Boss_ypos = backupbossy - 96 + gBossScreen_MasterY;
	muaka_left = Boss_xpos;
	muaka_right = parm_ypos;
	
	*(vu16 *)REG_BG0VOFS = 0;
	*(vu16 *)REG_BG0HOFS = 0;
	*(vu16 *)REG_BG1VOFS = 0;
	*(vu16 *)REG_BG1HOFS = 0;

	muakahead = GrabASprite();
	muakahead2 = GrabASprite();
	muakajaw = GrabASprite();
	muakashoulder = GrabASprite();
	for(a = 0; a < 4; a++)
	{
		muakaneck[a] = GrabASprite();
		Sprite[muakaneck[a]] = *(OamData *)OamData_Sample;
		Sprite[muakaneck[a]].Shape = MuakaHeadSizeShape[1];
		Sprite[muakaneck[a]].Size = MuakaHeadSizeShape[0];
	   	Sprite[muakaneck[a]].Pltt = 6;
		Sprite[muakaneck[a]].Priority = 2;
	}
	Sprite[muakahead] = *(OamData *)OamData_Sample;
	Sprite[muakahead].Shape = MuakaHeadSizeShape[1];
	Sprite[muakahead].Size = MuakaHeadSizeShape[0];
   	Sprite[muakahead].Pltt = 5;
	Sprite[muakahead].Priority = 2;
   	
   	Sprite[muakajaw] = *(OamData *)OamData_Sample;
	Sprite[muakajaw].Shape = MuakaHeadSizeShape[1];
	Sprite[muakajaw].Size = MuakaHeadSizeShape[0];
	Sprite[muakajaw].Pltt = 5;
	Sprite[muakajaw].Priority = 2;
   
	Sprite[muakahead2] = *(OamData *)OamData_Sample;
	Sprite[muakahead2].Shape = 0;
	Sprite[muakahead2].Size =  2;
	Sprite[muakahead2].Pltt = 5;
	Sprite[muakahead2].Priority = 2;
	
	Sprite[muakashoulder] = *(OamData *)OamData_Sample;
	Sprite[muakashoulder].Shape = 0;
	Sprite[muakashoulder].Size =  3;
	Sprite[muakashoulder].Pltt = 5;
	Sprite[muakashoulder].Priority = 1;
}

void HandleGenericBoss(void)
{
	s16 sprx,spry;
	s16 dx,dy;
	u8 a,frame;
	int hit;

	Boss_xpos = gBossScreen_StartX;
	Boss_ypos = backupbossy - 96 + gBossScreen_MasterY - ScaleZeroToHalf(gBossScreen_MasterY);

	for (a=0;a<(muakadrophitsmax+1)/2;a++)
	{
		if (a < (muakadrophits+1)/2)
		{
//	DmaClear(3, 1 | 0x2000, (BG_VRAM + 0x0800),0x0800,32);
			if (a<((muakadrophits)/2))
			{
				((u16*)(BG_VRAM + 0x0800))[32+28-a] = 1 | 0x2000;
			}
			else
			{
				if (((muakadrophits/2)*2) == muakadrophits)
				{
					((u16*)(BG_VRAM + 0x0800))[32+28-a] = 1 | 0x2000;
				}
				else
				{
					((u16*)(BG_VRAM + 0x0800))[32+28-a] = 2 | 0x2000;
				}
			}
		}
		else
		{
			((u16*)(BG_VRAM + 0x0800))[32+28-a] = 3 | 0x2000;
		}
	}

	if (bossonscreentick<=3)
	{
		bossonscreentick++;
		*(vu16 *)REG_DISPCNT &= ~DISP_OBJ_ON;

		Screen0(0);
		Screen1(0);
		Screen2(0);
		Screen3(0);
	}
	else
	{
		*(vu16 *)REG_DISPCNT |= DISP_OBJ_ON;

		Screen0(1);
		Screen1(1);
		Screen2(1);
		Screen3(0);
	}


  	if(player_state == player_state_notatalldead)
	{
		muakaseqptr = 0;
		muakaseqtime = 30;
	}

  
   	LoadPalette(MuakaHeadPalette,5);

	if(muakaflash > 0)
	{
		muakaflash--;
		if((muakaflash & 7) == 0)
		{
			if(muakaflash & 8)
			{
				LoadPalette(VFlashPalette,5); // flash head
			}
	//		else
	//		{
	//			LoadPalette(MuakaHeadPalette,2); // normal head
	//		}

		}
	}
	
	if(muakahits > 0)
	{
		Boss_armrot--;
		if(muakaarmslam)
		{
			muakaarmlift++;
			if(muakaarmlift == 8)
			{
				muakaarmlift = 0;
				Boss_armlift++;
				if(Boss_armlift == 3)
					muakaarmslam = 0;
			}
		}
		else
		{
			if(Boss_armlift > 0)
			{
				muakaarmlift++;
				if(muakaarmlift == 4) // SLAM! shake the camera and drop things
				{
					muakaarmlift = 0;
					Boss_armlift++;
					if(Boss_armlift == 4)
					{
						CameraShake = 64;
					//	for(a = 0; a < 16; a++)
					//		spawnparticle(Boss_xpos - 128 + a * 16,game_y,srnd(16),rnd(12),rnd(127),1,64,6,1);
						
						if(nxtenemy == 0)
						{
							wp_xpos = player.xpos;
							wp_ypos = player.ypos;
// Disabled for now
//							spawn(initdropper,player.xpos,game_y ,1);
						}
					}
					else
					{
						Boss_armlift = 0;
					}
				}
			}
		}
		
		if(Boss_Roar == 0 && Boss_Taunt == 0)
		{
		//	Boss_xpos += Boss_dx;
			if(Boss_xpos < muaka_left)
				Boss_dx = 1;
			if(Boss_xpos > muaka_right )
				Boss_dx = -1;
			
//			if((Boss_xpos & 7) == 0)
//				spawnparticle(Boss_xpos + ScaleToFit(32),Boss_ypos + ScaleToFit(100) + ScaleZeroToHalf(gBossConfig_HeightY),srnd(16),-rnd(16)-24,rnd(127),1,64,6,1);
//			if((Boss_xpos & 7) == 3)
//				spawnparticle(Boss_xpos + ScaleToFit(220),Boss_ypos + ScaleToFit(100) + ScaleZeroToHalf(gBossConfig_HeightY),srnd(16),-rnd(16)-24,rnd(127),1,64,6,1);
		}
		CameraPush = smin(CameraPush + 4,64);
	}
	else
	{
		if(muakahittime > 0)
		{
			if((muakahittime & 7) == 0)
			{
				if((muakahittime & 8) == 0)
				{
					spawn(initbaddyblast,Boss_xpos + ScaleToFit(rnd(128)),Boss_ypos + ScaleToFit(rnd(64)) + ScaleZeroToHalf(gBossConfig_HeightY),0);
					spawn(initbaddyblast,Boss_xpos + ScaleToFit(muakahead_x+gBossScreen_OffsetX +rnd(64)),Boss_ypos + ScaleToFit(muakahead_y + rnd(64)) + ScaleZeroToHalf(gBossConfig_HeightY),0);
					Sample_Play(SMPL_WALL_SMASH01);
				}
				else
				{
					spawn(initbaddyblast,Boss_xpos + ScaleToFit(rnd(128)),Boss_ypos + ScaleToFit(rnd(64)) + ScaleZeroToHalf(gBossConfig_HeightY),1);
					spawn(initbaddyblast,Boss_xpos + ScaleToFit(muakahead_x+gBossScreen_OffsetX + rnd(64)),Boss_ypos + ScaleToFit(muakahead_y + rnd(64)) + ScaleZeroToHalf(gBossConfig_HeightY),2);
				}
			}
			muakahittime--;	

		}
	}

	// handle head sprite
	sprx = Boss_xpos + ScaleToFit(muakahead_x+gBossScreen_OffsetX) - game_x - ScaleZeroToHalf(32);
	spry = Boss_ypos + ScaleToFit(muakahead_y+gBossScreen_OffsetY) - game_y + ScaleZeroToHalf(gBossConfig_HeightY) - ScaleZeroToHalf(32);
	
	if(sprx > -64 && sprx < 240 && spry > -64 && spry < 160)
	{
		Sprite[muakahead].HPos = sprx  & 511;
		Sprite[muakahead].VPos = (spry + 256) & 255;
		Sprite[muakahead].CharNo = BOSS_SPRITE1 + 64;
	}
	else
	{
		Sprite[muakahead].VPos = 160;
	}
		
	sprx = Boss_xpos + ScaleToFit(muakahead_x+gBossScreen_OffsetX) - game_x - ScaleZeroToHalf(32);
	spry = Boss_ypos + ScaleToFit(muakahead_y + 16 + muakachomp+gBossScreen_OffsetY) - game_y + ScaleZeroToHalf(gBossConfig_HeightY) - ScaleZeroToHalf(32);
	
	if(sprx > -64 && sprx < 240 && spry > -64 && spry < 160)
	{
		Sprite[muakajaw].HPos = sprx  & 511;
		Sprite[muakajaw].VPos = (spry + 256) & 255;
		Sprite[muakajaw].CharNo = BOSS_SPRITE1;
	}
	else
	{
		Sprite[muakajaw].VPos = 160;
	}

	// Update the jaw position animation
	if(Boss_Roar || Boss_Gob || bossgobrot || temprot)
	{
		muakachomp = min(12,muakachomp + 1);
	}
	else
	{
		if(muakagrabtime == 0 && muakahits > 0)
		{
			muakachomp++;
			if(muakachomp >= 12)
				muakachomp = 0;
		}	
	}

	sprx = Boss_xpos + ScaleToFit(muakahead_x+gBossScreen_OffsetX) + ScaleToFit(64) - game_x - ScaleZeroToHalf(16);
	spry = Boss_ypos + ScaleToFit(muakahead_y+gBossScreen_OffsetY) - game_y + ScaleZeroToHalf(gBossConfig_HeightY) - ScaleZeroToHalf(16);
	
	if(sprx > -64 && sprx < 240 && spry > -64 && spry < 160)
	{		
		Sprite[muakahead2].HPos = sprx & 511;
		Sprite[muakahead2].VPos = (spry + 256) & 255;
		Sprite[muakahead2].CharNo = BOSS_SPRITE2;
	}
	else
	{
		Sprite[muakahead2].VPos = 160;
	}
	
	// handle neck
	
	dx = muakahead_x >> 2; // neck delta x
	dy = muakahead_y >> 2; // neck delta y
	

	frame = 0;
	if(dx < -12)
		if(dx < -24)
			frame = 2;
		else
			frame = 1;
	
	if(frame != muakaneckframe)
		LoadSprite((u32)MuakaNeckSprite + frame * 2048,(u32)(BOSS_SPRITE1_OFFSET + BOSS_SPRITE1_SIZE * 3),BOSS_SPRITE1_SIZE);
	
	muakaneckframe = frame;	
	for(a = 0; a < 4;a++)
	{
		sprx = Boss_xpos + ScaleToFit((dx * a) +64 + gBossScreen_OffsetX) - game_x - ScaleZeroToHalf(32);
		spry = Boss_ypos + ScaleToFit((dy * a)+gBossScreen_OffsetY) - game_y + ScaleZeroToHalf(gBossConfig_HeightY) - ScaleZeroToHalf(32);
		
		if(sprx > -64 && sprx < 240 && spry > -64 && spry < 160)
		{		
			Sprite[muakaneck[a]].HPos = sprx & 511;
			Sprite[muakaneck[a]].VPos = (spry + 256) & 255;
			Sprite[muakaneck[a]].CharNo = BOSS_SPRITE1 + 192;
		}
		else
		{
			Sprite[muakaneck[a]].VPos = 160;
		}
	}

	sprx = Boss_xpos + ScaleToFit(64+gBossScreen_OffsetX) - game_x - ScaleZeroToHalf(32);
	spry = Boss_ypos + ScaleToFit(8+gBossScreen_OffsetY) - game_y + ScaleZeroToHalf(gBossConfig_HeightY) - ScaleZeroToHalf(32);
	
	if(sprx > -128 && sprx < 240 && spry > -128 && spry < 160)
	{		
		Sprite[muakashoulder].HPos = sprx & 511;
		Sprite[muakashoulder].VPos = (spry + 256) & 255;
		Sprite[muakashoulder].CharNo = BOSS_SPRITE1 + 128;
//		Sprite[muakashoulder].AffineMode = 3;
//		Sprite[muakashoulder].AffineParamNo_L = 3;		
	}
	else
	{
		Sprite[muakashoulder].VPos = 160;
		SpriteRotateScale(3,0,1,1);
		
	}

// Enable or disable animation of the boss
#if 1
	if(muakahits > 0)
	{
		if(muakagrab_y || muakaarmslam || Boss_armlift || Boss_Roar || Boss_Taunt || Boss_Gob) // doing move, so don't pick another
		{
			if(Boss_Gob)
			{
				muakahead_x += smin(gBossConfig_AttackOffsetX -16 - muakahead_x,(2+gBossConfigSpeed));
				muakahead_y += smin(gBossConfig_AttackOffsetY +32 - muakahead_y,(2+gBossConfigSpeed));
				Boss_Gob--;
				if (bossgobrot < 64)
				{
					bossgobrot+=2;
					if (bossgobrot > 64)
					{
						bossgobrot = 64;
					}
				}
				if (bossgobout > 0)
				{
					bossgobout--;
				}
				if(muakahead_y == (gBossConfig_AttackOffsetY+32) && muakahead_x == (gBossConfig_AttackOffsetX-16) && bossgobout == 0 && bossgobrot >= 48)
				{
					if (MiniMode == 0)
					{
						CameraShake = 32;
						fireball_xpos = Boss_xpos + ScaleToFit(muakahead_x+gBossScreen_OffsetX) - ScaleZeroToHalf(32) + 32;
						fireball_ypos = Boss_ypos + ScaleToFit(muakahead_y+gBossScreen_OffsetY) + ScaleZeroToHalf(gBossConfig_HeightY) - ScaleZeroToHalf(32);
						fireball_vely = -12 - (GameClock&3);
						fireball_targetx = player.xpos - 16;

						spawn(initbossfireball,0,0,0);
						Sample_Play(SMPL_LIONROAR01);
					}
					bossgobout = 30;
					if (Boss_Gob > 10)
					{
						Boss_Gob = 10;
					}
				}
			}

			if (Boss_Gob == 0)
			{
				bossgobrot -= 4;
				if (bossgobrot < 0)
				{
					bossgobrot = 0;
				}
			}
			
			if(Boss_Roar)
			{
				muakahead_x += smin(gBossConfig_AttackOffsetX + -32 - muakahead_x,(2+gBossConfigSpeed));
				muakahead_y += smin(gBossConfig_AttackOffsetY + roarpos - muakahead_y,(2+gBossConfigSpeed));
				Boss_Roar--;
				CameraShake = 64;
				if(muakahead_y == (gBossConfig_AttackOffsetY+roarpos) && muakahead_x == (gBossConfig_AttackOffsetX-32) && breathscale == 0 && (player.xpos > Boss_xpos - 240))
				{
					spawn(initbossbreath,0,0,0);
					Sample_Play(SMPL_LIONROAR01);
				}
			}
			
			if(Boss_Taunt)
			{
				muakahead_x += smin(gBossConfig_AttackOffsetX-32 - muakahead_x,4);
				muakahead_y += smin((min(32,fsin[Boss_Taunt] >> 3)) - muakahead_y,4);
				Boss_Taunt--;
			}
			
			
			if(muakagrab_y)
			{
				if(muakagrabtime > 0)
				{
					muakagrabtime--;
				}
				else
				{
					if(muakahead_x > -128)
					{
						muakahead_x -= 4;
						muakahead_y += smin(muakagrab_y - muakahead_y,4); 
					}
					else
					{
						muakagrab_y = 0;
					}
				}
			}
		}
		else
		{
			if(muakahead_x < 0)
				muakahead_x += 4;
			muakahead_y += smin(-32 - muakahead_y,(4+gBossConfigSpeed));
			
			if(muakahead_x == 0 && muakahead_y == -32 && Boss_xpos < (game_x + 240))
			{
			
				muakaseqtime--;
				if(muakaseqtime <= 0)
				{
					switch(muakasequence[muakaseqptr])
					{
						case 0: // grab
							Sample_Play(SMPL_BOSS03SERVO);

							muakagrab_y = player.ypos - Boss_ypos;
							muakagrabtime = 60;
							if(muakagrab_y == 0)
								muakagrab_y = 1;
							break;
//						case 1: // stomp
//							muakaarmslam = 1;
//							Sample_Play(SMPL_BOSS03SERVO);
//							break;
						case 1: // roar
							if (MiniMode == 0)
							{
								Boss_Roar = (64 * 2) + 120;
								Sample_Play(SMPL_LIONROAR01);
								breathscale = 0;
								roarpos = 24-gBossScreen_OffsetY;
							}
							else
							{
								Sample_Play(SMPL_BOSS03SERVO);

								muakagrab_y = player.ypos - Boss_ypos;
								muakagrabtime = 60;
								if(muakagrab_y == 0)
									muakagrab_y = 1;
							}
							break;
						case 2: // roar
							if (MiniMode == 0)
							{
								Boss_Roar = (64 * 2) + 120;
								Sample_Play(SMPL_LIONROAR01);
								breathscale = 0;
								roarpos = -24-gBossScreen_OffsetY;
							}
							else
							{
								Sample_Play(SMPL_BOSS03SERVO);

								muakagrab_y = player.ypos - Boss_ypos;
								muakagrabtime = 60;
								if(muakagrab_y == 0)
									muakagrab_y = 1;
							}
							break;
						case 3: // taunt
							Boss_Taunt = 64 * 5;
							Sample_Play(SMPL_BOSS03SERVO);
							break;
						case 4: // do nothing
							break;
						case 5: // Gob out a fireball
							if (MiniMode)
							{
								Boss_Taunt = 64 * 5;
								Sample_Play(SMPL_BOSS03SERVO);
							}
							else
							{
								Boss_Gob = 256;
								bossgobcounter = 0;
								bossgobout = 0;
								bossgobrot = 0;
								Sample_Play(SMPL_BOSS03SERVO);
							}
							break;
					}
					muakaseqptr++;
					muakaseqptr &= 15; // 16 sequence steps
					muakaseqtime = 30 * 3 - Game_Difficulty * 30;
				}
			}
		}


		if(player.xpos > Boss_xpos+ScaleToFit(gBossScreen_FeetOffsetX))
		{
// Disable for now
			player.xpos = Boss_xpos+ScaleToFit(gBossScreen_FeetOffsetX);
			HitPlayer(1);
		}
	
		sprx = Boss_xpos + ScaleToFit(muakahead_x+gBossScreen_OffsetX);
		spry = Boss_ypos + ScaleToFit(muakahead_y+gBossScreen_OffsetY) + ScaleZeroToHalf(gBossConfig_HeightY);
		if(player.xpos > (sprx) && player.ypos > (spry) && player.ypos < (spry + ScaleToFit(gBossConfig_HeightY)))
		{
// Disable for now
			HitPlayer(1);
		}

		EnemyNearX = Boss_xpos + muakahead_x+gBossScreen_OffsetX - player.xpos;
		EnemyNearY = Boss_ypos - player.ypos;

#if 1
		hit = FrisbeeHit(Boss_xpos + ScaleToFit(muakahead_x+gBossScreen_OffsetX)+ScaleToFit(16) /*- ScaleZeroToHalf(32)*/,Boss_ypos + ScaleToFit(muakahead_y+gBossScreen_OffsetY)+ScaleToFit(16) + ScaleZeroToHalf(gBossConfig_HeightY) /*- ScaleZeroToHalf(32)*/,ScaleToFit(32));
		if(hit > 0)
		{
			if (muakadropflash == 0)
			{
				if (MiniMode < 64 && MiniMode != 0)
				{
					minimodedelta = 1;
				}

				muakadropflash = 60;
				muakadrophits-= hit;
				muakahittime = 128;

				DiscRebound();
				// dink sound
				if(muakadrophits <= 0)
				{
					Sprite[mysprite].VPos = 161;
					muakahits = 0; // kill muaka
					Sample_Play(SMPL_WALL_SMASH01);
					muakadrophits = 0;
				}
			}
			else
			{
				DiscRebound();
			}
		}
#endif		
		
		
	}
	else		//From false if(muakahits > 0)...
	{
		bossgobrot = 0;
		Boss_Roar = 0;
		if(muakahead_y < 64)
		{
			muakahead_y += 8;
//			if((muakagrab_y < 8) && ((GameClock & 7) == 0))
//				muakagrab_y++;
		}
		if(muakahead_x > -64)
		{
			muakahead_x -=4;
		}
		if(muakahead_x <= -64 && muakahead_y >=64 && boss_end == 0)
		{
			if (boss_end_time == 0)
			{
				globalblend = 0;
			}
			boss_end_time++;
			if (gBossSwitchToSecond)
			{
				if (boss_end_time == 120)
				{
					gBossSwitchToSecond = 0;
					DmaCopy(3, BaragBody2Palette, BG_PLTT,16*2, 32);  //  Set BG palette
					DmaWait(3);

					InitBossVars();
				}
			}
			else
			{
				Freeze_Player = 1;
				if(boss_end_time > 120)
				{
					NextLevel = 1;
					fadeto = 0;
					boss_end = 1;
					boss_end_time = 0;
				}
			}
		}
	}

#endif // Disable boss animation for now

	// Let the game stablise for a frame first before testing for the zoom in state
	if (!commonskip)
	{
		// Do the scale to mini mode if it is set
		if(MiniMode && minimodedelta)
		{
			int tminimode;
			tminimode = MiniMode;
			tminimode += minimodedelta;
			if (tminimode < 32)
			{
				tminimode = 32;
				minimodedelta = 0;
			}
			if (tminimode > 64)
			{
				tminimode = 64;
				minimodedelta = 0;
			}
			MiniMode = tminimode;
		}

		// Make the boss screen scale in and out depending on the distance from the boss
		if (player.xpos > (Boss_xpos-96) && MiniMode < 64)
		{
			minimodedelta = 1;
		}

	//	if (player.xpos < (Boss_xpos-96) && (MiniMode == 64 || MiniMode == 0) && Boss_Roar == 0)
	//	{
	//		minimodedelta = -1;
	//	}

		if (muakahits == 0 && MiniMode < 64)
		{
			minimodedelta = 1;
		}

		if (MiniMode == 64 && minimodedelta >= 0)
		{
			int a;

			MiniMode = 0;
			minimodedelta = 0;

			Sprite[player.frame].AffineMode = 0;
			Sprite[muakahead].AffineMode = 0;
			Sprite[muakahead2].AffineMode = 0;
			Sprite[muakajaw].AffineMode = 0;
			Sprite[muakashoulder].AffineMode = 0;
			for(a = 0; a < 4; a++)
			{
				Sprite[muakaneck[a]].AffineMode = 0;
			}
		}
	}

	if (commonskip)
	{
		commonskip = 0;
	}

	if (MiniMode == 0 && minimodedelta < 0)
	{
		MiniMode = 64;
	}


	LoadPalette(MuakaHeadPalette,5);
	if(muakadropflash > 0)
	{
		if((GameClock & 8))
		{
			LoadPalette(VFlashPalette,5);
		}
		muakadropflash--;
	}		


	temprot = bossgobrot;

	if (bossgobrot > 0)
	{
		int aff;

		// Use affine 5
		SpriteRotate(5,0/*bossgobrot*/);
		SpriteRotate(5,temprot);

		aff = 5 << 2;		// Affine 5

		Sprite[aff].AffineParam -= ScaleZeroToHalf(Sprite[aff].AffineParam);
		Sprite[aff + 1].AffineParam -= ScaleZeroToHalf(Sprite[aff + 1].AffineParam);
		Sprite[aff + 2].AffineParam -= ScaleZeroToHalf(Sprite[aff + 2].AffineParam);
		Sprite[aff + 3].AffineParam -= ScaleZeroToHalf(Sprite[aff + 3].AffineParam);


//		if (cycleon)
//		{
//			temprot++;
//			temprot &= 63;
//		}


		Sprite[muakahead].AffineMode = 3;
		Sprite[muakahead].AffineParamNo_L = 5;
		Sprite[muakahead].HPos = Sprite[muakahead].HPos + ScaleToFit(- ((ScaleToFit(32)*fsin[(temprot+64)&255])/256) - ((ScaleToFit(16)*fsin[(temprot+00)&255])/256));
		Sprite[muakahead].VPos = Sprite[muakahead].VPos + ScaleToFit(- ScaleToFit(32) - ((ScaleToFit(32)*fsin[(temprot+00)&255])/256) - ((ScaleToFit(16)*fsin[(temprot+00)&255])/256));

		Sprite[muakajaw].AffineMode = 3;
		Sprite[muakajaw].AffineParamNo_L = 5;

		Sprite[muakajaw].HPos = Sprite[muakajaw].HPos + ScaleToFit(- ((ScaleToFit(32)*fsin[(temprot+64)&255])/256) - ((ScaleToFit(48)*fsin[(temprot+00)&255])/256));
		Sprite[muakajaw].VPos = Sprite[muakajaw].VPos + ScaleToFit(- 32 - ((ScaleToFit(32)*fsin[(temprot+00)&255])/256) - ((ScaleToFit(32)*fsin[(temprot+00)&255])/256));
	}
	else
	{
		Sprite[muakahead].AffineMode = 0;
		Sprite[muakajaw].AffineMode = 0;
	}

	CommonBossPostInitAlways();
}

int vblank_bossy;
int triggervalue;

void CommomBossBeforeRefreshInit(void)
{
	bossonscreentick = 0;
	Boss_ypos = 0;
	Boss_xpos = 0;
	vblank_bossy = 160;
	triggervalue = 160;

	MaxEnemyPals = 3;
	MiniMode = 32;
	minimodedelta = 0;
	ForegroundMode = 3;

	commonskip = 1;
}

void CommonBossInit(void)
{
	bossonscreentick = 0;
	ArgoVBlank();
	*(vu16 *)REG_DISPCNT = DISP_MODE_1;


	muakagrab_y =0;
	muakaarmslam =0;
	Boss_armlift =0;
	Boss_Roar =0;
	Boss_Taunt =0;
	Boss_Gob =0;
	bossgobrot = 0;

	Screen0(0);
	Screen1(0);
	Screen2(0);
	Screen3(0);
}

void CommonBossPostInitAlways(void)
{
	*(vu16 *)REG_BG1CNT =							 // Set BG control for BG 1
		BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_0
		| 1 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;

	DmaCopy(3, BossLifeBarChar, BG_VRAM + 0x4000 + ((8*8)/2),((8*8)/2)*3, 32);  //  Set BG character
	DmaWait(3);
	DmaClear(3, 0, (BG_VRAM + 0x4000),(8*8)/2,32);
	DmaWait(3);
	DmaCopy(3, BossLifeBarPalette, BG_PLTT+((16*2)*2),16*2, 32);  //  Set BG palette
	DmaWait(3);
}

void CommonBossPostInit(void)
{
	ArgoVBlank();

	// Turn on two normal screens and one scale screen
	*(vu16 *)REG_DISPCNT = DISP_MODE_1 | DISP_OBJ_ON | DISP_OBJ_CHAR_1D_MAP; // LCDC ON

	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2CNT) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2HOFS) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2VOFS) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PA) = 1<<8;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PB) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PC) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PD) = 1<<8;
	*(vu32 *)(REG_DISPCNT+OFFSET_REG_BG2X) = 0;
	*(vu32 *)(REG_DISPCNT+OFFSET_REG_BG2Y) = 0;

	// BG2CNT is set by the Boss VBlankBoss function

	*(vu16 *)REG_BG2CNT = BG_COLOR_256 | BG_SCREEN_SIZE_2 | BG_PRIORITY_2
		| 2 << BG_SCREEN_BASE_SHIFT | 3 << BG_CHAR_BASE_SHIFT;

	*(vu16 *)REG_BG0CNT =							 // Set BG control for BG 1
		BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_3
		| 0 << BG_SCREEN_BASE_SHIFT | 2 << BG_CHAR_BASE_SHIFT ;

	CommonBossPostInitAlways();
//	DmaClear(3, 1 | 0x2000, (BG_VRAM + 0x0800),0x0800,32);
	DmaClear(3, 0, (BG_VRAM + 0x0800),0x0800,32);
	DmaWait(3);
}

/* Sepecific boss routines here */

void refreshmuakoboss(void)
{
	CommonBossInit();

	DmaCompressedCopy(3, muakabdChar, BG_VRAM + 0x8000, 32);  //  Set BG character
	DmaWait(3);

	DmaCompressedCopy(3,MuakaBodyChar,(u32)(BG_VRAM + 0xc000),32);
	DmaWait(3);
	DmaArrayCopy(3,MuakaBodyPalette,BG_PLTT,32);
	DmaWait(3);
	DmaClear(3,0,BG_VRAM + 0x1000,(64 * 64),32);
	DmaWait(3);
 	DmaArrayCopy(3,MuakaBodyMap,(u32)(BG_VRAM + 0x1000),32);
	DmaWait(3);

	DmaArrayCopy(3, muakabdPalette, BG_PLTT,		32);  //  Set BG palette
	DmaWait(3);
	DmaArrayCopy(3, muakabdMap,(BG_VRAM + 0x000),32);
	DmaWait(3);

	LoadSprite((u32)MuakaHeadSprite,(u32)BOSS_SPRITE1_OFFSET,(BOSS_SPRITE1_SIZE * 2));
	LoadSprite((u32)MuakaHead2Sprite,(u32)BOSS_SPRITE2_OFFSET,(BOSS_SPRITE2_SIZE));
	LoadSprite((u32)MuakaShoulderSprite,(u32)(BOSS_SPRITE1_OFFSET + BOSS_SPRITE1_SIZE * 2),BOSS_SPRITE1_SIZE);
	LoadSprite((u32)MuakaNeckSprite,(u32)(BOSS_SPRITE1_OFFSET + BOSS_SPRITE1_SIZE * 3),BOSS_SPRITE1_SIZE);

   	LoadPalette(MuakaHeadPalette,5);
   	LoadPalette(MuakaNeckPalette,6);

	CommonBossPostInit();
}

void initmuakoboss(void)
{
	CommomBossBeforeRefreshInit();

	gBossConfig_HeightY = 96;
	gBossScreen_OffsetX = -24;
	gBossScreen_OffsetY = 16;
	gBossScreen_MasterY = 0;
	gBossScreen_StartX = 185;
	gBossScreen_FeetOffsetX = -16;
	gBossConfig_AttackOffsetX = 0;
	gBossConfig_AttackOffsetY = 0;
	gBossSwitchToSecond = 0;
	gBossConfigSpeed = 0;
	gBossLifeAdd = 0;

	InitGenericBoss();
}



void refreshrahiboss(void)
{
	CommonBossInit();

	DmaCompressedCopy(3,RahiBodyChar,(u32)(BG_VRAM + 0xc000),32);
	DmaWait(3);
	DmaArrayCopy(3,RahiBodyPalette,BG_PLTT,32);
	DmaWait(3);
	DmaClear(3,0,BG_VRAM + 1 * 2048,(32 * 32 * 4),32);
	DmaWait(3);
	DmaArrayCopy(3,RahiBodyMap,(u32)(BG_VRAM + 0x1000),32);
	DmaWait(3);

	DmaCompressedCopy(3, boss2bdChar, BG_VRAM + 0x8000, 32);  //  Set BG character
	DmaWait(3);
	DmaCopy(3, boss2bdPalette+16, BG_PLTT+(16*2),16*2, 32);  //  Set BG palette
	DmaWait(3);
	((u16*)PLTT)[0]=boss3bdPalette[16];
	DmaArrayCopy(3, boss2bdMap,(BG_VRAM + 0x000),32);
	DmaWait(3);

	LoadSprite((u32)MuakaHeadSprite,(u32)BOSS_SPRITE1_OFFSET,(BOSS_SPRITE1_SIZE * 2));
	LoadSprite((u32)MuakaHead2Sprite,(u32)BOSS_SPRITE2_OFFSET,(BOSS_SPRITE2_SIZE));
	LoadSprite((u32)MuakaShoulderSprite,(u32)(BOSS_SPRITE1_OFFSET + BOSS_SPRITE1_SIZE * 2),BOSS_SPRITE1_SIZE);
	LoadSprite((u32)MuakaNeckSprite,(u32)(BOSS_SPRITE1_OFFSET + BOSS_SPRITE1_SIZE * 3),BOSS_SPRITE1_SIZE);

   	LoadPalette(MuakaHeadPalette,5);
   	LoadPalette(MuakaNeckPalette,6);

	CommonBossPostInit();
}

void initrahiboss(void)
{
	CommomBossBeforeRefreshInit();

	gBossConfig_HeightY = 96;
	gBossScreen_OffsetX = 0;
	gBossScreen_OffsetY = 0;
	gBossScreen_MasterY = -64;
	gBossScreen_StartX = 256-96;
	gBossScreen_FeetOffsetX = 16;
	gBossConfig_AttackOffsetX = -32;
	gBossConfig_AttackOffsetY = 64;
	gBossSwitchToSecond = 0;
	gBossConfigSpeed = 1;
	gBossLifeAdd = 2;

	InitGenericBoss();
}



void refreshbaragboss(void)
{
	CommonBossInit();

	DmaCompressedCopy(3, boss3bdChar, BG_VRAM + 0x8000, 32);  //  Set BG character
	DmaWait(3);

	DmaCompressedCopy(3,BaragBodyChar,(u32)(BG_VRAM + 0xc000),32);
	DmaWait(3);
	DmaArrayCopy(3,BaragBodyPalette,BG_PLTT,32);
	DmaWait(3);
	DmaClear(3,0,BG_VRAM + 0x1000,(64 * 64),32);
	DmaWait(3);
 	DmaArrayCopy(3,BaragBodyMap,(u32)(BG_VRAM + 0x1000),32);
	DmaWait(3);

	DmaCopy(3, boss3bdPalette+16, BG_PLTT+(16*2),16*2, 32);  //  Set BG palette
	DmaWait(3);
	((u16*)PLTT)[0]=boss3bdPalette[16];
	DmaArrayCopy(3, boss3bdMap,(BG_VRAM + 0x000),32);
	DmaWait(3);

	LoadSprite((u32)MuakaHeadSprite,(u32)BOSS_SPRITE1_OFFSET,(BOSS_SPRITE1_SIZE * 2));
	LoadSprite((u32)MuakaHead2Sprite,(u32)BOSS_SPRITE2_OFFSET,(BOSS_SPRITE2_SIZE));
	LoadSprite((u32)MuakaShoulderSprite,(u32)(BOSS_SPRITE1_OFFSET + BOSS_SPRITE1_SIZE * 2),BOSS_SPRITE1_SIZE);
	LoadSprite((u32)MuakaNeckSprite,(u32)(BOSS_SPRITE1_OFFSET + BOSS_SPRITE1_SIZE * 3),BOSS_SPRITE1_SIZE);

   	LoadPalette(MuakaHeadPalette,5);
   	LoadPalette(MuakaNeckPalette,6);

	CommonBossPostInit();
}

void initbaragboss(void)
{
	CommomBossBeforeRefreshInit();

	gBossConfig_HeightY = 96;
	gBossScreen_OffsetX = 16;
	gBossScreen_OffsetY = 48;
	gBossScreen_MasterY = -80;
	gBossScreen_StartX = 160;
	gBossScreen_FeetOffsetX = 16;
	gBossConfig_AttackOffsetX = -32;
	gBossConfig_AttackOffsetY = 72;
	gBossSwitchToSecond = 1;
	gBossConfigSpeed = 2;
	gBossLifeAdd = 4;

	InitGenericBoss();
}



void refreshbaragboss2(void)
{
}

void initbaragboss2(void)
{
}


// Layer stuff
void VBlankBoss(void)
{
	s16 sprx,spry;

	if (Game_Level == 1 || Game_Level == 2)
	{
		if ( ((GameClock + rndfast(1023))&1023) <= 31 && ((u16*)PLTT)[0]!=0x7fff)
		{
			((u16*)PLTT)[0]=0x7fff;
		}
		else
		{
			((u16*)PLTT)[0]=0x664d;
		}
	}

	if (gBossSwitchToSecond && boss_end_time > 80)
	{
		*(vu16 *)REG_BLDCNT =  BLD_UP_MODE |  BLD_1ST_ALL;
		*(vu16 *)REG_BLDY = globalblend;
		globalblend += GameClock & 1;
		if (globalblend > 15)
		{
			globalblend = 15;
		}
	}

	if (!gBossSwitchToSecond && globalblend > 0)
	{
		globalblend -= GameClock & 1;
		*(vu16 *)REG_BLDCNT =  BLD_UP_MODE |  BLD_1ST_ALL;
		*(vu16 *)REG_BLDY = globalblend;
	}


	vblank_bossy = game_y;

	if (Boss_ypos > 0)
	{
		triggervalue = Boss_ypos + ScaleZeroToHalf(gBossConfig_HeightY) + 16;
	}

	sprx = game_x - Boss_xpos;
	spry = game_y - Boss_ypos;

	if(MiniMode)
	{	
		*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PA) = (1<<8) + ((((64 - MiniMode))*8));
		*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PD) = (1<<8) + ((((64 - MiniMode))*8));

//		*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PA) = 1<<9;
//		*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PD) = 1<<9;

		*(vu32 *)(REG_DISPCNT+OFFSET_REG_BG2X) = (sprx * 256) + (((sprx * 256) * (64-MiniMode)) / 32);
		*(vu32 *)(REG_DISPCNT+OFFSET_REG_BG2Y) = (spry * 256) + (((spry * 256) * (64-MiniMode)) / 32) - (((gBossConfig_HeightY*256) * (64-MiniMode))/32); // minus height of the boss
	}
	else
	{
		*(vu32 *)(REG_DISPCNT+OFFSET_REG_BG2X) = sprx * 256;
		*(vu32 *)(REG_DISPCNT+OFFSET_REG_BG2Y) = spry * 256;
	}

	*(vu16 *)REG_BG2CNT = BG_COLOR_256 | BG_SCREEN_SIZE_2 | BG_PRIORITY_2
			| 2 << BG_SCREEN_BASE_SHIFT | 3 << BG_CHAR_BASE_SHIFT;


//	*(vu16 *)REG_BG2VOFS = spry;
//	*(vu16 *)REG_BG2HOFS = sprx;
}

void HBlankBoss1(void) // H blank routine for boss 1 (muaka)
{
	u16 line;

	line = *(vu16 *)REG_VCOUNT; 

//	if(line < 160)
//	{
//		*(vu16 *)BG_PLTT = muakabdrainbowPalette[line];
//	}

	if (Boss_ypos > 0)
	{
		if ( (vblank_bossy + line) >= triggervalue && line < 160)
		{
			*(vu16 *)REG_BG2CNT |= BG_LOOP_ON;
		}

		if (line == 160)
		{
			*(vu16 *)REG_BG2CNT &= ~BG_LOOP_ON;
		}
	}
	else
	{
		*(vu16 *)REG_BG2CNT &= ~BG_LOOP_ON;
	}

	*(vu16 *)REG_IF	= H_BLANK_INTR_FLAG;
}
