/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
//#include "data.h"
#include "player.h"
#include "powerups.h"
#include "main.h"
#include "particles.h"
#include "cplayer.h"
#include "vplayer.h"
#include "pebble.h"
#include "masksprites.h"
#include "epower.h"
#include "SampleManager.h"
#include "mask.h"

#include "BlueMaskBK.h"
#include "BrownMaskBK.h"
#include "GreyMaskBK.h"
#include "PurpleMaskBK.h"
#include "TourquoiseMaskBK.h"
#include "YellowMaskBK.h"

powerupparms powerup[32];
u8 chiefs;


s8 balletx;
s8 balletdx;
u8 PickupItemsThisLevel;

u8 BonusMasks;
u32  BonusMask;
u32  BonusMaskPalette;
const u32 PickupItemSprite[6] = {(u32)SongSprite,(u32)StatueSprite,(u32)SongSprite,(u32)ProtodermisSprite,(u32)PebbleSprite,(u32)TorchSprite};
const u32 PickupItemPalette[6] = {(u32)SongPalette,(u32)StatuePalette,(u32)SongPalette,(u32)ProtodermisPalette,(u32)PebblePalette,(u32)TorchPalette};
const u8 BonusMaskFlag[4] = {1,2,4,8};
extern s16 game_x;
extern s16 game_y;
extern u8 SpriteBankTemp;

void HandlePowerupHealth(void);
void HandlePowerupEPower(void);
void HandlePowerupLives(void);
void HandlePickupItem(void);
void HandleFriends(void);
void HandlePowerupDisc(void);

u8 NextPowerUp(void)
{
	u8 a;
	for(a = 0; a < 32; a++)
	{
		if(powerup[a].xpos == 0)
			return a;
	}
	return 0;
}

void RemovePowerup(void)
{
	u8 me;
	me = Object[current_strat].parameter;
	powerup[me].xpos = 0;

}

void initpoweruphealth(void)
{
	u32 i;
	u8 me;
	
	me = NextPowerUp();
	powerup[me].frame = GrabASprite();
	Object[num_strats].handle = HandlePowerupHealth;
	Object[num_strats].remover = RemovePowerup;
	
	i = powerup[me].frame;
      	Sprite[i].CharNo = PUP_HEALTH_SPRITE;
       	Sprite[i].Shape = 0;
   		Sprite[i].Size = 2; //OAM_SIZE_32x32;
   		Sprite[i].Pltt = 10;
         Sprite[i].Priority = 2;
        powerup[me].xpos = parm_xpos;
        powerup[me].ypos = parm_ypos;
        powerup[me].cycle = 0;
        powerup[me].delay = 15;
        powerup[me].bob = 0;
 	Object[num_strats].parameter = me;
	LoadSprite((u32)pickup2Sprite,PUP_HEALTH_SPRITE_OFFSET,PUP_HEALTH_SPRITE_SIZE);


}

void initpowerupdisc(void)
{
	u32 i;
	u8 me;
	
	me = NextPowerUp();
	powerup[me].frame = GrabASprite();
	Object[num_strats].handle = HandlePowerupDisc;
	Object[num_strats].remover = RemovePowerup;
	
	i = powerup[me].frame;
      	Sprite[i].CharNo = PUP_DISC_SPRITE;
       	Sprite[i].Shape = 0;
   		Sprite[i].Size = 2; //OAM_SIZE_32x32;
   		Sprite[i].Pltt = 10;
         Sprite[i].Priority = 2;
        powerup[me].xpos = parm_xpos;
        powerup[me].ypos = parm_ypos;
        powerup[me].cycle = 0;
        powerup[me].delay = 15;
        powerup[me].bob = 0;
 	Object[num_strats].parameter = me;

	LoadSprite((u32)pickup4Sprite ,PUP_DISC_SPRITE_OFFSET,PUP_DISC_SPRITE_SIZE);

}


void initpowerupepower(void)
{
	u32 i;
	u8 me;
	
	me = NextPowerUp();
	powerup[me].frame = GrabASprite();
	Object[num_strats].handle = HandlePowerupEPower;
	Object[num_strats].remover = RemovePowerup;
	i = powerup[me].frame;
      	Sprite[i].CharNo = PUP_EPOWER_SPRITE;
       	Sprite[i].Shape = 0;
   		Sprite[i].Size = 2; //OAM_SIZE_32x32;
   		Sprite[i].Pltt = 10;
         Sprite[i].Priority = 2;
        powerup[me].xpos = parm_xpos;
        powerup[me].ypos = parm_ypos;
        powerup[me].cycle = 0;
        powerup[me].delay = 7;
        powerup[me].bob = 3;


 	Object[num_strats].parameter = me;

	LoadSprite((u32)pickup1Sprite,PUP_EPOWER_SPRITE_OFFSET,PUP_EPOWER_SPRITE_SIZE);

}

void initpoweruplife(void)
{
	u32 i;
	u8 me;
	
	me = NextPowerUp();
	powerup[me].frame = GrabASprite();
	Object[num_strats].handle = HandlePowerupLives;
	Object[num_strats].remover = RemovePowerup;
	i = powerup[me].frame;
      	Sprite[i].CharNo = PUP_LIFE_SPRITE;
       	Sprite[i].Shape = 0;
   		Sprite[i].Size = 2; //OAM_SIZE_32x32;
   		Sprite[i].Pltt = 10;
         Sprite[i].Priority = 2;
        powerup[me].xpos = parm_xpos;
        powerup[me].ypos = parm_ypos;
        powerup[me].cycle = 0;
        powerup[me].delay = 5;
        powerup[me].bob = 6;

	LoadSprite((u32)pickup3Sprite,PUP_LIFE_SPRITE_OFFSET,(PUP_LIFE_SPRITE_SIZE * 1));

 	Object[num_strats].parameter = me;
}

void initpowerupchief(void)
{
	u32 i;
	u8 me;
	
	me = NextPowerUp();
	powerup[me].frame = player.spare;
	Object[num_strats].handle = HandlePowerupChief;
	Object[num_strats].remover = RemovePowerup;
	i = powerup[me].frame;
      	Sprite[i].CharNo = PLAYER2_SPRITE;
       	Sprite[i].Shape = 0;
   		Sprite[i].Size = 3; //OAM_SIZE_64x64;
   		Sprite[i].Pltt = 1;
         Sprite[i].Priority = 2;
        powerup[me].xpos = parm_xpos;
        powerup[me].ypos = parm_ypos;
        powerup[me].cycle = 0;
        powerup[me].delay = 8;


 	Object[num_strats].parameter = me;
	LoadPalette(CSpecialPalette[Game_Area],1);

	chiefs++;
	

}

void initfriends(void)
{
	u32 i;
	u8 me;
	
	me = NextPowerUp();
	powerup[me].frame = GrabASprite();
	Object[num_strats].handle = HandleFriends;
	Object[num_strats].remover = RemovePowerup;
	i = powerup[me].frame;
      	Sprite[i].CharNo = PLAYER2_SPRITE;
       	Sprite[i].Shape = 0;
   		Sprite[i].Size = 3; //OAM_SIZE_64x64;
   		Sprite[i].Pltt = 1;
         Sprite[i].Priority = 2;
        powerup[me].xpos = parm_xpos;
        powerup[me].ypos = parm_ypos;
        powerup[me].cycle = 0;
        powerup[me].delay = 8;


 	Object[num_strats].parameter = me;
	LoadPalette(CSpecialPalette[Game_Area],1);

	balletdx = 1;
	balletx = 0;

}


void initbonusmask(void)
{
	u32 i;
	u8 me;
	u8 a,b,x,y;
	u32 * tptr;
	
	
	me = NextPowerUp();
	powerup[me].frame = GrabASprite();
	Object[num_strats].handle = HandleBonusMask;
	Object[num_strats].remover = RemovePowerup;
	i = powerup[me].frame;
      	Sprite[i].CharNo = BOSS_SPRITE2;
       	Sprite[i].Shape = 0;
   		Sprite[i].Size = 2; // 32 x 32;
   		Sprite[i].Pltt = 2;
         Sprite[i].Priority = 2;
        powerup[me].xpos = parm_xpos;
        powerup[me].ypos = parm_ypos;
        powerup[me].cycle = Object[num_strats].parameter;
        powerup[me].delay = 0;

 	Object[num_strats].parameter = me;
 	
	switch(gamemasknum[Game_Area + 1])
	{
		case 0:
			BonusMask = (u32)YellowMaskBKSprite;
			BonusMaskPalette = (u32)YellowMaskBKPalette;
			break;
		case 1:
			BonusMask = (u32)GreyMaskBKSprite;
			BonusMaskPalette = (u32)GreyMaskBKPalette;
			break;
		case 2:
			BonusMask = (u32)TourquoiseMaskBKSprite;
			BonusMaskPalette = (u32)TourquoiseMaskBKPalette;
			break;
		case 3:
			BonusMask = (u32)BlueMaskBKSprite;
			BonusMaskPalette = (u32)BlueMaskBKPalette;
			break;
		case 4:
			BonusMask = (u32)BrownMaskBKSprite;
			BonusMaskPalette = (u32)BrownMaskBKPalette;
			break;
		case 5:
			BonusMask = (u32)PurpleMaskBKSprite;
			BonusMaskPalette = (u32)PurpleMaskBKPalette;
			break;
	}


}


void HandlePowerupHealth(void)
{
	u8 me;
	u8 a;
	s16 sprx,spry;
	me = Object[current_strat].parameter;

	mysprite = powerup[me].frame;
	if(abs(game_x - powerup[me].xpos) > 400)
	{
		Sprite[mysprite].VPos = 160;
		return;
	}

	sprx = powerup[me].xpos -16 - game_x;
	spry = powerup[me].ypos - 16 - game_y + bobtable[powerup[me].bob] * 2;
	if(sprx >= -32 && sprx < 240 && spry >= -32 && spry <= 160)
	{



      	Sprite[mysprite].CharNo = PUP_HEALTH_SPRITE;
       	Sprite[mysprite].Shape = 0;
   		Sprite[mysprite].Size = 2; //OAM_SIZE_32x32;
   		Sprite[mysprite].Pltt = 10;
         Sprite[mysprite].Priority = 2;
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		powerup[me].bob = (powerup[me].bob + 1) & 31;
		
		// cycle it	
		powerup[me].delay--;
		if(powerup[me].delay == 0)
		{
			powerup[me].delay = 15;
			powerup[me].cycle = 1 - powerup[me].cycle;
			LoadSprite((u32)pickup2Sprite + powerup[me].cycle * PUP_HEALTH_SPRITE_SIZE,PUP_HEALTH_SPRITE_OFFSET,PUP_HEALTH_SPRITE_SIZE);
		}
		if(abs(player.xpos - powerup[me].xpos) < 32 && abs(player.ypos - powerup[me].ypos) < 32)
		{
			if(player.health < 5)
			{
				player.health = min(5,player.health + 1);
				Sprite[mysprite].VPos = 161; // zap the sprite and return it to the pool
			SpawnParticleRing(powerup[me].xpos,powerup[me].ypos,4,4,4);
				Sample_Play(SMPL_DISC_DEFLECT01);
				
				remove();
			}
		}
	}
	else
	{
		Sprite[mysprite].VPos = 160;
	}
}

void HandlePowerupDisc(void)
{
	u8 me;
	u8 a;
	u8 pup;
	s16 sprx,spry;
	
	me = Object[current_strat].parameter;
	mysprite = powerup[me].frame;
	if(abs(game_x - powerup[me].xpos) > 400)
	{
		Sprite[mysprite].VPos = 160;
		return;
	
	}
	sprx = powerup[me].xpos -16 - game_x;
	spry = powerup[me].ypos - 16 - game_y + bobtable[powerup[me].bob] * 2;
	if(sprx >= -32 && sprx < 240 && spry >= -32 && spry <= 160)
	{



		Sprite[mysprite].CharNo = PUP_DISC_SPRITE; // + powerup[me].cycle * 16;
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		powerup[me].bob = (powerup[me].bob + 1) & 31;
		
		// cycle it	
		powerup[me].delay--;
		if(powerup[me].delay == 0)
		{
			powerup[me].delay = 15;
			powerup[me].cycle = (powerup[me].cycle + 1) & 3;
			LoadSprite((u32)pickup4Sprite + powerup[me].cycle * PUP_DISC_SPRITE_SIZE,PUP_DISC_SPRITE_OFFSET,PUP_DISC_SPRITE_SIZE);
		}
		if(abs(player.xpos - powerup[me].xpos) < 32 && abs(player.ypos - powerup[me].ypos) < 32)
		{
			
			//pup = 1 + player.elemental_power; // size of effect is based on player's elemental power level
			if(Frisbee_Power < 4) // pup
			{
				Sprite[mysprite].VPos = 161; // zap the sprite and return it to the pool
				SpawnParticleRing(powerup[me].xpos,powerup[me].ypos,4,4,4);
				Frisbee_Power++;
				spawn(initplayerpower,0,0,Sprite[player.frame].HFlip);
				Sample_Play(SMPL_DISC_DEFLECT01);
				respawnme();
				remove();
			}
		}
	}
	else
	{
		Sprite[mysprite].VPos = 160;
	}
}

void HandlePowerupEPower(void)
{
	u8 me;
	s16 sprx,spry;
	u8 a;
	
	me = Object[current_strat].parameter;
	mysprite = powerup[me].frame;
	if(abs(game_x - powerup[me].xpos) > 400)
	{
		Sprite[mysprite].VPos = 160;
		return;
	
	}
	sprx = powerup[me].xpos -16 - game_x;
	spry = powerup[me].ypos - 16 - game_y + bobtable[powerup[me].bob] * 2;
	if(sprx >= -32 && sprx < 240 && spry >= -32 && spry <= 160)
	{
		
		
		Sprite[mysprite].CharNo = PUP_EPOWER_SPRITE; // + powerup[me].cycle * 16;
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		powerup[me].bob = (powerup[me].bob + 1) & 31;
		LoadEnemyPalette(pickup1Palette,nxtenemypal);
   		Sprite[mysprite].Pltt = 2 + PalCache;
		// cycle it	
		powerup[me].delay--;
		if(powerup[me].delay == 0)
		{
			powerup[me].delay = 7;
			powerup[me].cycle++;
			if(powerup[me].cycle > 3)
				powerup[me].cycle = 0;
			LoadSprite((u32)pickup1Sprite + powerup[me].cycle * PUP_EPOWER_SPRITE_SIZE,PUP_EPOWER_SPRITE_OFFSET,PUP_EPOWER_SPRITE_SIZE);
		}
		// check for pickup...
		
		if(abs(player.xpos - powerup[me].xpos) < 32 && abs(player.ypos - powerup[me].ypos) < 32)
		{
			if(player.elemental_power < 3)
			{
				player.elemental_power = min(3,player.elemental_power + 1);
				Sprite[mysprite].VPos = 161; // zap the sprite and return it to the pool
				SpawnParticleRing(powerup[me].xpos,powerup[me].ypos,4,4,3);
				Sample_Play(SMPL_DISC_DEFLECT01);
				remove();
			}
		}
	}
	else
	{
		Sprite[mysprite].VPos = 160;
	}
}

void HandlePowerupLives(void)
{
	u8 me;
	u8 a;
	s16 sprx,spry;
	me = Object[current_strat].parameter;
	mysprite = powerup[me].frame;
	if(abs(game_x - powerup[me].xpos) > 400)
	{
		Sprite[mysprite].VPos = 160;
		return;
	
	}
	sprx = powerup[me].xpos -16 - game_x;
	spry = powerup[me].ypos - 16 - game_y + bobtable[powerup[me].bob] * 2;
	if(sprx >= -32 && sprx < 240 && spry >= -32 && spry <= 160)
	{
		
		
		Sprite[mysprite].CharNo = PUP_LIFE_SPRITE;
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		powerup[me].bob = (powerup[me].bob + 1) & 31;
		
		powerup[me].cycle = (powerup[me].cycle + 4) & 255;
			
		// cycle it	
		powerup[me].delay--;
		if(powerup[me].delay == 0)
		{
			powerup[me].delay = 5;
			spawnparticle(powerup[me].xpos + 16 + (fsin[powerup[me].cycle] >> 5),powerup[me].ypos + 12 + (fsin[(powerup[me].cycle * 2) & 255] >> 5),0,0,0,0,16,0,0);
		}
		// check for pickup...
		
		if(abs(player.xpos - powerup[me].xpos) < 32 && abs(player.ypos - powerup[me].ypos) < 32)
		{
			if(player.lives < 9)
			{
				player.lives = min(9,player.lives + 1);
				Sprite[mysprite].VPos = 161; // zap the sprite and return it to the pool
				SpawnParticleRing(powerup[me].xpos,powerup[me].ypos,4,4,2);
				Sample_Play(SMPL_DISC_DEFLECT01);
				remove();
			}
		}
	}
	else
	{
		Sprite[mysprite].VPos = 160;
	}
}

void HandlePowerupChief(void)
{
	u8 me;
	s16 sprx,spry;
	u8 a;
	
	me = Object[current_strat].parameter;
	mysprite = powerup[me].frame;
	if(abs(game_x - powerup[me].xpos) > 400)
	{
		Sprite[mysprite].VPos = 160;
		return;
	
	}
	sprx = powerup[me].xpos - game_x - 32;
	spry = powerup[me].ypos - game_y - 48;
	if(sprx >= -32 && sprx < 240 && spry >= -32 && spry <= 160)
	{
		
		spritesource[PLAYER_SPARE] = SpriteBase[1][SPRITE_IDLE];// + (powerup[me].cycle << 11);
		
	//	if(spritesource[PLAYER_SPARE] != lastsparesprite)
			LoadSprite(spritesource[PLAYER_SPARE],PLAYER2_SPRITE_OFFSET,PLAYER_SPRITE_SIZE);
		lastsparesprite = spritesource[PLAYER_SPARE];
		
		Sprite[player.spare].HPos = sprx  & 511;
		Sprite[player.spare].VPos = (spry + 256) & 255;
		Sprite[player.spare].CharNo = PLAYER2_SPRITE; //SpriteSeq[currsprite];
		Sprite[player.spare].HFlip = 0;




		// cycle it	
		powerup[me].delay--;
		if(powerup[me].delay == 0)
		{
			powerup[me].delay = 8;
			powerup[me].cycle++;
			if(powerup[me].cycle > 8)
				powerup[me].cycle = 0;
		}
		// check for pickup...
		
		if(abs(player.xpos - powerup[me].xpos) < 32 && abs(player.ypos - powerup[me].ypos) < 32)
		{
			if((player.ActionFlags & ACTION_HASOTHER) == 0)
			{
				player.ActionFlags |= ACTION_HASOTHER;
				SpawnParticleRing(powerup[me].xpos,powerup[me].ypos,4,4,1);
				// reset the other character too
				for(a = 0; a < 16; a++)
				{
					chasex[a] = powerup[me].xpos;
					chasey[a] = powerup[me].ypos;
				}
				Sample_Play(SMPL_DISC_DEFLECT01);

				remove();
			}
		}
	}
	else
	{
		Sprite[mysprite].VPos = 160;
	}
}


void HandleFriends(void)
{
	
	u8 me;
	s16 sprx,spry;
	u8 a;
	u32 sprptr;
	
	me = Object[current_strat].parameter;
	mysprite = powerup[me].frame;
	
	if(me == 0)
	{
	//	balletx += balletdx;
		
	//	if(balletx < -32)
	//		balletdx = 1;
	//	if(balletx > 32)
	//		balletdx = -1;
	}
	
	powerup[me].ypos = ForceOtherCollision(powerup[me].xpos,powerup[me].ypos);
	sprx = powerup[me].xpos - game_x - 32 + balletx;
	spry = powerup[me].ypos - game_y - 48;
	if(sprx >= -64 && sprx < 240 && spry >= -64 && spry <= 160)
	{
		a = 0;
		if(me == Game_Character)
		{
			a = 1;
		}
		if(powerup[me].delay == 0)
			sprptr = SpriteBase[a][SPRITE_IDLE];
		else
			sprptr = SpriteBase[a][SPRITE_JUMP] + (powerup[me].cycle << 11);
		
	//	if(spritesource[PLAYER_SPARE] != lastsparesprite)
		lastsparesprite = spritesource[PLAYER_SPARE];


		LoadSprite(sprptr, PLAYER_SPRITE + me * PLAYER_SPRITE_SIZE + PLAYER_SPRITE_SIZE, PLAYER_SPRITE_SIZE);
		if(a == 0)
		{
			LoadPalette(VSpecialPalette[me],(me + 1));
   		}
   		else
   		{
   			LoadPalette(CSpecialPalette[me],(me + 1));
   		}
   		Sprite[mysprite].Pltt = me + 1;
		
		Sprite[mysprite].HPos = sprx  & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		Sprite[mysprite].CharNo = me * 64 + 64;
		Sprite[mysprite].HFlip = 0;



		if(powerup[me].delay == 0)
		{
			if(rndfast(511) < 2)
			{
				powerup[me].delay = 8;
				powerup[me].cycle = 0;
			}	
		}
		else
		{
		// cycle it	
			powerup[me].delay--;
			if(powerup[me].delay == 0)
			{
				powerup[me].delay = 8;
				powerup[me].cycle++;
				if(powerup[me].cycle > 4)
				{
					powerup[me].cycle = 0;
					powerup[me].delay = 0;
				}
			}
		}
	}
	else
	{
		Sprite[mysprite].VPos = 160;
	}
}


void initpickupitem(void)
{
	u32 i;
	u8 me;
	
	me = NextPowerUp();
//	powerup[me].frame = GrabASprite();
	Object[num_strats].handle = HandlePickupItem;
	Object[num_strats].remover = RemovePowerup;
        powerup[me].xpos = parm_xpos;
        powerup[me].ypos = parm_ypos;
        powerup[me].cycle = 0;
        powerup[me].delay = 8;
        powerup[me].grabbed = 0;
        powerup[me].slot = PickupItemsThisLevel * 16;
        PickupItemsThisLevel++;
        if(Object[num_strats].parameter > 0)
        {
        	powerup[me].xpos = 240 - Object[num_strats].parameter * 16;
        	powerup[me].ypos = 0;
        	powerup[me].grabbed = 255;
        }


		LoadSprite((u32)PickupItemSprite[Game_Area] + 128,PICKUP_SPRITE_OFFSET + 128,128);

	LoadSprite(PickupItemSprite[Game_Area],PICKUP_SPRITE_OFFSET,PICKUP_SPRITE_SIZE);
	LoadPalette(PickupItemPalette[Game_Area],11);
  	Object[num_strats].parameter = me;

	if(Game_Area == 5)
	{
		//StartTorch();
		if(powerup[me].grabbed == 255)
			TorchLit = 1;
	}
}

void HandlePickupItem(void)
{
	u8 me;
	u8 a;
	s16 sprx,spry;
	u8 mypri;
	
	mypri = 2;
	me = Object[current_strat].parameter;
	//mysprite = powerup[me].frame;
//	if(abs(game_x - powerup[me].xpos) > 400)
//	{
//		Sprite[mysprite].VPos = 160;
//		return;
	
//	}
	if(powerup[me].grabbed == 255) // on display
	{
		if(Game_Area == 5) // torch
		{
			spry = player.ypos + bobtable[powerup[me].bob] * 2 - 20 - game_y;
			sprx = player.xpos + (fsin[GameClock & 255] >> 3) + 16 - game_x;
			if(Sprite[player.frame].HFlip == 1)
				sprx -= 32;
			if((GameClock & 255) > 64 && (GameClock & 255) < 192)
				mypri = 1;
		}
		else
		{
			sprx = powerup[me].xpos;
			spry = powerup[me].ypos;
		}
	}
	else
	{
		sprx = 224 - powerup[me].slot;// PickupItemsThisLevel * 16;
		spry = 4;
		
		
		mysprite = NextSprite++; // Bohrok[me].frame;
    	Sprite[mysprite] = *(OamData *)OamData_Sample;
		
     	Sprite[mysprite].Pltt = 11;
         Sprite[mysprite].Priority = 0;

      	Sprite[mysprite].CharNo = PICKUP_SPRITE + 4;
       	Sprite[mysprite].Shape = PebbleSizeShape[1];
   		Sprite[mysprite].Size = PebbleSizeShape[0]; //OAM_SIZE_64x64;
		Sprite[mysprite].HPos = sprx;
		Sprite[mysprite].VPos = spry ;
		Sprite[mysprite].AffineMode = 0;
       Sprite[mysprite].HFlip = 0;
         Sprite[mysprite].VFlip = 0;
 
		if(powerup[me].grabbed) // picked up!
		{
			if(powerup[me].grabbed == 1)
			{
				powerup[me].xpos += smin(game_x + 120 + (fsin[(powerup[me].spinoff * 2 + 64) & 255] >> 3) - powerup[me].xpos,16);
				powerup[me].ypos += smin(game_y + 80 + (fsin[(powerup[me].spinoff * 2) & 255] >> 3) - powerup[me].ypos,16);
				powerup[me].spinoff+= 2;
				if(powerup[me].spinoff >=  192)
				{
					powerup[me].grabbed++;
				}
			}
			else
			{
				powerup[me].ypos -= powerup[me].grabbed;
				powerup[me].grabbed = min(254,powerup[me].grabbed + 1);
				
			}
		}
		


		sprx = powerup[me].xpos - 16 - game_x;
		spry = powerup[me].ypos - 16 - game_y + bobtable[powerup[me].bob] * 2;
	}
	if(sprx >= -32 && sprx < 240 && spry >= -32 && spry <= 160)
	{
		
		mysprite = NextSprite++; // Bohrok[me].frame;
    	Sprite[mysprite] = *(OamData *)OamData_Sample;
		
     	Sprite[mysprite].Pltt = 11;
         Sprite[mysprite].Priority = mypri;

      	Sprite[mysprite].CharNo = PICKUP_SPRITE;
       	Sprite[mysprite].Shape = PebbleSizeShape[1];
   		Sprite[mysprite].Size = PebbleSizeShape[0]; //OAM_SIZE_64x64;
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		Sprite[mysprite].AffineMode = 0;
       Sprite[mysprite].HFlip = 0;
         Sprite[mysprite].VFlip = 0;
 
		powerup[me].bob = (powerup[me].bob + 1) & 31;
		
		powerup[me].cycle = (powerup[me].cycle + 4) & 255;
		LoadSprite((u32)PickupItemSprite[Game_Area],PICKUP_SPRITE_OFFSET,128);
		LoadPalette((u32)PickupItemPalette[Game_Area ],11);
			
		// cycle it	
		powerup[me].delay--;
		if(powerup[me].delay == 0)
		{
			powerup[me].delay = 5;
			spawnparticle(powerup[me].xpos + 16 + (fsin[powerup[me].cycle] >> 5),powerup[me].ypos + 12 + (fsin[(powerup[me].cycle * 2) & 255] >> 5),0,0,0,0,16,0,0);
		}
		// check for pickup...
		
		if(abs(player.xpos - powerup[me].xpos) < 32 && abs(player.ypos - powerup[me].ypos) < 32 && powerup[me].grabbed == 0)
		{
			PickupItems++; // increase number of items picked up
			
			Sprite[mysprite].VPos = 161; // zap the sprite and return it to the pool
			SpawnParticleRing(powerup[me].xpos,powerup[me].ypos,4,4,2);
			powerup[me].grabbed = 1;
			if(Game_Area == 5) // Onu-wahi
			{
				TorchLit = 1;
			}
		}
	}
	else
	{
	//	Sprite[mysprite].VPos = 160;
		if(powerup[me].grabbed)
		{
			powerup[me].xpos = 224 - powerup[me].slot;
			powerup[me].ypos = 4;
			powerup[me].grabbed = 255;
		}
	}
	
}

void HandleBonusMask(void)
{
	u8 me;
	u8 a;
	s16 sprx,spry;
	me = Object[current_strat].parameter;
	mysprite = powerup[me].frame;
	if(abs(game_x - powerup[me].xpos) > 400)
	{
		Sprite[mysprite].VPos = 160;
		return;
	
	}

	if(powerup[me].delay) // picked up!
	{
		if(powerup[me].delay == 1)
		{
			powerup[me].xpos += smin(game_x + 120 + (fsin[(powerup[me].spinoff * 2 + 64) & 255] >> 3) - powerup[me].xpos,16);
			powerup[me].ypos += smin(game_y + 80 + (fsin[(powerup[me].spinoff * 2) & 255] >> 3) - powerup[me].ypos,16);
			powerup[me].spinoff+= 2;
			if(powerup[me].spinoff >=  192)
			{
				powerup[me].delay++;
			}
		}
		else
		{
			powerup[me].ypos -= powerup[me].delay;
			powerup[me].delay++;
		}
	}
	sprx = powerup[me].xpos - game_x;
	spry = powerup[me].ypos - game_y + bobtable[powerup[me].bob] * 2;
	if(sprx >= -32 && sprx < 240 && spry >= -32 && spry <= 160)
	{
		
		
		Sprite[mysprite].CharNo = BOSS_SPRITE2;
		LoadSprite((u32)BonusMask + (powerup[me].cycle) * BOSS_SPRITE2_SIZE,BOSS_SPRITE2_OFFSET,BOSS_SPRITE2_SIZE);
		LoadEnemyPalette(BonusMaskPalette,nxtenemypal);
   		Sprite[mysprite].Pltt = 2 + PalCache;
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		powerup[me].bob = (powerup[me].bob + 1) & 31;
			
		// check for pickup...
		
		if(abs(player.xpos - powerup[me].xpos) < 32 && abs(player.ypos - powerup[me].ypos) < 32 && powerup[me].delay == 0)
		{
			
			SpawnParticleRing(powerup[me].xpos,powerup[me].ypos,4,4,2);
			powerup[me].delay = 1;
			powerup[me].spinoff = 0;
			//Sprite[mysprite].ObjMode = 1;
			Sprite[mysprite].Priority = 0;
			BonusMasks |= BonusMaskFlag[powerup[me].cycle];
			Sample_Play(SMPL_SELECT);			
		}
		if(powerup[me].delay > 0)
			spawnparticle(powerup[me].xpos + 16,powerup[me].ypos + 16,0,0,0,0,16,0,0);

	}
	else
	{
		Sprite[mysprite].VPos = 160;
		if(powerup[me].delay > 0)
		{
			Sprite[mysprite].VPos = 161; // zap the sprite and return it to the pool
			if(BonusMasks == 15) // all masks gained
			{
				NCharAvail[Game_Area + 1] = 1;
				//for(sprx = 0; sprx < 4; sprx++)
				GameStateLoop = GainCharacterLoop;
				PauseScreenState = *(vu16 *)REG_DISPCNT;
				*(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_ON | DISP_OBJ_CHAR_1D_MAP; ;
				HBlankRoutine(HBlankGainChar);
				GameClock = 0;
				GainCharacterSequence = 0;
				numparticles = 0;
				SpriteBankTemp = 1;
			//	for(a = 0; a < 128;a++)
			//			Sprite[a].VPos = max(160,Sprite[a].VPos);
			}
			Sample_Play(SMPL_DISC_DEFLECT01);

			remove();
		}
	}
}

void initbonusmaskgain(void)
{
	u32 i;
	u8 me;
	u8 a,b,x,y;
	u32 * tptr;
	
	
	me = NextPowerUp();
	powerup[me].frame = GrabASprite();
	Object[num_strats].handle = HandleBonusMaskGain;
	Object[num_strats].remover = RemovePowerup;
	i = powerup[me].frame;

      	Sprite[i].CharNo =EnemySprite[SpriteCache];
       	Sprite[i].Shape = 0;
   		Sprite[i].Size = 3; // 32 x 32;
   		Sprite[i].Pltt = 2; // use enemy dynamic palettes
         Sprite[i].Priority = 2;
         Sprite[i].AffineMode = 1;
         Sprite[i].AffineParamNo_L = 3;
	SpriteScaleFine(3,1,1);
	
        powerup[me].xpos = 0;
        powerup[me].ypos = 0;
 		powerup[me].cycle = parm_xpos;
		powerup[me].delay = 1;
 		
 	Object[num_strats].parameter = me;
 	
	
}

void HandleBonusMaskGain(void)
{

	u8 me;
	u8 a,x,y;
	s16 sprx,spry;
	u32 sprite_ptr;
	
	me = Object[current_strat].parameter;
	mysprite = powerup[me].frame;

	sprx = 120 - 32;
	spry = 80 - 32;

	LoadEnemyPalette(MaskPalette + gamemasknum[Game_Area + 1] * 32,nxtenemypal);
	Sprite[mysprite].Pltt = 2 + PalCache;

	sprite_ptr = (u32)Mask1Sprite + gamemasknum[Game_Area + 1] * MASK_MSPRITE_SIZE;
	LoadEnemySprite(sprite_ptr, 2048);
		
	Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
	Sprite[mysprite].HPos = sprx & 511;
	Sprite[mysprite].VPos = (spry + 256) & 255;
	
	powerup[me].delay++;
	SpriteScaleFine(3,min(64,powerup[me].delay),min(64,powerup[me].delay));
		
	if(powerup[me].delay >= 80)
	{
		Sprite[mysprite].VPos = 161;
		Sprite[mysprite].AffineMode = 0;
		SpawnParticleRing(game_x + 120,game_y + 80,4,4,4);
		remove();
	}
	
}
	
	