// SampleImporterDlg.cpp : implementation file
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define AGSS_OK							0
#define AGSSERR_FILE_NOT_FOUND			-1
#define AGSSERR_BAD_FORMAT				-2
#define AGSSERR_ONLY_MONO_SUPPORTED		-3
#define AGSSERR_ONLY_8BIT_SUPPORTED		-4

static char *playingFreqStrings[]=
{
	"1:1 of main frequency",
	"1:2 of main frequency",
	"1:4 of main frequency",
	"1:8 of main frequency"
};

#define SMPPLAYFREQ_1_1		0
#define SMPPLAYFREQ_1_2		1
#define SMPPLAYFREQ_1_4		2
#define SMPPLAYFREQ_1_8		3

typedef struct
{
	int				length;
	char			*nameIdentifier;
	char			*importedFromFile;
	unsigned char	*data;
	int				defPlayFreq;
} sImportedSample;

int lastUsedDefPlayFreq = 0;

DynamicArray<sImportedSample*>	importedSamples;
OPENFILENAME inputofn;

static int LoadSample( char *fileName, sImportedSample *dst );

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSampleImporterDlg dialog

CSampleImporterDlg::CSampleImporterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSampleImporterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSampleImporterDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSampleImporterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSampleImporterDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSampleImporterDlg, CDialog)
	//{{AFX_MSG_MAP(CSampleImporterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(NM_RCLICK, IDC_LIST_OF_SAMPLES, OnRclickListOfSamples)
	ON_COMMAND(IDM_RENAME_ID_NAME, OnRenameIdName)
	ON_COMMAND(IDM_INSERT_SAMPLE, OnInsertSample)
	ON_COMMAND(IDM_SET_1_1_FREQ, OnSet11Freq)
	ON_COMMAND(IDM_SET_1_2_FREQ, OnSet12Freq)
	ON_COMMAND(IDM_SET_1_4_FREQ, OnSet14Freq)
	ON_COMMAND(IDM_SET_1_8_FREQ, OnSet18Freq)
	ON_COMMAND(IDM_DELETE_SAMPLE, OnDeleteSample)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_OF_SAMPLES, OnDblclkListOfSamples)
	ON_COMMAND(IDM_SAVE_AGSS_FILE, OnSaveAgssFile)
	ON_WM_COPYDATA()
	ON_WM_CANCELMODE()
	ON_WM_DROPFILES()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSampleImporterDlg message handlers

BOOL CSampleImporterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CListCtrl *lc = (CListCtrl*)GetDlgItem(IDC_LIST_OF_SAMPLES);
	lc->SetExtendedStyle(LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_TRACKSELECT|LVS_EX_FLATSB);
	lc->InsertColumn(0,"ID Name",LVCFMT_RIGHT,150);
	lc->InsertColumn(1,"Imported from file",LVCFMT_LEFT,250);
	lc->InsertColumn(2,"Length",LVCFMT_RIGHT,60);
	lc->InsertColumn(3,"Frequency",LVCFMT_LEFT,130);
	lc->InsertColumn(4,"Looped",LVCFMT_LEFT,60);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSampleImporterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSampleImporterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSampleImporterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


int LoadSample( char *fileName, sImportedSample *dst )
{
DWORD id;
WAVEFORMATEX waveFormat;
int retVal = AGSSERR_BAD_FORMAT;
int dataLength;
int i,j;
unsigned char *data;

	FILE *inpf = fopen( fileName, "rb" );
	if( inpf==NULL )
		return AGSSERR_FILE_NOT_FOUND;
	fseek( inpf, 0, SEEK_END );
	int flength = ftell(inpf);
	if( flength<0x30 )
		goto bad;
	fseek( inpf, 0, SEEK_SET );
	fread( &id, 1, sizeof(DWORD), inpf );
	if( id!='FFIR' ) goto bad;
	fseek( inpf, 8, SEEK_SET );
	fread( &id, 1, sizeof(DWORD), inpf );
	if( id!='EVAW' ) goto bad;
	fseek( inpf, 0x14, SEEK_SET );
	fread( &waveFormat, 0x10, 1, inpf );
	fread( &id, 1, sizeof(DWORD), inpf );
	if( id!='atad' ) goto bad;
	fseek( inpf, 0x28, SEEK_SET );
	fread( &dataLength, 1, sizeof(DWORD), inpf );

	if( waveFormat.wFormatTag!=1 )
		goto bad;
	if( waveFormat.nChannels!=1 )
	{
		retVal = AGSSERR_ONLY_MONO_SUPPORTED;
		goto bad;
	}
	if( waveFormat.wBitsPerSample!=8 )
	{
		retVal = AGSSERR_ONLY_8BIT_SUPPORTED;
		goto bad;
	}

	data = new unsigned char[dataLength+4];
	fread( data, 1, dataLength, inpf );
	for( i=0; i<dataLength; i++ )
	{
		data[i] ^= 0x80;
	}
	data[i++] = 0;
	data[i++] = 0;
	data[i++] = 0;
	data[i++] = 0;

	dst->defPlayFreq = lastUsedDefPlayFreq;
	dst->data = data;
	dst->importedFromFile = strdup(fileName);
	dst->length = dataLength;
	char fname[MAX_PATH];
	_splitpath(fileName,NULL,NULL,fname,NULL);
	_strupr(fname);
	for (j=0;j<(int)strlen(fname);j++)
	{
		if (fname[j] == '-')
		{
			fname[j] = '_';
		}
	}
	char idName[4000];
	for( j=0; j<1000; j++ )
	{
		if( j==0 )
			sprintf( idName, "SMPL_%s", fname );
		else
			sprintf( idName, "SMPL_%s%d", fname, j+1 );
		for( i=0; i<importedSamples.Size(); i++ )
		{
			if(stricmp(idName,importedSamples[i]->nameIdentifier)==0 )
				break;
		}
		if( i==importedSamples.Size() )
			break;
	}
	dst->nameIdentifier = strdup(idName);
	fclose( inpf );
	return AGSS_OK;
bad:
	fclose(inpf);
	return retVal;
}

int selectedItem;

void CSampleImporterDlg::OnRclickListOfSamples(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CListCtrl *lc = (CListCtrl*)GetDlgItem(IDC_LIST_OF_SAMPLES);
	CPoint screenPoint; GetCursorPos(&screenPoint);
	CPoint pt = screenPoint; lc->ScreenToClient(&pt);
	CMenu mainMenu,*subMenu;
	mainMenu.LoadMenu(IDR_VARIOUS_MENUS);
	int item = lc->HitTest(pt);
	selectedItem = item;
	if( item!=-1 )
	{
		LVHITTESTINFO hti;
		hti.pt			= pt;
		hti.iItem		= item;
		lc->SubItemHitTest(&hti);
		subMenu = mainMenu.GetSubMenu(hti.iSubItem+1);
		if( (hti.iSubItem+1)==4 )
		{
			subMenu->CheckMenuItem( importedSamples[selectedItem]->defPlayFreq, MF_BYPOSITION|MF_CHECKED );
		}
	}
	else	
		subMenu = mainMenu.GetSubMenu(0);
	subMenu->TrackPopupMenu( TPM_RIGHTBUTTON|TPM_LEFTALIGN|TPM_LEFTBUTTON, screenPoint.x, screenPoint.y, this );
	mainMenu.DestroyMenu();
	*pResult = 0;
}

void CSampleImporterDlg::OnRenameIdName() 
{
int i;
CEnterName en;

	strcpy( en._enteredName, importedSamples[selectedItem]->nameIdentifier);
	again:
	if( IDOK==en.DoModal() )
	{
		for( i=0; i<importedSamples.Size(); i++ )
		{
			if(stricmp(en._enteredName,importedSamples[i]->nameIdentifier)==0 )
				break;
		}
		if( i!=importedSamples.Size() )
		{
			MessageBox( "Sample with that identifier, already exists!" );
			goto again;
		}
		free( importedSamples[selectedItem]->nameIdentifier );
		_strupr(en._enteredName);
		importedSamples[selectedItem]->nameIdentifier = strdup( en._enteredName );
		CListCtrl *lc = (CListCtrl*)GetDlgItem(IDC_LIST_OF_SAMPLES);
		lc->SetItemText( selectedItem, 0, en._enteredName );
	}
}

bool CSampleImporterDlg::DoSampleAdd(char *srcFileName)
{
	sImportedSample *dst = new sImportedSample;
	int retV = LoadSample(srcFileName,dst);
	if( retV==AGSS_OK )
	{
		CListCtrl *lc = (CListCtrl*)GetDlgItem(IDC_LIST_OF_SAMPLES);
		int item;
		if( selectedItem==-1 )
		{
			item = lc->InsertItem( lc->GetItemCount(), dst->nameIdentifier );
		}
		else
		{
			item = lc->InsertItem( selectedItem, dst->nameIdentifier );
		}
		char str[200];
		lc->SetItemText( item, 1, dst->importedFromFile );
		sprintf(str,"%d",dst->length);
		lc->SetItemText( item, 2, str );
//			lc->SetItemText( item, 3, playingFreqStrings[dst->defPlayFreq] );
		lc->SetItemText( item, 3, "16384" );
		lc->SetItemText( item, 4, "no" );
		if( selectedItem==-1 )
			importedSamples.Add(dst);
		else
			importedSamples.Insert(dst,selectedItem);
//			lc->GetItemText(
		return true;
	}
	else
	{
		delete dst;
		char *errStr = "huh?";
		switch( retV )
		{
			case AGSSERR_FILE_NOT_FOUND:		errStr = "File not found ?"; break;
			case AGSSERR_BAD_FORMAT:			errStr = "Bad format."; break;
			case AGSSERR_ONLY_MONO_SUPPORTED:	errStr = "Only mono samples are supported."; break;
			case AGSSERR_ONLY_8BIT_SUPPORTED:	errStr = "Only 8bit unsigned samples are supported."; break;
		}
		char errS[1000];
		sprintf(errS,"Error occured while file \"%s\" was processed:\n\"%s\"", srcFileName, errStr );
		MessageBox( errS );
		return false;
	}

	return false;
}

void CSampleImporterDlg::OnInsertSample() 
{
	char inputOutputFileName[MAX_PATH*1000];
	inputofn.lStructSize	= sizeof(inputofn);
	inputofn.lpstrTitle	= _T("Insert new sample ...");
	inputofn.lpstrFilter	= _T("Sample Files (*.wav)\0*.wav\0\0");
	inputofn.hwndOwner		= m_hWnd;
	inputofn.lpstrFile		= inputOutputFileName;
	inputofn.nMaxFile		= sizeof(inputOutputFileName);
	inputofn.Flags			= OFN_EXPLORER|OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST|OFN_ALLOWMULTISELECT;
	inputOutputFileName[0] = 0;
	if( !GetOpenFileName(&inputofn) )
		return;
	char *srcFileName = &inputofn.lpstrFile[inputofn.nFileOffset];
	while(strlen(srcFileName))
	{
		if (!DoSampleAdd(srcFileName))
		{
			break;
		}
		int len = strlen(srcFileName);
		srcFileName = &srcFileName[len+1];
	}
}

void CSampleImporterDlg::OnSet11Freq() 
{
	importedSamples[selectedItem]->defPlayFreq = 0;
	CListCtrl *lc = (CListCtrl*)GetDlgItem(IDC_LIST_OF_SAMPLES);
	lc->SetItemText( selectedItem, 3, playingFreqStrings[0] );
	lastUsedDefPlayFreq = 0;
}
void CSampleImporterDlg::OnSet12Freq() 
{
	importedSamples[selectedItem]->defPlayFreq = 1;
	CListCtrl *lc = (CListCtrl*)GetDlgItem(IDC_LIST_OF_SAMPLES);
	lc->SetItemText( selectedItem, 3, playingFreqStrings[1] );
	lastUsedDefPlayFreq = 1;
}

void CSampleImporterDlg::OnSet14Freq() 
{
	importedSamples[selectedItem]->defPlayFreq = 2;
	CListCtrl *lc = (CListCtrl*)GetDlgItem(IDC_LIST_OF_SAMPLES);
	lc->SetItemText( selectedItem, 3, playingFreqStrings[2] );
	lastUsedDefPlayFreq = 2;
}
void CSampleImporterDlg::OnSet18Freq() 
{
	importedSamples[selectedItem]->defPlayFreq = 3;
	CListCtrl *lc = (CListCtrl*)GetDlgItem(IDC_LIST_OF_SAMPLES);
	lc->SetItemText( selectedItem, 3, playingFreqStrings[3] );
	lastUsedDefPlayFreq = 3;
}

void CSampleImporterDlg::OnDeleteSample() 
{
	CListCtrl *lc = (CListCtrl*)GetDlgItem(IDC_LIST_OF_SAMPLES);
	lc->DeleteItem( selectedItem );
	importedSamples.Remove(selectedItem);
}

void CSampleImporterDlg::OnDblclkListOfSamples(NMHDR* pNMHDR, LRESULT* pResult) 
{
	selectedItem = -1;
	OnInsertSample();
	*pResult = 0;
}

OPENFILENAME outputofn;

void CSampleImporterDlg::OnSaveAgssFile() 
{
int i,j;

	char inputOutputFileName[MAX_PATH];
	outputofn.lStructSize	= sizeof(outputofn);
	outputofn.lpstrTitle	= _T("Select output file ...");
	outputofn.lpstrFilter	= _T("Sound System Sample Files (*.s)\0*.s\0\0");
	outputofn.hwndOwner		= m_hWnd;
	outputofn.lpstrFile		= inputOutputFileName;
	outputofn.nMaxFile		= sizeof(inputOutputFileName);
	outputofn.Flags			= OFN_EXPLORER|OFN_PATHMUSTEXIST;
	inputOutputFileName[0] = 0;
	if( !GetSaveFileName(&outputofn) )
		return;

	FILE *outf = fopen(inputOutputFileName,"wt" );
	if( outf )
	{
		fprintf( outf, "\t.text\n" );
		fprintf( outf, "\t.global\tagss_imported_samples\n" );
		fprintf( outf, "\t.type\tagss_imported_samples, object\n" );
		fprintf( outf, "\t.align\t2\n" );
		fprintf( outf, "agss_imported_samples:\n" );
		fprintf( outf, "\t.word\t%d\n", importedSamples.Size() );

		for( i=0; i<importedSamples.Size(); i++ )
		{
			fprintf( outf, "\t.word\tagss_is_%06d, % 6d, %d\n", i, importedSamples[i]->length, importedSamples[i]->defPlayFreq );
		}
		fprintf(outf,"\n");

		for( j=0; j<importedSamples.Size(); j++ )
		{
			fprintf( outf, "agss_is_%06d:", j );
			int length = importedSamples[j]->length;
			for(i=0; i<length; i+=4 )
			{
				DWORD value = ((DWORD*)(&importedSamples[j]->data[i]))[0];
				if( (i&31)==0 )
					fprintf( outf, "\n\t.word\t0x%08x", value );
				else
					fprintf( outf, ", 0x%08x", value );
			}
			fprintf( outf, "\n\n" );
		}
		fclose(outf);

		char fdir[MAX_PATH],fdrive[MAX_PATH], fname[MAX_PATH];
		_splitpath( inputOutputFileName, fdrive, fdir, fname, NULL );
		char fileName[MAX_PATH];
		_makepath( fileName, fdrive, fdir, fname, ".inc" );
		outf = fopen(fileName,"wt");
		fprintf( outf, "@\n@  This file contains sample identifiers\n@ and should be included into your asm files\n@\n\n" );
		for( i=0; i<importedSamples.Size(); i++ )
			fprintf( outf, "\t%s = %d", importedSamples[i]->nameIdentifier, i );
		fprintf( outf, "\n\n" );
		fclose(outf);

		_makepath( fileName, fdrive, fdir, fname, ".h" );
		outf = fopen(fileName,"wt");
		fprintf( outf, "//\n//  This file contains sample identifiers\n// and should be included into your C/C++ files\n//\n\n" );
		fprintf( outf, "enum\n{\n" );
		for( i=0; i<importedSamples.Size(); i++ )
		{
			fprintf( outf, "\t%s,\n", importedSamples[i]->nameIdentifier);
		}
		fprintf( outf, "\tEND_SMPL_END\n");
		fprintf( outf, "};\n" );
		fclose(outf);

	}
}

BOOL CSampleImporterDlg::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
{
	// TODO: Add your message handler code here and/or call default
	
	return CDialog::OnCopyData(pWnd, pCopyDataStruct);
}

void CSampleImporterDlg::OnCancelMode() 
{
	CDialog::OnCancelMode();
	
	// TODO: Add your message handler code here
	
}

void CSampleImporterDlg::OnDropFiles(HDROP hDropInfo) 
{
	// TODO: Add your message handler code here and/or call default

	char buffer[256];
	int numdrops = DragQueryFile(hDropInfo,-1,buffer,sizeof(buffer));

	selectedItem = -1;
	for (int i=0;i<numdrops;i++)
	{
		DragQueryFile(hDropInfo,i,buffer,sizeof(buffer));
		if (!DoSampleAdd(buffer))
		{
			break;
		}
	}
	
	CDialog::OnDropFiles(hDropInfo);
}
