// Display Screen (for titles, credits etc.)

#include <AGB.h>
#include "ArgoVBlank.h"
#include "screen.h"
#include "asldefines.h"
#include "main.h"
#include "legotitles.h"
#include "argonautscreen.h"
#include "fesprites.h"
#include "displayscreen.h"
//#include "fescalemap.h"
#include "splashscreen.h"
#include "splashscreen2.h"
//#include "cloudsprite.h"
#include "lewahiloader.h"
#include "flashstrip.h"
#include "legolegal.h"
#include "bioniclelogo.h"
#include "SampleManager.h"
#include "text.h"
#include "menubutton.h"
#include "font16.h"
#include "maintext1.h"
#include "maintext2.h"

u16 titleclock;
u8 titlespritecount;

titlespriteparms titlesprite[14];
extern u8 AttractTimeout;

void HandleCloudFrontSprite(void);
void initcloudfrontsprite(void);
void HandleTitleCharSprite(void);
void HandleTitleCharNameSprite(void);
void inittitlechar1(void);
void inittitlechar2(void);
void inittitlechar3(void);
void inittitlechar1n(void);
void inittitlechar2n(void);
void inittitlechar3n(void);
void inittitleletter(void);

int titlefontletter;

#include "GBADecompress.h"

u8 screenfirsttime=0;

void DisplayLego()
{
	s8 fade;
	u16 clock;
	
	ArgoVBlank();                           // Complete V Blank interrupt

	*(vu16 *)REG_BLDCNT =  BLD_UP_MODE |  BLD_1ST_ALL;
	*(vu16 *)REG_BLDY = 15;

	*(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_CHAR_1D_MAP;
	Screen0(0);
	Screen1(0);
	Screen2(0);
	Screen3(0);

    DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
   	DmaWait(3);
    DmaArrayCopy(3, Sprite,          OAM,            32);
	DmaWait(3);

    DmaCompressedCopy(3, legolegalChar, BG_VRAM + 0x4000, 32);  //  Set BG character
    DmaWait(3);
    DmaArrayCopy(3, legolegalMap,BG_VRAM,32);
	DmaWait(3);

	ArgoVBlank();                           // Complete V Blank interrupt

	*(vu16 *)REG_BG0CNT =                             // Set BG control for BG 0
		BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_2
		| 0 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;

	*(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_ON | DISP_BG0_ON |  DISP_OBJ_CHAR_1D_MAP; // LCDC ON

	*(vu16 *)REG_BLDCNT =  BLD_A_BLEND_MODE | BLD_BG0_1ST | BLD_BG2_2ND;

	*(vu16 *)REG_BLDALPHA = (10) + ((14) << 8);

    DmaArrayCopy(3, legolegalPalette, BG_PLTT,        32);  //  Set BG palette
    DmaWait(3);

   	MapActive = 0;

	KeyRead();
	clock = 0;
/*  switch this section off for normal game.
    * this bit lets Jason manually load in screens for testing
*/
//	while(!(controller_push & pad_start))
//	{
//		KeyRead();
//		ArgoVBlank();
//	
//	}

	fade = 15;
	while(fade >= 0)
	{
		WipeToWhite(fade--);
        ArgoVBlank();                           // Complete V Blank interrupt
	}


//   lose the above for the normal game.
	//Sample_Play(SMPL_AHLEGO);
	while(clock < 300)
	{
  		KeyRead();                                  // Key control
        ArgoVBlank();                           // Complete V Blank interrupt

		if (screenfirsttime)
		{
			if ( (controller_push & pad_start) )
			{
				clock = 300;
			}
		}
		
   		handle_strats();
   		DoParticles();
		clock++;
	
	
	}

	screenfirsttime = 1;

	fade = 0;
	while(fade <= 15)
	{
		WipeToWhite(fade++);
		ArgoVBlank();
	}

}

void DisplayBionicleLogo()
{
	s8 fade;
	u16 clock;
	
	fade = 15;
	MenuScreen();
    Screen2(0);
    DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
   	DmaWait(3);
    DmaArrayCopy(3, Sprite,          OAM,            32);
	DmaWait(3);
    
   	MapActive = 0;
    DmaCompressedCopy(3, bioniclelogoChar, BG_VRAM + 0x4000, 32);  //  Set BG character
    DmaWait(3);
    DmaArrayCopy(3, bioniclelogoPalette, BG_PLTT,        32);  //  Set BG palette
    DmaWait(3);
    DmaArrayCopy(3, bioniclelogoMap,BG_VRAM,32);
	DmaWait(3);
	while(fade >= 0)
	{
		WipeToBlack(fade--);
        ArgoVBlank();                           // Complete V Blank interrupt
	}
	KeyRead();
	clock = 0;
/*  switch this section off for normal game.
    * this bit lets Jason manually load in screens for testing
*/
//	while(!(controller_push & pad_start))
//	{
//		KeyRead();
//		ArgoVBlank();
//	
//	}

//   lose the above for the normal game.
	//Sample_Play(SMPL_AHLEGO);
	while(!(controller_push & pad_start) && clock < 300)
	{
  		KeyRead();                                  // Key control
        ArgoVBlank();                           // Complete V Blank interrupt
		
   		handle_strats();
   		DoParticles();
		clock++;
	
	
	}
	fade = 0;
	while(fade <= 15)
	{
		WipeToWhite(fade++);
		ArgoVBlank();
	}

}


void DisplayArgonaut()
{
	s8 fade;
	u16 clock;
	
	fade = 0;
	while(fade <= 15)
	{
		WipeToBlack(fade++);
		ArgoVBlank();
		
	}
	fade = 15;
	MenuScreen();
    Screen2(0);
    DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
    DmaArrayCopy(3, Sprite,          OAM,            32);

     DmaWait(3);
   
    DmaArrayCopy(3, ArgonautChar, BG_VRAM + 0x4000, 32);  //  Set BG character
    DmaWait(3);
    DmaArrayCopy(3, ArgonautPalette, BG_PLTT,        32);  //  Set BG palette
    DmaWait(3);
    DmaArrayCopy(3, ArgonautMap,BG_VRAM,32);
    DmaWait(3);
	
	while(fade >= 0)
	{
		WipeToBlack(fade--);
        ArgoVBlank();                           // Complete V Blank interrupt
	}
	KeyRead();
	clock = 0;
	while(!(controller_push & pad_start) && clock < 300)
	{
  		KeyRead();                                  // Key control
        ArgoVBlank();                           // Complete V Blank interrupt
		
   		handle_strats();
   		DoParticles();
		clock++;
	
	
	}
	fade = 0;
	while(fade <= 15)
	{
		WipeToWhite(fade++);
		ArgoVBlank();
	}

}

void DisplaySplash()
{
	s8 fade;
	u16 clock;
	u8 a;
	u16 timeout;
	int musvol;
	int charno;
	int palette;
	int i,j;
	u8 sprites[64];
	int whooshcounter;
	int bldcount;
	
//	fade = 0;
//	while(fade <= 15)
//	{
//		WipeToWhite(fade++);
//		ArgoVBlank();
//	}
	fade = 15;
	MenuScreen();
	Screen2(0);
    MenuScreenLayer1();
    Screen1(0);
	// White the screen
    Screen0(0);
	*(vu16 *)REG_BLDCNT =  BLD_UP_MODE |  BLD_1ST_ALL;
	*(vu16 *)REG_BLDY = 15;
    
    DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
    DmaArrayCopy(3, Sprite,          OAM,            32);

     DmaWait(3);
   
    DmaCompressedCopy(3, splashscreenChar, BG_VRAM + 0x4000, 32);  //  Set BG character
    DmaWait(3);
    DmaArrayCopy(3, splashscreenPalette, BG_PLTT,        32);  //  Set BG palette
    DmaWait(3);
    DmaArrayCopy(3, splashscreenMap,BG_VRAM,32);
    DmaWait(3);

	*(vu16 *)REG_BG0CNT =                             // Set BG control for BG 0 (main game area)
		BG_COLOR_256 | BG_SCREEN_SIZE_0 | BG_PRIORITY_2
		| 0 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;
	
//   	DmaArrayCopy(3, splashscreen2Char, BG_VRAM + 0xC000, 32);  //  Set BG character
//    DmaWait(3);
//    DmaArrayCopy(3, splashscreenPalette, BG_PLTT,        32);  //  Set BG palette
//    DmaWait(3);
//    DmaArrayCopy(3, splashscreen2Map,BG_VRAM + 2048,32);
//    DmaWait(3);
		*(vu16 *)REG_BG0VOFS = 0;
		*(vu16 *)REG_BG0HOFS = 0;
		*(vu16 *)REG_BG1VOFS = 0;
		*(vu16 *)REG_BG1HOFS = 0;
		*(vu16 *)REG_BG2VOFS = 0;
		*(vu16 *)REG_BG2HOFS = 0;
		*(vu16 *)REG_BG3VOFS = 0;
		*(vu16 *)REG_BG3HOFS = 0;

	    num_strats = 0;		// get rid of all current strats
   	KillButtons();
   	KillBigChars();


	LoadSprite((u32)FontBigSprite,BIGTEXT_MSPRITE_OFFSET ,BIGTEXT_MSPRITE_SIZE * 67);

	// Do the sprites
	charno = 300;
	palette = 0;

	for (j=0;j<4;j++)
	{
		i = GrabASprite();
		sprites[j] = i;
 		Sprite[i].CharNo = charno;
  		Sprite[i].Shape = 0;
		Sprite[i].Size = 3;
		Sprite[i].Pltt = palette;
		Sprite[i].Priority = 0;
		Sprite[i].AffineMode = 0;
		Sprite[i].ObjMode = 0;
		Sprite[i].HPos = j*64;
		Sprite[i].VPos = 160;
		LoadSprite((u32)maintext1Sprite+(((64*64)/2)*j),charno * 32,(64*64)/2);
		charno+=8*8;
	}

	for (j=0;j<15;j++)
	{
		i = GrabASprite();
		sprites[j+4] = i;
 		Sprite[i].CharNo = charno;
  		Sprite[i].Shape = 0;
		Sprite[i].Size = 1;
		Sprite[i].Pltt = palette;
		Sprite[i].Priority = 0;
		Sprite[i].AffineMode = 0;
		Sprite[i].ObjMode = 0;
		Sprite[i].HPos = j*16;
		Sprite[i].VPos = 160;
		LoadSprite((u32)maintext2Sprite+(((16*16)/2)*j),charno * 32,(16*16)/2);
		charno+=2*2;
	}

	LoadPalette(maintext1Palette,palette);
	palette++;

	
    Screen0(1);
	while(fade >= 0)
	{
		WipeToWhite(fade--);
        ArgoVBlank();                           // Complete V Blank interrupt
	}
	KeyRead();
	clock = 0;
	num_strats = 0;
	HBlankRoutine(HBlankGame);
	MapActive = 0;


	whooshcounter = 400;

	bldcount = 0;

	timeout = 15 * 60;
	while(!(controller_push & pad_start) && timeout > 0)
	{
  		timeout--;
  		KeyRead();                                  // Key control
        ArgoVBlank();                           // Complete V Blank interrupt

		if (whooshcounter > 0)
		{
			whooshcounter -= 4+min(8,whooshcounter/5);
			if (whooshcounter <= 0)
			{
				whooshcounter = 0;
				Sample_Play(SMPL_WALL_SMASH01);
				Sample_Play(SMPL_WALL_SMASH01);
				bldcount = 15;
			}
		}

		bldcount--;
		if (bldcount < 0)
		{
			bldcount = 0;
		}

		*(vu16 *)REG_BLDY = bldcount;

		for (j=0;j<4;j++)
		{
			int posx;
			posx = whooshcounter + (j*64);
			i = sprites[j];
			if (posx < 240 && posx > -64)
			{
				Sprite[i].HPos = posx;
				Sprite[i].VPos = 0;
			}
			else
			{
				Sprite[i].HPos = 0;
				Sprite[i].VPos = 160;
			}
		}

		for (j=0;j<15;j++)
		{
			int posx;
			posx = -whooshcounter + (j*16);
			i = sprites[4+j];
			if (posx < 240 && posx > -64)
			{
				Sprite[i].HPos = posx;
				Sprite[i].VPos = 48;
			}
			else
			{
				Sprite[i].HPos = 0;
				Sprite[i].VPos = 160;
			}
		}
		
   		handle_strats();
   		DoParticles();
		if(LastSprite > NextSprite) // If less sprites assigned this frame, switch off the remainder
		{
			for(a = NextSprite;a < LastSprite;a++)
			{
				Sprite[a].VPos = 160;
				Sprite[a].AffineMode = 0;
			}
		}
		LastSprite = NextSprite;
	//	if(NextSprite >= 96)
	//		LastSpriteWarn = NextSprite;
		NextSprite = 64;
		clock++;
		if(clock == 256)
			clock = 128;
		if(clock == 60)
		{
//			Screen1(1);
		}
//		if(clock >= 60 && clock < 92)
		if(clock >= 60 && clock < 92)
		{
//			*(vu16 *)REG_BLDCNT =  BLD_UP_MODE |  BLD_BG1_1ST;  
//			*(vu16 *)REG_BLDY = (91 - clock) / 2;
		}
		if(clock == 92)
		{
			TextAutoCentre = 1;
			menuselect = 0;
			BigText(0,48,96,(char *)&ButtonText[Lingo][68][0]);
		}
		if(clock >= 92)
		{
			if(clock & 16)
			{
				if((clock & 15) == 0)
					BigTextMove(0,120 - BigTextLen((char *)&ButtonText[Lingo][68][0]) / 2,180);
			}
			else
			{
				if((clock & 15) == 0)
					BigTextMove(0,120 - BigTextLen((char *)&ButtonText[Lingo][68][0]) / 2,96);
			}
		}
	
	}
	fade = 0;

	while(fade <= 15)
	{
		musvol = (Music_Volume * 33) - ((Music_Volume * 33 ) * fade)/15;
		SampleManager_SetMusicVolume(musvol);
		ArgoVBlank();
		WipeToWhite(fade++);
	}

	ArgoVBlank();
	*(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_CHAR_1D_MAP;
	Screen0(0);
	Screen1(0);
	Screen2(0);
	Screen3(0);
	*(vu16 *)REG_BG0CNT =                             // Set BG control for BG 0 (main game area)
		BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_2
		| 0 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;

	SampleManager_SetMusicVolume(0);
	KillBigChars();
	KillButtons();
	DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
	removeall();
	if(timeout == 0)
		AttractTimeout = 1;
}

static void remap16charto8(u16 *input,u8 *output,int size)
{
/*
	while (size>0)
	{
		*output++ = *input++;
		size--;
	}
*/
	int i;
	for (i=0;i<size;i++)
	{
		((u8 *)WRAM)[i] = input[i];
	}

	DmaCopy(3,WRAM,output,size,32);
	DmaWait(3);
}

#include "BackGroundScaleUp.h"
#include "LetterB.h"
#include "LetterI.h"
#include "LetterO.h"
#include "LetterN.h"
#include "LetterC.h"
#include "LetterL.h"
#include "LetterE.h"

static const void *const lettertable[] = {
	LetterBChar,LetterBMap,
	LetterIChar,LetterIMap,
	LetterOChar,LetterOMap,
	LetterNChar,LetterNMap,
	LetterIChar,LetterIMap,
	LetterCChar,LetterCMap,
	LetterLChar,LetterLMap,
	LetterEChar,LetterEMap,
};

void DisplayLetterWhoosh(void)
{
	int bldval;
	int counter;
	int timeout;
	int bank;
	int letter;
	int stampdown;
	int scaleup;
	int scaledown;

	*(vu16 *)REG_BLDCNT =  BLD_UP_MODE |  BLD_1ST_ALL;
	*(vu16 *)REG_BLDY = 15;

	DmaClear(3,0,VRAM,OBJ_MODE2_VRAM-VRAM,32);		// Clear all of the BG VRAM
	DmaWait(3);

	*(vu16 *)REG_BG2CNT = BG_COLOR_256 | BG_SCREEN_SIZE_1 | BG_PRIORITY_2
		| 0 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;

	*(vu16 *)REG_BG3CNT = BG_COLOR_256 | BG_SCREEN_SIZE_1 | BG_PRIORITY_3
		| 3 << BG_SCREEN_BASE_SHIFT | 3 << BG_CHAR_BASE_SHIFT ;

	*(vu16 *)REG_DISPCNT = DISP_MODE_2 | DISP_OBJ_ON | DISP_BG2_ON | DISP_BG3_ON | DISP_OBJ_CHAR_1D_MAP;

	*(vu16 *)REG_BG2HOFS = 0;
	*(vu16 *)REG_BG2VOFS = 0;
	*(vu16 *)REG_BG2PA = 1<<8;
	*(vu16 *)REG_BG2PB = 0;
	*(vu16 *)REG_BG2PC = 0;
	*(vu16 *)REG_BG2PD = 1<<8;
	*(vu32 *)REG_BG2X = 0;
	*(vu32 *)REG_BG2Y = 0;

	*(vu16 *)REG_BG3HOFS = 0;
	*(vu16 *)REG_BG3VOFS = 0;
	*(vu16 *)REG_BG3PA = 1<<8;
	*(vu16 *)REG_BG3PB = 0;
	*(vu16 *)REG_BG3PC = 0;
	*(vu16 *)REG_BG3PD = 1<<8;
	*(vu32 *)REG_BG3X = 0;
	*(vu32 *)REG_BG3Y = 0;

	DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
	DmaWait(3);
	DmaArrayCopy(3, Sprite,          OAM,            32);
	DmaWait(3);

	DmaCompressedCopy(3, BackGroundScaleUpChar, BG_VRAM + (0x4000*3), 32);  //  Set BG character
	DmaWait(3);
	DmaArrayCopy(3, BackGroundScaleUpPalette, BG_PLTT,        32);  //  Set BG palette
	DmaWait(3);
	remap16charto8(BackGroundScaleUpMap,(u8*)BG_VRAM+(0x800*3),32*32);

	bldval = 15;
	counter = 0;
	timeout = (8*16)+30;
	stampdown = 256;
	letter = 0;
	bank = 0;

	while(timeout > 0)
	{
  		KeyRead();                                  // Key control
        ArgoVBlank();                           // Complete V Blank interrupt

		*(vu16 *)REG_BLDY = bldval;

		if (timeout > 15 && bldval > 0)
		{
			bldval--;
		}
		if (timeout < 15 && bldval < 15)
		{
			bldval++;
		}

		scaleup = 513 - counter;
		scaledown = 128 + (stampdown*2);

		*(vu16 *)REG_BG3PA = scaleup;
		*(vu16 *)REG_BG3PB = 0;
		*(vu16 *)REG_BG3PC = 0;
		*(vu16 *)REG_BG3PD = scaleup;
		*(vu32 *)REG_BG3X = ((256*256) - (240*scaleup))/2;
		*(vu32 *)REG_BG3Y = ((256*256) - (160*scaleup))/2;

		*(vu16 *)REG_BG2PA = scaledown;
		*(vu16 *)REG_BG2PB = 0;
		*(vu16 *)REG_BG2PC = 0;
		*(vu16 *)REG_BG2PD = scaledown;
		*(vu32 *)REG_BG2X = ((256*256) - (240*scaledown))/2;
		*(vu32 *)REG_BG2Y = ((256*256) - (160*scaledown))/2;

		switch(bank)
		{
			case 0:
				*(vu16 *)REG_BG2CNT = BG_COLOR_256 | BG_SCREEN_SIZE_1 | BG_PRIORITY_2
					| 0 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;
				break;
			case 1:
				*(vu16 *)REG_BG2CNT = BG_COLOR_256 | BG_SCREEN_SIZE_1 | BG_PRIORITY_2
					| 1 << BG_SCREEN_BASE_SHIFT | 2 << BG_CHAR_BASE_SHIFT ;
				break;
		}

		stampdown++;
		if (stampdown > 16 && letter < (sizeof(lettertable)/sizeof(*lettertable))/2)
		{
			bank = !bank;
			stampdown = 0;
			DmaCompressedCopy(3, lettertable[letter*2], BG_VRAM + (0x4000*(1+bank)), 32);  //  Set BG character
			DmaWait(3);
			remap16charto8((u16*) lettertable[(letter*2)+1],(u8*)BG_VRAM+(0x800*(0+bank)),32*32);
			letter++;
			if (timeout > 15)
			{
				bldval = 12;
			}
		}

		if (controller_push & pad_start && timeout > 15)
		{
			timeout = 15;
		}

		counter++;
		timeout--;
	}

}



void DoBlendUpScreens(u16 x)
{
 	*(vu16 *)REG_BLDCNT =  BLD_UP_MODE |  BLD_BG0_1ST | BLD_BG1_1ST | BLD_BG2_1ST | BLD_BG3_1ST;
	*(vu16 *)REG_BLDY = x;
}

void DoBlendDownScreens(u16 x)
{
 	*(vu16 *)REG_BLDCNT =  BLD_DOWN_MODE |  BLD_BG0_1ST | BLD_BG1_1ST | BLD_BG2_1ST | BLD_BG3_1ST;
	*(vu16 *)REG_BLDY = x;
}

static int initname(char *name,u8 *sprites,int *pcharno,int *ppalette)
{
	int charno = *pcharno;
	int palette = *ppalette;
	int namelen = 0;
	int nameoffset = 0;
	int i,cnt;
	while (name[namelen])
	{
		namelen++;
	}

	// Load one palette
	LoadPalette(FontBigPalette,palette);

	for (cnt=0;cnt<namelen;cnt++)
	{
		titlefontletter = name[cnt] - 'A';
		i = GrabASprite();
		sprites[cnt] = i;
		Sprite[i].CharNo = charno;
		Sprite[i].Shape = 0;
		Sprite[i].Size = 1; //OAM_SIZE_16x16
		Sprite[i].Pltt = palette;
		Sprite[i].Priority = 0;
		Sprite[i].AffineMode = 0;
		Sprite[i].ObjMode = 0;
		Sprite[i].HPos = 200;
		Sprite[i].VPos = 160;
		LoadSprite((u32)FontBigSprite+(titlefontletter*128),charno * 32,(16*16)/2);
		charno+=2*2;
	}

	// Incr the palette used entry	
	palette++;

	*pcharno = charno;
	*ppalette = palette;

	return namelen;
}


#define CONVNIBBLE(x)	\
	if ((x)==0)	(x)=1;	\
	else if ((x)==1)	(x)=1;	\
	else if ((x)==2)	(x)=2;


static void invertsprite(u8 *dest,u8 *data,int len)
{
	int i;
	for (i=0;i<len;i++)
	{
		u8 nibble1,nibble2;
		nibble1 = data[i] & 15;
		nibble2 = (data[i]>>4) & 15;
		CONVNIBBLE(nibble1);
		CONVNIBBLE(nibble2);
		dest[i] = (nibble1&15) | ((nibble2&15)<<4);
	}
}

static int initnamevert(char *name,u8 *sprites,int *pcharno,int *ppalette,int xpos,int ypos)
{
	int charno = *pcharno;
	int palette = *ppalette;
	int namelen = 0;
	int nameoffset = 0;
	int i,cnt,namec;
	int x,y;
	u8 tempspr[128];
	u16 newpalette[16];
	int chartonanmesprite[16];

	// Because we are using the scale function we have to offset each char by half the width and height to make it match up
	xpos -= 8;
	ypos -= 8;

	newpalette[1] = 0x7fff;

	while (name[namelen])
	{
		namelen++;
	}

	for (i=0;i<namelen;i++)
	{
		chartonanmesprite[i] = charno;
		titlefontletter = name[i] - 'A';
		invertsprite(tempspr,(u8*)FontBigSprite+(titlefontletter*128),(16*16)/2);
		LoadSprite((u32)tempspr,charno * 32,(16*16)/2);
		charno+=2*2;
	}

	// Load one palette
	LoadPalette(newpalette,palette);

	cnt = 0;
	namec = 0;

//	y = ypos + (((-namelen*16)/2)+8);
	y = ypos + ((-(namelen-1)*16));
	while (y > -16)
	{
		titlefontletter = name[namec] - 'A';
		i = GrabASprite();
		sprites[cnt] = i;
 		Sprite[i].CharNo = chartonanmesprite[namec];
  		Sprite[i].Shape = 0;
		Sprite[i].Size = 1; //OAM_SIZE_16x16
		Sprite[i].Pltt = palette;
		Sprite[i].Priority = 0;
		Sprite[i].AffineMode = 0;
		Sprite[i].AffineParamNo_L = 1;
		Sprite[i].HFlip = 0;
		Sprite[i].VFlip = 0;
		Sprite[i].ObjMode = 0;
		Sprite[i].HPos = 200;
		Sprite[i].VPos = 160;

		y-=16;
		namec--;
		if (namec < 0)
		{
			namec = namelen-1;
		}
		cnt++;
	}
//	y = ypos + (((-namelen*16)/2)+8);
	y = ypos + ((-(namelen-1)*16));
	y += 16;
	namec = 1;
	while (y < 160)
	{
		titlefontletter = name[namec] - 'A';
		i = GrabASprite();
		sprites[cnt] = i;
 		Sprite[i].CharNo = chartonanmesprite[namec];
  		Sprite[i].Shape = 0;
		Sprite[i].Size = 1; //OAM_SIZE_16x16
		Sprite[i].Pltt = palette;
		Sprite[i].Priority = 0;
		Sprite[i].AffineMode = 0;
		Sprite[i].AffineParamNo_L = 1;
		Sprite[i].HFlip = 0;
		Sprite[i].VFlip = 0;
		Sprite[i].ObjMode = 0;
		Sprite[i].HPos = 200;
		Sprite[i].VPos = 160;

		y+=16;
		namec++;
		if (namec >= namelen)
		{
			namec = 0;
		}
		cnt++;
	}

	// Incr the palette used entry	
	palette++;

	*pcharno = charno;
	*ppalette = palette;

	return namelen;
}

static int initstar(int *pcharno,int *ppalette)
{
	int charno = *pcharno;
	int palette = *ppalette;
	int i;
	u8 tempspr[128];
	u16 newpalette[16];

	newpalette[1] = 0x7fff;
	for (i=0;i<(8*8)/2;i++)
	{
		tempspr[i] = 0;
	}
	tempspr[0] = 1|(1<<4);
	tempspr[4] = 1|(1<<4);

	LoadSprite((u32)tempspr,charno * 32,(8*8)/2);
	charno+=1*1;

	// Load one palette
	LoadPalette(newpalette,palette);

	// Incr the palette used entry	
	palette++;

	*pcharno = charno;
	*ppalette = palette;
}

static void initnamevertpos(int namelen,u8 *sprites,int xpos,int ypos)
{
	int nameoffset = 0;
	int i,cnt;
	int x,y;

	// Because we are using the scale function we have to offset each char by half the width and height to make it match up
	xpos -= 8;
	ypos -= 8;

	cnt = 0;

//	y = ypos + (((-namelen*16)/2)+8);
	y = ypos + ((-(namelen-1)*16));
	while (y > -16)
	{
		i = sprites[cnt];
		Sprite[i].AffineMode = 3;
		Sprite[i].AffineParamNo_L = 1;
		Sprite[i].HFlip = 0;
		Sprite[i].VFlip = 0;
		Sprite[i].HPos = xpos;
		Sprite[i].VPos = y;

		y-=16;
		cnt++;
	}
//	y = ypos + (((-namelen*16)/2)+8);
	y = ypos + ((-(namelen-1)*16));
	y += 16;
	while (y < 160)
	{
		i = sprites[cnt];
		Sprite[i].AffineMode = 3;
		Sprite[i].AffineParamNo_L = 1;
		Sprite[i].HFlip = 0;
		Sprite[i].VFlip = 0;
		Sprite[i].HPos = xpos;
		Sprite[i].VPos = y;

		y+=16;
		cnt++;
	}
}

static void initnamevertposoff(int namelen,u8 *sprites,int xpos,int ypos)
{
	int nameoffset = 0;
	int i,cnt;
	int x,y;

	// Because we are using the scale function we have to offset each char by half the width and height to make it match up
	xpos -= 8;
	ypos -= 8;

	cnt = 0;

//	y = ypos + (((-namelen*16)/2)+8);
	y = ypos + ((-(namelen-1)*16));
	while (y > -16)
	{
		i = sprites[cnt];
		Sprite[i].AffineMode = 3;
		Sprite[i].AffineParamNo_L = 1;
		Sprite[i].HFlip = 0;
		Sprite[i].VFlip = 0;
		Sprite[i].HPos = xpos;
		Sprite[i].VPos = 161;

		y-=16;
		cnt++;
	}
//	y = ypos + (((-namelen*16)/2)+8);
	y = ypos + ((-(namelen-1)*16));
	y += 16;
	while (y < 160)
	{
		i = sprites[cnt];
		Sprite[i].AffineMode = 3;
		Sprite[i].AffineParamNo_L = 1;
		Sprite[i].HFlip = 0;
		Sprite[i].VFlip = 0;
		Sprite[i].HPos = xpos;
		Sprite[i].VPos = 161;

		y+=16;
		cnt++;
	}
}

static int spinname(int xpos,int ypos,int angle,int namelen,u8 *sprites)
{
	int i,cnt;
//	int justify = ((-namelen*16)/2)+8;
	int justify = ((-(namelen-1)*16));
	angle = angle & 255;
	for (cnt=0;cnt<namelen;cnt++)
	{
		i = sprites[cnt];

		Sprite[i].HPos = xpos + ((justify * fsin[angle])/256);
		Sprite[i].VPos = ypos + ((justify * -fsin[((angle-64)&255)])/256);
		justify+=16;
	}
}

static int spinnamewhooshoff(int namelen,u8 *sprites)
{
	int i,cnt;
	for (cnt=0;cnt<namelen;cnt++)
	{
		int pos;
		i = sprites[cnt];

		if (Sprite[i].HPos < 240)
		{
			pos = Sprite[i].HPos;
			pos += (Sprite[i].HPos/32)+1;
			if (pos >= 240)
			{
				pos = 240;
			}
			Sprite[i].HPos = pos;
		}
		pos = Sprite[i].VPos;
		if (pos != 160)
		{
			if (cnt&1)
			{
				pos -= (cnt*2)+2;
			}
			else
			{
				pos += (cnt*2)+2;
			}
			if (pos < 0)
			{
				pos = 160;
			}
			if (pos > 160)
			{
				pos = 160;
			}
			Sprite[i].VPos = pos;
		}
	}
}

static int spinnameoff(int namelen,u8 *sprites)
{
	int i,cnt;
	for (cnt=0;cnt<namelen;cnt++)
	{
		i = sprites[cnt];

		Sprite[i].HPos = 200;
		Sprite[i].VPos = 160;
	}
}

static int spinnameveryoff(int namelen,u8 *sprites)
{
	int i,cnt;
	for (cnt=0;cnt<namelen;cnt++)
	{
		i = sprites[cnt];

		Sprite[i].HPos = 200;
		Sprite[i].VPos = 161;
	}
}

static void movestars(int numstars,u8 *sprites,int tick)
{
	int i;
	for (i=0;i<numstars;i++)
	{
		int scaleout = (tick + (i*176))&255;
		int zoom = (((numstars*120)/(((i-tick)%numstars)+1))/numstars);
		Sprite[sprites[i]].HPos = 120+((fsin[scaleout]*zoom)/256);
		zoom = (((numstars*80)/(((i-tick)%numstars)+1))/numstars);
		Sprite[sprites[i]].VPos = 80+((fsin[(scaleout+64)&255]*zoom)/256);
	}
}

void HBlankIntroBars(void)
{
	u16 line;
    line = *(vu16 *)REG_VCOUNT; 
	if(line < 160)
	{
		*(vu16 *)BG_PLTT = ((u16*)(WRAM+0x10000))[line];		// Magical spare piece of WRAM that is used for a rainbow
	}
	
	*(vu16 *)REG_IF	= H_BLANK_INTR_FLAG;
}

static u16 SaturateRGB(u16 colour,int saturation)
{
	return min(31,((colour>>0)&31)+saturation)
			| (min(31,((colour>>5)&31)+saturation)<<5)
			| (min(31,((colour>>10)&31)+saturation)<<10);
}

static void DoRainbowColour(int top,int bottom,u16 colourstart,u16 colourend,int saturation)
{
	int i;

	for (i=top;i<=bottom;i++)
	{
		u16 finalcolour = 0;
		finalcolour  = (((int)((colourstart>> 0) & 31) + ((((int)((colourend>> 0) & 31) - (int)((colourstart>> 0) & 31))*(i-top))/(bottom-top)))&31)<<0;
		finalcolour |= (((int)((colourstart>> 5) & 31) + ((((int)((colourend>> 5) & 31) - (int)((colourstart>> 5) & 31))*(i-top))/(bottom-top)))&31)<<5;
		finalcolour |= (((int)((colourstart>>10) & 31) + ((((int)((colourend>>10) & 31) - (int)((colourstart>>10) & 31))*(i-top))/(bottom-top)))&31)<<10;

		((u16*)(WRAM+0x10000))[i] = SaturateRGB(finalcolour,saturation);
	}
}

static u16 MakeRGB(int r,int g,int b)
{
	return ((r&255)>>3) + (((g&255)>>3)<<5) + (((b&255)>>3)<<10);
}

void DisplayBionicle()
{
	s8 fade;
	u8 a;
	s32 scalein;
	int count;
	u32 dest;
	u32 src;
	u8 x1,x2,x3;
	int i,cnt;
	int charno;
	int palette;
	u8 sprites[64];
	int angle = 0;
	int spinpalette;
	int vertpalette;
	int main3charno;
	int main3palette;
	int namelen;
	int cyclecount;
	int startick = 0;
	u16 barcontrol;

	DmaClear(3,0,WRAM+0x10000,256*2,32);		// Clear all of the rainbow data
	DmaWait(3);
	HBlankRoutine(HBlankIntroBars);

	*(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_ON |  DISP_OBJ_CHAR_1D_MAP; // LCDC ON

	WipeToWhite(15);	

	fade = 15;
//	FrontEndScreen();
    
	ArgoVBlank();
    DmaArrayClear(3,161,             Sprite,         32);  // Move undisplayed OBJ to outside of the screen
   	DmaWait(3);
    DmaArrayCopy(3, Sprite,          OAM,            32);
    DmaWait(3);

	num_strats = 0;
#if 1	
	// left to right whooshy characters

	KeyRead();
	
	*(vu16 *)REG_BG0CNT =                             // Set BG control for BG 0 (main game area)
		BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_2
		| 0 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;
	*(vu16 *)REG_BG1CNT =                             // Set BG control for BG 1 (front layer)
		BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_1
		| 1 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;
	*(vu16 *)REG_BG2CNT =                             // Set BG control for BG 2 (far background layer)
		BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_0
		| 2 << BG_SCREEN_BASE_SHIFT | 1 << BG_CHAR_BASE_SHIFT ;

//	*(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_ON |  DISP_BG0_ON |  DISP_BG1_ON | DISP_BG2_ON | DISP_OBJ_CHAR_1D_MAP; // LCDC ON
	*(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_ON |  DISP_OBJ_CHAR_1D_MAP; // LCDC ON

	WipeToWhite(15);	

  	MapActive = 0;
    DmaClear(3,(u16)32,BG_PLTT,6144,16);
    DmaWait(3);
    DmaArrayCopy(3, flashstripChar, BG_VRAM + 0x4000, 16);  //  Set BG character
    DmaWait(3);
    DmaArrayCopy(3, flashstripPalette, BG_PLTT,        32);  //  Set BG palette
    DmaWait(3);
    DmaArrayCopy(3, flashstripMap1,BG_VRAM,16);
	DmaWait(3);
    DmaArrayCopy(3, flashstripMap1,BG_VRAM + 2048,16);
	DmaWait(3);
    DmaArrayCopy(3, flashstripMap1,BG_VRAM + 4096,16);
	DmaWait(3);
    DmaArrayCopy(3, flashstripMap2,BG_VRAM + 2048,16);
	DmaWait(3);
    DmaArrayCopy(3, flashstripMap3,BG_VRAM + 4096,16);
	DmaWait(3);
	//  switch up a palette

	charno = 0;
	palette = 0;


	i = GrabASprite();
	sprites[0] = i;
 	Sprite[i].CharNo = charno;
  	Sprite[i].Shape = 0;
	Sprite[i].Size = 3; //OAM_SIZE_64x64
	Sprite[i].Pltt = palette;
    Sprite[i].Priority = 0;
    Sprite[i].AffineMode = 0;
	Sprite[i].ObjMode = 0;
	Sprite[i].HPos = 240;
	Sprite[i].VPos = -2;
	LoadSprite((u32)FEBohrokSprite,charno * 32,(64*64)/2);
	LoadPalette(FEBohrokPalette,palette);
	palette++;
	charno+=8*8;

	i = GrabASprite();
	sprites[1] = i;
 	Sprite[i].CharNo = charno;
  	Sprite[i].Shape = 0;
	Sprite[i].Size = 3; //OAM_SIZE_64x64
	Sprite[i].Pltt = palette;
    Sprite[i].Priority = 0;
    Sprite[i].AffineMode = 0;
	Sprite[i].ObjMode = 0;
	Sprite[i].HPos = 240;
	Sprite[i].VPos = 52;
	LoadSprite((u32)FETuragaSprite,charno * 32,(64*64)/2);
	LoadPalette(FETuragaPalette,palette);
	palette++;
	charno+=8*8;

	i = GrabASprite();
	sprites[2] = i;
 	Sprite[i].CharNo = charno;
  	Sprite[i].Shape = 0;
	Sprite[i].Size = 3; //OAM_SIZE_64x64
	Sprite[i].Pltt = palette;
    Sprite[i].Priority = 0;
    Sprite[i].AffineMode = 0;
	Sprite[i].ObjMode = 0;
	Sprite[i].HPos = 240;
	Sprite[i].VPos = 100;
	LoadSprite((u32)FEMatoranSprite,charno * 32,(64*64)/2);
	LoadPalette(FEMatoranPalette,palette);
	palette++;
	charno+=8*8;

/*
	for (cnt=0;cnt<32;cnt++)
	{
		i = GrabASprite();
		sprites[32+cnt] = i;
 		Sprite[i].CharNo = charno;
  		Sprite[i].Shape = 0;
		Sprite[i].Size = 0; //OAM_SIZE_8x8
		Sprite[i].Pltt = palette;
		Sprite[i].Priority = 3;
		Sprite[i].AffineMode = 0;
		Sprite[i].ObjMode = 0;
		Sprite[i].HPos = 128;
		Sprite[i].VPos = 80;
	}
	initstar(&charno,&palette);
	movestars(32,sprites+32,startick++);
*/

	main3charno = charno;
	main3palette = palette;


	// Now the loopable routine
	for (cyclecount=0;cyclecount<4;cyclecount++)
	{
		int spinxpos,spinypos;
		int xposs[3];

		ArgoVBlank();                           // Complete V Blank interrupt

		SpriteScaleFine(1,1,64);
		charno = main3charno;
		palette = main3palette;

		switch(cyclecount)
		{
			case 0:
				spinxpos = 128;
				spinypos = 70;
				barcontrol= DISP_MODE_0 | DISP_OBJ_ON |  DISP_BG0_ON | DISP_OBJ_CHAR_1D_MAP; // LCDC ON
				spinpalette = palette;
				namelen = initname("BOHROK",sprites+4,&charno,&palette);
				vertpalette = palette;
				ArgoVBlank();                           // Complete V Blank interrupt
				initnamevert("BOHROK",sprites+4+16,&charno,&palette,spinxpos,spinypos);
				break;
			case 1:
				spinxpos = 64;
				spinypos = 36;
				barcontrol = DISP_MODE_0 | DISP_OBJ_ON |  DISP_BG1_ON | DISP_OBJ_CHAR_1D_MAP; // LCDC ON
				spinpalette = palette;
//				namelen = initname("TURAGA",sprites+4,&charno,&palette);
// Backwards because it spins the other way
				namelen = initname("AGARUT",sprites+4,&charno,&palette);
				vertpalette = palette;
				ArgoVBlank();                           // Complete V Blank interrupt
//				initnamevert("TURAGA",sprites+4+16,&charno,&palette,spinxpos,spinypos);
// Backwards because it spins the other way
				initnamevert("AGARUT",sprites+4+16,&charno,&palette,spinxpos,spinypos);
				break;
			case 2:
				spinxpos = 148;
				spinypos = 80;
				barcontrol = DISP_MODE_0 | DISP_OBJ_ON |  DISP_BG2_ON | DISP_OBJ_CHAR_1D_MAP; // LCDC ON
				spinpalette = palette;
				namelen = initname("MATORAN",sprites+4,&charno,&palette);
				vertpalette = palette;
				ArgoVBlank();                           // Complete V Blank interrupt
				initnamevert("MATORAN",sprites+4+16,&charno,&palette,spinxpos,spinypos);
				break;
			case 3:
			default:
				barcontrol = DISP_MODE_0 | DISP_OBJ_ON |  DISP_BG0_ON |  DISP_BG1_ON | DISP_BG2_ON | DISP_OBJ_CHAR_1D_MAP;
				namelen = 0;
				break;
		}

		*(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_ON | DISP_OBJ_CHAR_1D_MAP;

	//fsin

		{
			u16 Palette[16] ={ // palette data
			0x7c1f,0x0000,0x7fff,0x1b40,0x1764,0x1389,0x0fad,0x0fd2,0x0bf6,0x03fd,0x039f,0x02ff,0x067e,0x05dd,0x093c,0x089c,
			};
			LoadPalette(Palette,spinpalette);
		}

		count = 0;
		SpriteScaleFine(1,1,64);

#define VERTTEXTFADEIN	(32+25+1)
#define VERTTEXTFADEOUT	(32+25+96+16)
#define SPINTEXTFADEIN	(32+25+96)
#define SPINTEXTSPIN	(32+25+128)
#define SPINWHOOSHOFF	(32+25+300)
#define BARFADEIN1		(0)
#define BARFADEINWHITE	(14)
#define BARFADEIN2		(16)
#define BARFADEOUT		(32+25+356)

		while(count < BARFADEOUT )
		{
			int sizex;


  			KeyRead();                                  // Key control
			ArgoVBlank();                           // Complete V Blank interrupt

//			*(vu16 *)REG_DISPCNT = DISP_MODE_0 | DISP_OBJ_ON |  DISP_OBJ_CHAR_1D_MAP;
			if (count >= BARFADEIN1 && count < BARFADEIN2)
			{
				int scalar;
				int saturate;
				saturate=0;
				scalar = (256 * (count - BARFADEIN1)) / (BARFADEIN2-BARFADEIN1);
				if (count > BARFADEINWHITE)
				{
					saturate = (count - BARFADEINWHITE)*(32/(BARFADEIN2-BARFADEINWHITE));
				}

				switch(cyclecount)
				{
					case 0:
						DoRainbowColour(33 - ((scalar * 30)/256),33,MakeRGB(0,138,0),0x7fff,saturate);
						DoRainbowColour(33, 33 + ((scalar * (52-33))/256),0x7fff,MakeRGB(0,148,0),saturate);
						break;
					case 1:
						DoRainbowColour(88 - ((scalar * (88-57))/256),88,MakeRGB(247,121,0),0x7fff,saturate);
						DoRainbowColour(88, 88 + ((scalar * (108-88))/256),0x7fff,MakeRGB(247,147,0),saturate);
						break;
					case 2:
						DoRainbowColour(140 - ((scalar * (140-112))/256),140,MakeRGB(0,0,160),0x7fff,saturate);
						DoRainbowColour(140, 140 + ((scalar * (159-140))/256),0x7fff,MakeRGB(0,16,189),saturate);
						break;
					case 3:
						DoRainbowColour(33 - ((scalar * 30)/256),33,MakeRGB(0,138,0),0x7fff,saturate);
						DoRainbowColour(33, 33 + ((scalar * (52-33))/256),0x7fff,MakeRGB(0,148,0),saturate);
						DoRainbowColour(88 - ((scalar * (88-57))/256),88,MakeRGB(247,121,0),0x7fff,saturate);
						DoRainbowColour(88, 88 + ((scalar * (108-88))/256),0x7fff,MakeRGB(247,147,0),saturate);
						DoRainbowColour(140 - ((scalar * (140-112))/256),140,MakeRGB(0,0,160),0x7fff,saturate);
						DoRainbowColour(140, 140 + ((scalar * (159-140))/256),0x7fff,MakeRGB(0,16,189),saturate);
						break;
				}
			}

			if (count == BARFADEIN2)
			{
				*(vu16 *)REG_DISPCNT = barcontrol;
				DoBlendUpScreens(15);		// White out
			}

			if (count == BARFADEIN2+1)
			{
				DmaClear(3,0,WRAM+0x10000,256*2,32);		// Clear all of the rainbow data
				DmaWait(3);
			}

 			if(count < (15+BARFADEIN2) && count >= BARFADEIN2)
			{
 				DoBlendUpScreens(14 - (count-BARFADEIN2)); 
			}
			if (count < BARFADEIN2)
			{
				DoBlendUpScreens(0);
			}



//			movestars(32,sprites+32,startick++);

			if (count <= BARFADEIN2)
			{
				xposs[0] = 240;
				xposs[1] = -64;
				xposs[2] = 240;
			}

			if (count > BARFADEIN2)
			{
				switch(cyclecount)
				{
					case 0:
						xposs[0]-=8;
						if (xposs[0] < 32)
						{
							xposs[0] = 32;
						}
						break;
					case 1:
						xposs[1]+=8;
						if (xposs[1] > 144)
						{
							xposs[1] = 144;
						}
						break;
					case 2:
						xposs[2]-=8;
						if (xposs[2] < 32)
						{
							xposs[2] = 32;
						}
						break;
					case 3:
						xposs[0]--;
						xposs[1]++;
						xposs[2]--;
						if (xposs[0] < 32)
						{
							xposs[0] = 32;
						}
						if (xposs[1] > 144)
						{
							xposs[1] = 144;
						}
						if (xposs[2] < 32)
						{
							xposs[2] = 32;
						}
						Sprite[sprites[0]].VPos = -9;
						Sprite[sprites[1]].VPos = 44;
						break;
				}
			}

			Sprite[sprites[0]].HPos = xposs[0];
			Sprite[sprites[1]].HPos = xposs[1];
			Sprite[sprites[2]].HPos = xposs[2];

			if (count < (BARFADEOUT-15) && controller_push & pad_start)
			{
	//			count = 1300-15;
				count = BARFADEOUT-15;
				cyclecount = 255;
			}
			if (count >= (BARFADEOUT-15) && controller_push & pad_start)
			{
				cyclecount = 255;
			}

			if (namelen > 0)
			{
				if (count == 0)
				{
					SpriteScaleFine(1,1,64);
					initnamevertpos(namelen,sprites+4+16,255,spinypos);
					spinnameoff(namelen,sprites+4);
				}


				if (count == VERTTEXTFADEIN)
				{
					SpriteScaleFine(1,1,64);
					initnamevertpos(namelen,sprites+4+16,spinxpos,spinypos);
				}

				if (count >= VERTTEXTFADEIN && count < (VERTTEXTFADEIN+64))
				{
					int val = count - VERTTEXTFADEIN;
					int fsinval;
					fsinval = ((64-val)*300)/64;
					fsinval = fsinval & 255;

					initnamevertpos(namelen,sprites+4+16,spinxpos+(fsin[fsinval]/2),spinypos);
					

					val = val/4;
					if (val < 1)
					{
						val = 1;
					}
					SpriteScaleFine(1,(64 * val)/16,64);
				}
				else if (count > VERTTEXTFADEOUT)
				{
					sizex = 16 - ((count - VERTTEXTFADEOUT)/2);
					if (sizex <= 0 || sizex > 16)
					{
						SpriteScaleFine(1,1,64);
						initnamevertpos(namelen,sprites+4+16,255,spinypos);
					}
					else
					{
						SpriteScaleFine(1,(64 * sizex)/16,64);
					}
				}
				else if (count >= VERTTEXTFADEIN && count <= VERTTEXTFADEOUT)
				{
					initnamevertpos(namelen,sprites+4+16,spinxpos,spinypos);
					SpriteScaleFine(1,64,64);
				}

				if (count == SPINTEXTFADEIN)
				{
					spinname(spinxpos,spinypos,0,namelen,sprites+4);
				}
				if (count >= SPINTEXTFADEIN && count <= (SPINTEXTFADEIN+15))
				{
					int col = (count - SPINTEXTFADEIN)*2;
					u16 Palette[16];
					Palette[1] = 0;
					Palette[2] = col | (col<<5) | (col<<10);
					LoadPalette(Palette,spinpalette);
				}
				if (count == (SPINTEXTFADEIN+16))
				{
					int col = 31;
					u16 Palette[16];
					Palette[1] = 0;
					Palette[2] = col | (col<<5) | (col<<10);
					LoadPalette(Palette,spinpalette);
				}
				if (count == (SPINTEXTSPIN-16))
				{
					angle = 0;
				}
				if (count >= (SPINTEXTSPIN-16) && count <= ((SPINTEXTSPIN+32)-16))
				{
					if (angle > 64)
					{
						angle = 64;
					}
					if (cyclecount == 1)
					{
						spinname(spinxpos,spinypos,-angle,namelen,sprites+4);
					}
					else
					{
						spinname(spinxpos,spinypos,angle,namelen,sprites+4);
					}
					angle +=2;
				}
				if (count < SPINTEXTFADEIN)
				{
					spinnameoff(namelen,sprites+4);
				}
				if (count > SPINWHOOSHOFF)
				{
					spinnamewhooshoff(namelen,sprites+4);
				}
			}

 			if(count > (BARFADEOUT-15))
			{
 				DoBlendUpScreens( 15-(BARFADEOUT-count) );
			}

	//	*(vu16 *)REG_BLDCNT =  BLD_UP_MODE |  BLD_BG0_1ST;
	//	*(vu16 *)REG_BLDY = 15;

 			count++;
 			*(vu16 *)REG_BG0VOFS = 0;
			*(vu16 *)REG_BG0HOFS = x1;
			*(vu16 *)REG_BG1VOFS = -54;
			*(vu16 *)REG_BG1HOFS = x2;
			*(vu16 *)REG_BG2VOFS = -108;
			*(vu16 *)REG_BG2HOFS = x3;
			
			
			x1+=8;
			x2-=8;
			x3+=12;
	//   		handle_strats();
		
		}

		SpriteScaleFine(1,1,64);
		initnamevertposoff(namelen,sprites+4+16,255,spinypos);
		spinnameveryoff(namelen,sprites+4);
	} 
 #endif
 		*(vu16 *)REG_BG0VOFS = 0;
		*(vu16 *)REG_BG0HOFS = 0;
		*(vu16 *)REG_BG1VOFS = 0;
		*(vu16 *)REG_BG1HOFS = 0;
		*(vu16 *)REG_BG2VOFS = 0;
		*(vu16 *)REG_BG2HOFS = 0;

	HBlankRoutine(HBlankGame);

	if (cyclecount < 255)
	{
		DisplayLetterWhoosh();
	}
}



void inittitlechar1(void)
{
	u32 i;
	u8 me;
	u16 x;
	
	me = Object[num_strats].parameter;
	
	
	titlesprite[me].frame = GrabASprite();
	Object[num_strats].handle = HandleTitleCharSprite;
	Object[num_strats].remover = 0;
	
	i = titlesprite[me].frame;
      	Sprite[i].CharNo = me * 64;
       	Sprite[i].Shape = 0;
   		Sprite[i].Size = 3; //OAM_SIZE_64x64;
   		Sprite[i].Pltt = me;
         Sprite[i].Priority = 0;
	    Sprite[i].AffineMode = 0; // off 3; // on and double size
   		Sprite[i].ObjMode = 0; // trans effect
     titlesprite[me].xpos = parm_xpos;
        titlesprite[me].ypos = parm_ypos;
		titlesprite[me].tx = wp_xpos;
		LoadSprite((u32)FEBohrokSprite,me * 2048,2048);
		LoadPalette(FEBohrokPalette,me);	
}


void inittitlechar2(void)
{
	u32 i;
	u8 me;
	u16 x;
	
	me = Object[num_strats].parameter;
	
	
	titlesprite[me].frame = GrabASprite();
	Object[num_strats].handle = HandleTitleCharSprite;
	Object[num_strats].remover = 0;
	
	i = titlesprite[me].frame;
      	Sprite[i].CharNo = me * 64;
       	Sprite[i].Shape = 0;
   		Sprite[i].Size = 3; //OAM_SIZE_64x64;
   		Sprite[i].Pltt = me;
         Sprite[i].Priority = 0;
	    Sprite[i].AffineMode = 0; // off 3; // on and double size
   		Sprite[i].ObjMode = 0; // trans effect
     titlesprite[me].xpos = parm_xpos;
        titlesprite[me].ypos = parm_ypos;
		titlesprite[me].tx = wp_xpos;
	LoadSprite((u32)FETuragaSprite,me * 2048,2048);
	LoadPalette(FETuragaPalette,me);	
}


void inittitlechar3(void)
{
	u32 i;
	u8 me;
	u16 x;
	
	me = Object[num_strats].parameter;
	
	
	titlesprite[me].frame = GrabASprite();
	Object[num_strats].handle = HandleTitleCharSprite;
	Object[num_strats].remover = 0;
	
	i = titlesprite[me].frame;
 	Sprite[i].CharNo = me * 64;
  	Sprite[i].Shape = 0;
	Sprite[i].Size = 3; //OAM_SIZE_64x64;
	Sprite[i].Pltt = me;
    Sprite[i].Priority = 0;
    Sprite[i].AffineMode = 0; // off 3; // on and double size
	Sprite[i].ObjMode = 0; // trans effect
     titlesprite[me].xpos = parm_xpos;
   titlesprite[me].ypos = parm_ypos;
	titlesprite[me].tx = wp_xpos;
		LoadSprite((u32)FEMatoranSprite,me * 2048,2048);
		LoadPalette(FEMatoranPalette,me);	
}

void inittitleletter(void)
{
	u32 i;
	u8 me;
	u16 x;
	
	me = Object[num_strats].parameter;
	
	titlesprite[me].frame = GrabASprite();
	Object[num_strats].handle = HandleTitleCharNameSprite;
	Object[num_strats].remover = 0;
	
	i = titlesprite[me].frame;
 	Sprite[i].CharNo = me * 64;
  	Sprite[i].Shape = 0;
	Sprite[i].Size = 1; //OAM_SIZE_64x64;
	Sprite[i].Pltt = me;
    Sprite[i].Priority = 0;
    Sprite[i].AffineMode = 0; // off 3; // on and double size
	Sprite[i].ObjMode = 0; // trans effect
     titlesprite[me].xpos = parm_xpos;
   titlesprite[me].ypos = parm_ypos;
	titlesprite[me].tx = wp_xpos;
		LoadSprite((u32)FontBigSprite+(titlefontletter*128),me * 2048,128);
		LoadPalette(FontBigPalette,me);	
}


void HandleTitleCharSprite(void)
{
	s16 sprx,spry;
	s8 dx;
	u8 me;
	u16 x;
	
	me = Object[current_strat].parameter;
	mysprite = titlesprite[me].frame;
	if(titlespritecount >= me)
	{
		titlesprite[me].xpos += smin(titlesprite[me].tx - titlesprite[me].xpos,8);
		if(titlesprite[me].xpos == titlesprite[me].tx && titlespritecount == me)
		{
			titlespritecount++;
			Sample_Play(SMPL_SWINGING_BOULDER01);
		}
	}
	sprx = titlesprite[me].xpos;
	spry = titlesprite[me].ypos;

	Sprite[mysprite].CharNo = me * 64;
	Sprite[mysprite].HPos = sprx & 511;
	Sprite[mysprite].VPos = (spry + 256) & 255;
}

void HandleTitleCharNameSprite(void)
{
	s16 sprx,spry;
	s8 dx;
	u8 me;
	u16 x;
	
	me = Object[current_strat].parameter;
	mysprite = titlesprite[me].frame;

	sprx = titlesprite[me].xpos;
	spry = titlesprite[me].ypos;

	Sprite[mysprite].CharNo = me * 64;
	Sprite[mysprite].HPos = sprx & 511;
	Sprite[mysprite].VPos = (spry + 256) & 255;
}
