/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
#include "player.h"
#include "door.h"
#include "main.h"
#include "switch.h"
#include "doorsprites.h"
#include "SampleManager.h"

u16 currsprite;
u8 frameclock;
doorparms doors[MAX_DOORS];
u8 lastdoor;
u8 ThroughDoor;
u8 ThroughDoorOveride;
extern s16 game_x;
extern s16 game_y;

void HandleDoor(void);

u8 NextDoor()
{
	u8 a;
	for(a = 0; a < MAX_DOORS;a++)
	{
		if(doors[a].xpos == 0)
		{
			return a;
		}
	}
	return 0;
}

void RemoveDoor(void)
{
	u8 me;
	me = Object[current_strat].parameter;
	doors[me].xpos = 0;
}



void initdoor(void)
{
	u32 i;
	u8 me;
	
	ThroughDoorOveride = 0;
	me = NextDoor();
	Object[num_strats].handle = HandleDoor;
	Object[num_strats].remover = RemoveDoor;
    doors[me].xpos = parm_xpos;
    doors[me].ypos = parm_ypos;
    doors[me].switchnum = Object[num_strats].parameter;
    Object[current_strat].parameter = me;
	doors[me].targx = wp_xpos;
	doors[me].targy = wp_ypos;
	lastdoor = 99;
	ThroughDoor = 0;
}

void initdoor2(s16 doortargetx,s16 doortargety)
{
	doors[lastdoor].targx = doortargetx;
	doors[lastdoor].targy = doortargety;
	lastdoor = 99;
}

void HandleDoor(void)
{
	u8 me;
	u8 jump;
	me = Object[current_strat].parameter;
	
	// avoid fading back if just started fading
	
//	if(doors[me].switchnum == 100) // cheat
//	{
//		if((controller & (pad_L | pad_R)) == (pad_L | pad_R) && (player.xpos != restart_xpos))
//		{
//			player.xpos = doors[me].xpos;
//			player.ypos = doors[me].ypos;
//		}
//	}
	if(fadeto == fadetolevel)
	{
	
		if(abs(player.xpos - doors[me].xpos) < 32 && abs(player.ypos - doors[me].ypos) < 32)
		{
			if(lastdoor != me)
			{
				if(ThroughDoor > 0)
				{
					if(fadetolevel == 15 && fadeto == 15)
					{
						lastdoor = me;
						ThroughDoor = 0;
						fadeto = 0;
						Freeze_Player = 0;
					}
				}
				else
				{
					jump = 0;
					if(doors[me].switchnum >= 99)
						jump = 1;
					else
						jump = tswitch[doors[me].switchnum].state;

					if(jump)
					{		
						
						if(doors[me].switchnum == 100) // next level
						{
							NextLevel = 1;
							fadeto = 0;
							remove();
						}
						else
						{
							player.xpos = doors[me].targx;
							player.ypos = doors[me].targy;
							fadeto = 15;
							Freeze_Player = 1;
							ThroughDoor = 15;
							ThroughDoorOveride = 20;
						}
					}
				}
			}
			else // lastdoor == me
			{
				
			}
		
		}
		else
		{
			if(lastdoor == me)
				lastdoor = 99;
		}
	}
}

void initdoorsprite(void)
{
	u32 i;
	u8 me;
	
	me = NextDoor(); //Object[num_strats].parameter; // what switch to use (99 = no switch)
	doors[me].targx = (GrabASprite() << 8) + GrabASprite();
	Object[num_strats].handle = HandleDoorSprite;
	Object[num_strats].remover = RemoveDoor;
	i = (doors[me].targx >> 8);
      	Sprite[i].CharNo = DOOR_SPRITE;
       	Sprite[i].Shape = DoorSizeShape[1];
   		Sprite[i].Size = DoorSizeShape[0]; //OAM_SIZE_64x64;
   		Sprite[i].Pltt = 8;
         Sprite[i].Priority = 2;
#if 0
	if(doubledoor[Game_Area])
	{
		i = (doors[me].targx & 255);
	      	Sprite[i].CharNo = DOOR_SPRITE;
	       	Sprite[i].Shape = DoorSizeShape[1];
	   		Sprite[i].Size = DoorSizeShape[0]; //OAM_SIZE_64x64;
	   		Sprite[i].Pltt = 8;
	   		Sprite[i].HFlip = 1;
	         Sprite[i].Priority = 2;
	 }
#endif 
        doors[me].xpos = parm_xpos;
        doors[me].ypos = parm_ypos;
        doors[me].targy = 0; // recycled as frame number
        doors[me].switchnum = Object[num_strats].parameter;
 
 	Object[num_strats].parameter = me;

}

void HandleDoorSprite(void)
{
	u8 me;
	u8 state;
	s16 sprx,spry;
	
	
	me = Object[current_strat].parameter;
	mysprite = (doors[me].targx >> 8);
	sprx = doors[me].xpos - game_x;
	spry = doors[me].ypos - game_y - 64 - doors[me].targy;
   if(doors[me].switchnum >= 99)
   	state = 1;
   else
   	state = tswitch[doors[me].switchnum].state;
	
	if(sprx >= -32 && sprx < 240 && spry >= -32 && spry <= 160)
	{
		Sprite[mysprite].CharNo = DOOR_SPRITE;
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		
#if 0
		if(doubledoor[Game_Area])
		{
			mysprite = (doors[me].targx & 255);
			Sprite[mysprite].CharNo = DOOR_SPRITE;
			Sprite[mysprite].HPos = (sprx + 32) & 511;
			Sprite[mysprite].VPos = (spry + 256) & 255;
		}
#endif
		// handle open/close
		
		if(state == 1)
		{
			if(doors[me].targy == 0)
				Sample_Play(SMPL_DOOR_OPEN);
			if(doors[me].targy < 64)
				doors[me].targy++;
			
		}
		else
		{
			if(doors[me].targy > 0)
				doors[me].targy--;
			if(player.ypos > (doors[me].ypos - 96) && player.ypos < (doors[me].ypos + 48))
			{
				if(player.xpos < doors[me].xpos + 16 && player.xpos > doors[me].xpos - 16 )
					if(player.dx > 0)
					{
						player.dx = 0;
						player.xpos = doors[me].xpos - 16;
					}
				if(player.xpos > doors[me].xpos + 16 && player.xpos < doors[me].xpos + 64)
					if(player.dx < 0)
					{
						player.dx = 0;
						player.xpos = doors[me].xpos + 64;
					}
			}
		}		

	}
	else
	{
		Sprite[mysprite].VPos = 160;
	//	mysprite = (doors[me].targx & 255);
	//	Sprite[mysprite].VPos = 160;
	}
}