/******************************************/
/*										  */
/*  ASL Defines for GBA					  */
/* Aaron Fothergill, Argonaut Software    */
/* Oct 2001								  */
/******************************************/

#include <AGB.h>
#include <AgbEeprom.h>
#include "asldefines.h"
#include "player.h"
#include "main.h"
#include "memorycard.h"
#include "menubutton.h"
#include "text.h"

u16 SaveGame[64]; // save game buffer
u8 GameSlot[2]; 
u8 MemCard_Active;

void memcardinit(void)
{

     *(vu16 *)REG_DISPCNT&=~DISP_OBJ_ON;       // OBJ off
	SampleManager_Halt();
//	VBlankIntrWait();                           // Complete V Blank interrupt
	IntrTable[0] = IntrDummy;
	IntrTable[1] = IntrDummy;
	*(vu16 *)REG_IME = 0;
//	*(vu16 *)REG_IF = 0xffff;


  //  *(u16 *)INTR_CHECK_BUF = V_BLANK_INTR_FLAG | H_BLANK_INTR_FLAG;     // Set V Blank interrupt check

   SetEepromTimerIntr(3,&IntrTable[6]);  // User Timer 3

	
MapActive = 0;
	MemCard_Active = 1;

}

void memcarddone(void)
{
    *(vu16 *)REG_DISPCNT |= DISP_OBJ_ON;       // OBJ off
   IntrTable[6] = IntrDummy;      //< Timer 3 interrupt
	IntrTable[0] = VBlankIntr;
	IntrTable[1] = HBlankFast;
	MapActive = 1;
	MemCard_Active = 0;
    *(vu16 *)REG_IE    = V_BLANK_INTR_FLAG | H_BLANK_INTR_FLAG;           // Permit V blank interrupt
                    //   | CASSETTE_INTR_FLAG;          // Permit cassette interrupt
}

u16 memcardwrite(u8 length,u8 slot)
{
	u16 a;
	u16 result;
	u16 * source;
	
	
//	memcardinit();
	// write
	if(slot < 2)
		GameSlot[slot] = 0;
		
	source = SaveGame;
	result = 0;
   for(a = 0 ; a < length ; a++) 
   {
       result = ProgramEepromDword((a + slot * 16),source);           // Write
        source += 4;
	    if(result)
	    {
	    	//a = result;
	    	return result; // error writing
    	}
    }
	// verify
    
	source = SaveGame;
	
   for(a = 0 ; a < length ; a++) 
   {
        result=VerifyEepromDword(a + slot * 16,source);    // Verify
        if(result)
           return result; // error verifying
        source += 4;
    }

	if(slot < 2)
		GameSlot[slot] = SaveGame[2] + (SaveGame[3] * 8) + 1;
	
	
	
	return 0;
	
	
}

u16 memcardread(u8 length,u8 slot)
{
	u8 a;
	u8 result;
	u16 * source;
	
	source = SaveGame;
	
	for(a = 0; a < length; a++)
	{
		result = ReadEepromDword(a + slot * 16,source); // read
		if(result)
			return result; // error reading
        source += 4;
	}
	

	return 0;
}

void MemCardError(u8 err)
{
	Screen3(1);
	TextOn();
	TextClear();

	TextCentre(0,64,&ButtonText[Lingo][69][0]);
	TextCentre(0,80,&ButtonText[Lingo][70][0]);
	TextCentre(0,96,&ButtonText[Lingo][71][0]);

	while((controller_push & pad_A))
	{
		KeyRead();                                  // Key control
        ArgoVBlank();                           // Complete V Blank interrupt

	}


	while(!(controller_push & pad_A))
	{
		KeyRead();                                  // Key control
        ArgoVBlank();                           // Complete V Blank interrupt

	}
	TextOff();
	Screen3(0);
}