/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
//#include "data.h"
#include "player.h"
#include "HealthPanel.h"
#include "main.h"
#include "font.h"
#include "torchcover.h"


u8 frameclock;
u8 healthframe;
u8 lifesprite;
u8 energyframe;
u8 oldhealth;
u8 oldenergy;
u8 oldlives;
u16 healthcolour;
u16 epcolour;
u16 offcolour;

u16 panellight[8] = {0x013f,0x05df,0x1e5f,0x32df,0x4b1f,0x7ff5,0x7fe8,0x7f20};

void HandlePanel(void);

void initpanel(void)
{

		lifesprite = GrabASprite();
	healthframe = GrabASprite();
	Object[num_strats].handle = HandlePanel;
	Object[num_strats].remover = 0;
	   	Sprite[healthframe] = *(OamData *)OamData_Sample;
      	Sprite[healthframe].CharNo = PANEL_SPRITE1;
   		Sprite[healthframe].Size = 2; //OAM_SIZE_32x32;
   		Sprite[healthframe].Pltt = 14; // panel 1 palette
        Sprite[healthframe].Priority = 0;
        Sprite[healthframe].HPos = 4;
        Sprite[healthframe].VPos = 4;
     	Sprite[lifesprite].VPos = 1;
       LoadSprite(HealthPanelSprite,PANEL_SPRITE1_OFFSET,PANEL_SPRITE1_SIZE);
		oldlives = 255;
		oldhealth =255;
		oldenergy = 255;
		healthcolour = HealthPanelPalette[1];
		epcolour = HealthPanelPalette[6];
		offcolour = HealthPanelPalette[12];
}


void HandlePanel(void)
{
	u8 display;
	u8 a;
	u16 bgr;
	u16 *ptr;
	
	Sprite[healthframe].CharNo = PANEL_SPRITE1;
	Sprite[lifesprite].CharNo = FONT_SPRITE;
	if(player.health != oldhealth)
	{
		// change palette for health display to show new health
	//	AGBPrint("Update Health Display\n");
	//	AGBPrintFlush();
		display = max(0,min(4,player.health - 1));
		for(a = display; a < 4 ; a++)
		{
	
			ptr = (u16 *)(OBJ_PLTT + (14 * 32) + (a * 2)+ 2);
			*ptr = offcolour;
		}
		for(a = 0; a< display;a ++)
		{
			ptr = (u16 *)(OBJ_PLTT + (14 * 32) + (a * 2) + 2);
			*ptr = healthcolour;
		}
		oldhealth = player.health;
	}
	if(player.elemental_power != oldenergy || elem_power_level > 59)
	{
		// change palette for health display to show new health
	
		display = min(3,player.elemental_power); 
	//	AGBPrintf("Update Power Display %d\n",display);
	//	AGBPrintFlush();
		
		for(a = display ; a < 3 ; a++)
		{
	
			ptr = (u16 *)(OBJ_PLTT + (14 * 32) + (a * 2)+ 12);
			*ptr = offcolour;
		}
		for(a = 0; a < display;a ++)
		{
			ptr = (u16 *)(OBJ_PLTT + (14 * 32) + (a * 2)+ 12);
			if((elem_power_level > 59) && ((GameClock & 16) == 0))
			{
				*ptr = 0x7fff;
				oldenergy = 255;
			}
			else
			{
				*ptr = epcolour;
			}
		}
		oldenergy = player.elemental_power;
	}
	if(player.lives != oldlives)
	{
		// update lives digit
	//	AGBPrintf("Update Lives Display %d\n",player.lives);
	//	AGBPrintFlush();
		display = player.lives + 30;
	   	Sprite[lifesprite] = *(OamData *)OamData_Sample;
	    Sprite[lifesprite].Priority = 0;
	    Sprite[lifesprite].Size = 0;
	    Sprite[lifesprite].Shape = 0;
		Sprite[lifesprite].CharNo = FONT_SPRITE;
		Sprite[lifesprite].Pltt = 15;
		Sprite[lifesprite].VPos = 16;
		Sprite[lifesprite].HPos = 19;
		LoadSprite(FontSprite + display * 32 ,FONT_SPRITE_OFFSET,FONT_SPRITE_SIZE);
		TextColour(31,31,31);
		oldlives = player.lives;
		if(Game_Area == 5) // onu_wahi. refresh torch colour
		{
			DmaCopy(3,TorchCoverPalette + 480,BG_PLTT + 480,32,16);
			DmaWait(3);
		}

		
	}

		

}
