/* Particles.h


*/

#ifndef _PARTICLES_H
#define _PARTICLES_H

typedef struct {
	OamData sprite;
	s32 xpos;
	s32 ypos;
	s8 dx;		// delta x
	s8 dy;		// delta y
	u8 time;	// when 0, kill particle
	s8 grav_x;	// to be added to dx
	s8 grav_y;	// to be added to dy 
	u8 charno; // character number
	u8 fx;     // special fx type (0 = normal)
	u8 t;	// toggle value
} particle_type;


typedef struct {
	s16 xpos;
	s16 ypos;
	u16 charno;
	u8 time;
	u8 frame;
	u8 shape;
	u8 size;
	u8 pal;
} trailtype;

typedef struct {
	s16 xpos;
	s16 ypos;
	u8 frame;
	u8 clock;
	s8 dx;
	s8 dy;
	u8 spin;
} blasttype;

particle_type particle[64];
u8 numparticles;
u8 flash_scroll_x,flash_scroll_y;
s16 flash_x,flash_y;
u8 flash_scale;
u8 flash_base;

s8 rain_x,rain_y;
u8 torchactive;

void InitParticles(void);
u16 spawnparticle(s16 xpos,s16 ypos,s8 dx,s8 dy,s8 grav_x,s8 grav_y,u8 time,u8 charno,u8 fx);
void DoParticles(void);
void SpawnParticleSplash(s16 xpos,s16 ypos,u8 charno);
void SpawnParticleLeafSplash(s16 xpos,s16 ypos,u8 charno);
void SpawnParticleDriftUp(s16 xpos,s16 ypos,u8 charno);
void SpawnParticleRing(s16 xpos,s16 ypos,s8 dx,s8 dy,u8 charno);
void SpawnParticleInverseRing(s16 xpos,s16 ypos,s8 dx,s8 dy,u8 charno);
void SpawnParticleBlast(s16 xpos,s16 ypos);
void initflash(void);
void HandleFlash(void);
void StartRain(void);
void StartTorch(void);
u8 inittrailsprite(s16 xpos,s16 ypos,u16 CharNo,u8 size,u8 shape,u8 pal);
void handletrailsprites(void);
void SetSpriteColour(u8 index,u8 red, u8 green, u8 blue);
void initrainswitch(void);
void HandleRainSwitch(void);

u8 CheckBlasts(void);

void initbaddyblast(void);
void HandleBlast(void);

void initdiskpower(void);
void HandleDiskPower(void);

void initplayerpower(void);
void HandlePlayerPower(void);

void initbosspower(void);
void HandleBossPower(void);

#endif

