/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
#include "player.h"
#include "platform.h"
#include "main.h"
#include "switch.h"
//#include "data.h"
#include "platformsprite.h"
#include "SampleManager.h"
#include "tawahibridge.h"

u16 currsprite;
u8 frameclock;
u8 movingplatformpair;

platparms platform[MAX_PLATFORMS];
plankparms plank[16];

OamData PlatformTemplate;
OamData	PlatformTemplate2;
OamData PlankTemplate;

extern s16 game_x;
extern s16 game_y;

void HandlePlatform(void);

void HandleBridge(void);

u8  NextPlatform(void)
{
	u8 a;
	for(a = 0; a < MAX_PLATFORMS;a++)
	{
		if(platform[a].active == 0)
		{
			platform[a].active = 1;
			return a;
		}
	}
	return 0;
}

void RemovePlatform(void)
{

	u8 me;
	me = Object[current_strat].parameter;
	platform[me].active = 0;
}


void initplatform(void)
{
	u8 me;
	
	
	//PlatformTemplate = 0;
	PlatformTemplate.CharNo = PLATFORM_SPRITE;
	PlatformTemplate.Shape = 0;
	PlatformTemplate.Size = 3;
	PlatformTemplate.Pltt = 8;
	PlatformTemplate.Priority = 2;

	PlatformTemplate2.CharNo = PLATFORM_SPRITE + 64; // falling platform
	PlatformTemplate2.Shape = 0;
	PlatformTemplate2.Size = 3;
	PlatformTemplate2.Pltt = 8;
	PlatformTemplate2.Priority = 2;


	me = NextPlatform(); //Object[num_strats].parameter; // what switch to use (99 = no switch)
	Object[num_strats].handle = HandlePlatform;
    Object[num_strats].remover = RemovePlatform;
        platform[me].xpos = parm_xpos;
        platform[me].ypos = parm_ypos;
        platform[me].LinkedSwitch = Object[num_strats].parameter;
        platform[me].dx = 0;	// recycle. crumbled triggered
        platform[me].xposL = 0; //
        if(platform[me].LinkedSwitch >= 99)
        	platform[me].state = 1;
        else
        	platform[me].state = tswitch[platform[me].LinkedSwitch].state;
 	Object[num_strats].parameter = me;
}

void HandlePlatform(void)
{
	u8 me;
	s16 sprx,spry;
	u8 fall;
	
	me = Object[current_strat].parameter;

	if(abs(game_x - platform[me].xpos) > 400)
		return;


	sprx = platform[me].xpos - game_x - 32;
	spry = platform[me].ypos - game_y - 8;
   if(platform[me].LinkedSwitch >= 99)
   	platform[me].state = 1;
   else
   	platform[me].state = tswitch[platform[me].LinkedSwitch].state;
	
	// crumbling platform routine
	
	if(platform[me].LinkedSwitch == 100)
	{
		if(platform[me].dx > 0 && platform[me].xposL == 0) // wobbling
		{
			if((GameClock & 1) == 0)
				platform[me].dx++;
			if(platform[me].dx == 32) // fall time
			{
				platform[me].xposL = 1;
				platform[me].dx = 0; // now we recycle dx as dy
				platform[me].xposR = platform[me].ypos; // store the original ypos
				Sample_Play(SMPL_CRUMBLE_PLATFORM);
				
			}
			
		}
		else
		{
			if(platform[me].xposL > 0) // falling
			{	
				platform[me].ypos += platform[me].dx;
				platform[me].dx = min(3,platform[me].dx + 1);
				platform[me].xposL++;
				
				if(platform[me].xposL > (60 * 5)) // timeout, so reset to original
				{
					platform[me].xposL = -200;
					platform[me].dx = 0;
					platform[me].ypos = platform[me].xposR;
				}
			}
			else
			{	//re-appearing
				if(platform[me].xposL < 0)
				{
					platform[me].xposL+=4+(-platform[me].xposL/32);
					if (platform[me].xposL > 0)
					{
						platform[me].xposL = 0;
					}
				}
			}	
		}
	}
	
	if(sprx > -64 && sprx < 240 && spry >= -64 && spry <= 160 && platform[me].state == 1)
	{
		mysprite = NextSprite++;
	if(platform[me].LinkedSwitch == 100) // crumbler, jiggle it
		{
			if(platform[me].dx > 16)
				sprx += ((platform[me].dx & 2) >> 1);
		}
		Sprite[mysprite] = PlatformTemplate2;
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		
		if(platform[me].xposL < 0)
		{
//			if((platform[me].xposL & 8) )
//				Sprite[mysprite].VPos = 160;
// "Whoosh" the platform back on
				spry = spry + platform[me].xposL;
				if (spry >= -64 && spry <= 160)
				{
					Sprite[mysprite].VPos = (spry + 256) & 255;
				}
				else
				{
					Sprite[mysprite].VPos = 160;
				}
		}
			
		// let's make it a platform :)
		fall = 0;
		if(platform[me].xposL > 0)
			fall = 16;
		// Only if the platform is not coming back. i.e. It is stationary or doing the fall
		if (platform[me].xposL >= 0)
		{
			if(collision_underme > platform[me].ypos - fall &&  player.ypos <= (platform[me].ypos + 32))
			{

				if((player.xpos > platform[me].xpos - 32 ) && (player.xpos < platform[me].xpos + 32) && player.jump >= 0)
				{
					collision_underme = platform[me].ypos + 1;// - fall;
					platform_underme = collision_underme;
					
					if(player.ypos >= platform[me].ypos - fall && (player.jump >> 2) >= platform[me].dx)
					{
						if(platform[me].LinkedSwitch == 100) // crumbling platform
						{
							if(platform[me].dx == 0 && platform[me].xposL == 0)
								platform[me].dx = 1;
						}
						if(player.jump > 0)
						{
							player.jump = min(player.jump,platform[me].dx << 2);
							if(fall == 0)
								player.ypos = platform[me].ypos + 1;
							player.falltime = 0;
						
						//	Sprite[mysprite].VPos+=4;
						}
					}
				}
			}
		}
	}

}

void initmovingplatform(void)
{
	u8 me;

	PlatformTemplate.CharNo = PLATFORM_SPRITE;
	PlatformTemplate.Shape = 0;
	PlatformTemplate.Size = 3;
	PlatformTemplate.Pltt = 8;
	PlatformTemplate.Priority = 2;

	PlatformTemplate2.CharNo = PLATFORM_SPRITE + 64; // falling platform
	PlatformTemplate2.Shape = 0;
	PlatformTemplate2.Size = 3;
	PlatformTemplate2.Pltt = 8;
	PlatformTemplate2.Priority = 2;

	me = NextPlatform(); //Object[num_strats].parameter; // what switch to use (99 = no switch)
	Object[num_strats].handle = HandleMovingPlatform;
	Object[num_strats].remover = RemovePlatform;
        platform[me].xpos = parm_xpos;
        platform[me].ypos = parm_ypos;
        platform[me].LinkedSwitch = Object[num_strats].parameter;
    	platform[me].xposL = parm_xpos;
    	platform[me].xposR = wp_xpos;
    	platform[me].dx = 1;
        if(platform[me].LinkedSwitch == 99)
        	platform[me].state = 1;
        else
        	platform[me].state = tswitch[platform[me].LinkedSwitch].state;
 	Object[num_strats].parameter = me;
	movingplatformpair = me ;
	
}

void HandleMovingPlatform(void)
{
	u8 me,a;
	s16 sprx,spry;
	me = Object[current_strat].parameter;
	
	if(abs(game_x - platform[me].xpos) > 400)
		return;

	
	if(platform[me].state == 1)
	{
		platform[me].xpos += platform[me].dx;
		if(platform[me].xpos < platform[me].xposL)
		{
			platform[me].dx = -platform[me].dx;
			platform[me].xpos = platform[me].xposL;
		}
		if(platform[me].xpos > platform[me].xposR)
		{
			platform[me].xpos = platform[me].xposR;
			platform[me].dx = -platform[me].dx;
		}
	}
	sprx = platform[me].xpos - game_x - 32;
	spry = platform[me].ypos - game_y - 8;
   if(platform[me].LinkedSwitch == 99)
   	platform[me].state = 1;
   else
   	platform[me].state = tswitch[platform[me].LinkedSwitch].state;
	
	
	
	if(sprx > -64 && sprx < 240 && spry >= -64 && spry <= 160 && platform[me].state == 1)
	{
		mysprite = NextSprite++;
		Sprite[mysprite] = PlatformTemplate;
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		
		
		// let's make it a platform :)
		
		if(collision_underme > platform[me].ypos &&  player.ypos <= (platform[me].ypos + 32))
		{

			if((player.xpos > platform[me].xpos - 32 ) && (player.xpos < platform[me].xpos + 32))
			{
				collision_underme = platform[me].ypos + 1;
				platform_underme = collision_underme;
				
				if(player.ypos >= platform[me].ypos)
				{
					if(player.jump > 0)
					{
						player.jump = 0;
						player.ypos = platform[me].ypos + 1 ;
						player.falltime = 0;
					//	Sprite[mysprite].VPos+=4;
					}
					if(player.ypos == platform[me].ypos + 1)
					{
						player.xpos += platform[me].dx;
						for(a = 0; a < 16; a++)
						{
							chasex[a] += platform[me].dx;
						}

					}
				}

			}
		}
	}
}

void initvmovingplatform(void)
{
	u8 me;

	PlatformTemplate.CharNo = PLATFORM_SPRITE;
	PlatformTemplate.Shape = 0;
	PlatformTemplate.Size = 3;
	PlatformTemplate.Pltt = 8;
	PlatformTemplate.Priority = 2;

	PlatformTemplate2.CharNo = PLATFORM_SPRITE + 64; // falling platform
	PlatformTemplate2.Shape = 0;
	PlatformTemplate2.Size = 3;
	PlatformTemplate2.Pltt = 8;
	PlatformTemplate2.Priority = 2;

	me = NextPlatform(); //Object[num_strats].parameter; // what switch to use (99 = no switch)
	Object[num_strats].handle = HandleVMovingPlatform;
	Object[num_strats].remover = RemovePlatform;
        platform[me].xpos = parm_xpos;
        platform[me].ypos = parm_ypos;
        platform[me].LinkedSwitch = Object[num_strats].parameter;
     	
    	if(parm_ypos < wp_ypos)
    	{
    		platform[me].dx = 1;
	   		platform[me].xposL = parm_ypos;
	    	platform[me].xposR = wp_ypos;
    	}
    	else
		{
		  	platform[me].dx = -1;
           	platform[me].xposR = parm_ypos;
	    	platform[me].xposL = wp_ypos;
		}
        if(platform[me].LinkedSwitch == 99)
        	platform[me].state = 1;
        else
        	platform[me].state = tswitch[platform[me].LinkedSwitch].state;
 	Object[num_strats].parameter = me;
	movingplatformpair = me ;
	
}

void HandleVMovingPlatform(void)
{

	u8 me;
	s16 sprx,spry;
	me = Object[current_strat].parameter;
	if(abs(game_x - platform[me].xpos) > 400)
		return;
	
	if(platform[me].state == 1)
	{
		platform[me].ypos += platform[me].dx;
		if(platform[me].ypos < platform[me].xposL)
		{
			platform[me].dx = -platform[me].dx;
			platform[me].ypos = platform[me].xposL;
		}
		if(platform[me].ypos > platform[me].xposR)
		{
			platform[me].ypos = platform[me].xposR;
			platform[me].dx = -platform[me].dx;
		}
	}
	sprx = platform[me].xpos - game_x - 32;
	spry = platform[me].ypos - game_y - 8;
   if(platform[me].LinkedSwitch == 99)
   	platform[me].state = 1;
   else
   	platform[me].state = tswitch[platform[me].LinkedSwitch].state;
	
	
	
	if(sprx > -64 && sprx < 240 && spry >= -64 && spry <= 160 && platform[me].state == 1)
	{
		mysprite = NextSprite++;
		Sprite[mysprite] = PlatformTemplate;
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		
		
		// let's make it a platform :)
		
		if(collision_underme >= (platform[me].ypos - 1) &&  player.ypos <= (platform[me].ypos + 32))
		{

			if((player.xpos > platform[me].xpos - 32 ) && (player.xpos < platform[me].xpos + 38))
			{
				collision_underme = platform[me].ypos + 1;
				platform_underme = collision_underme;
				
				if((player.ypos > platform[me].ypos - 2) && (player.jump >= 0))
				{
					player.ypos = platform[me].ypos + 1;
					player.jump = 0;
						player.falltime = 0;
					if(player_state == player_state_jump)
						player_state = player_state_idle;
				}
				else
				{
					if(player.ypos >= platform[me].ypos)
					{
						if(player.jump >= 0)
						{
							player.jump = 0;
							player.ypos = platform[me].ypos + 1 ;
						player.falltime = 0;
						//	Sprite[mysprite].VPos+=4;
						}
					}
				}
			}
		}
	}
}

void initbridge(void)
{
	u8 me;
	u8 a;
	
	//PlatformTemplate = 0;
	PlatformTemplate.CharNo = PLATFORM_SPRITE;
	PlatformTemplate.Shape = 0;
	PlatformTemplate.Size = 3;
	PlatformTemplate.Pltt = 8;
	PlatformTemplate.Priority = 2;

	PlatformTemplate2.CharNo = PLATFORM_SPRITE + 64; // falling platform
	PlatformTemplate2.Shape = 0;
	PlatformTemplate2.Size = 3;
	PlatformTemplate2.Pltt = 8;
	PlatformTemplate2.Priority = 2;

	PlankTemplate.CharNo = ENEMY_SPRITE;
	PlankTemplate.Shape = tawahibridgeSizeShape[1];
	PlankTemplate.Size = tawahibridgeSizeShape[0];
	PlankTemplate.Pltt = 2;
	PlankTemplate.Priority = 2;

	me = NextPlatform(); //Object[num_strats].parameter; // what switch to use (99 = no switch)
	Object[num_strats].handle = HandleBridge;
    Object[num_strats].remover = RemovePlatform;
    platform[me].xpos = parm_xpos;
    platform[me].ypos = parm_ypos;
    platform[me].dx = (wp_xpos - parm_xpos) / 32;	// recycle. crumbled triggered
    platform[me].xposL = 0; //
  	Object[num_strats].parameter = me;
	for(a = 0; a < platform[me].dx;a++)
	{
		plank[a].xpos = parm_xpos + a * 32;
		plank[a].ypos = parm_ypos;
		plank[a].dy = 0;

	}
}

void HandleBridge(void)
{
	u8 me;
	s16 sprx,spry;
	s32 sprite_ptr;
	s8 f;
	u8 frame;
	u8 a;
	
	
	me = Object[current_strat].parameter;
	if(abs(player.xpos - platform[me].xpos) > 400)
		return;
	
	LoadEnemyPalette(tawahibridgePalette,nxtenemypal);

	sprite_ptr = (u32)tawahibridgeSprite;
	LoadEnemySprite(sprite_ptr, 1024);
	
	f = EnemySprite[SpriteCache];
	for(a = 0; a < platform[me].dx;a++)
	{
		if(plank[a].dy)
		{
			if(plank[a].dy < 0)
				plank[a].dy++;
			if(plank[a].dy >= 0)
			{
				plank[a].ypos+= plank[a].dy;
				plank[a].dy = min(8,plank[a].dy + 1);
				if(plank[a].ypos > platform[me].ypos + 320)
				{
					plank[a].dy = 0;
					plank[a].ypos = PlayerMapHeight * 8 + 64;
				}
			}
			
		}
		
		sprx = plank[a].xpos - game_x;
		spry = plank[a].ypos - game_y - 32;
		if(sprx > -32 && sprx < 240 && spry > -32 && spry < 160)
		{
			frame = NextSprite++;
			
			
			Sprite[frame] = PlankTemplate;
			
		   	Sprite[frame].Pltt = 2 + PalCache;
			Sprite[frame].CharNo = f;
			Sprite[frame].HPos = sprx & 511;
			Sprite[frame].VPos = (spry + 256) & 255;


		// let's make it a platform :)
			
			if(collision_underme >= (plank[a].ypos - 1) &&  player.ypos <= (plank[a].ypos + 32))
			{

				if((player.xpos > plank[a].xpos ) && (player.xpos < plank[a].xpos + 32))
				{
					collision_underme = plank[a].ypos + 1;
					platform_underme = collision_underme;
					if(plank[a].dy == 0)
					{
						plank[a].dy = -16;
					}
					if((player.ypos > plank[a].ypos - 2) && (player.jump >= 0))
					{
						player.ypos = plank[a].ypos + 1;
						player.jump = 0;
						player.falltime = 0;
						if(player_state == player_state_jump)
							player_state = player_state_idle;
					}
					else
					{
						if(player.ypos >= plank[a].ypos)
						{
							if(player.jump >= 0)
							{
								player.jump = 0;
								player.ypos = plank[a].ypos + 1 ;
								player.falltime = 0;
							//	Sprite[mysprite].VPos+=4;
							}
						}
					}
				}
			}

		}
	}



}
