/*********************************************/
/*  player.h  test player strat routine      */
/*********************************************/
#ifndef _PLAYER_H
#define _PLAYER_H

#include <AGB.h>
#include "asldefines.h"


#define PLAYER_ACTUAL	0
#define PLAYER_SPARE	1

#define SPRITE_SPECIAL	0
#define	SPRITE_WALK		1
#define	SPRITE_RUN		2
#define	SPRITE_JUMP		3
#define	SPRITE_ATTACK	4
#define	SPRITE_CLIMB	5
#define	SPRITE_IDLE		6
#define	SPRITE_NOTDIE	7
#define SPRITE_SWIM		8

#define	ACTION_THROWSWITCH	1
#define ACTION_HASOTHER		2
#define ACTION_POWER		4
#define ACTION_LADDERLEFT	8
#define	ACTION_LADDERRIGHT	16
#define ACTION_LADDER		24
#define ACTION_SLIDE		32
#define ACTION_DUCKED		64
#define ACTION_SMARTBOMB	128

typedef struct {
	s32 xpos;
	s32 ypos;
	s16 yposoffset; // for quicksand etc.
	u8	frame;
	u8  shadow; // player's shadow sprite
	u8 spare; // following character
	u8 spareshadow; // following character's shadow sprite
	s8 jump;
	s8 dx;
	s8 jumpoffset;
	u8 health;
	u8 elemental_power;
	u8 lives;
	u8 ActionFlags;		// ThrowSwitch, HasOther, ElementPower, Attack
	u8 falltime;
	u8 dash;
	// safety vars (refresh player at end of strat loop so if other strats have overwritten it gets reset
	u8 charno;
	s16 hpos;
	s16 vpos;
} playerparms;

typedef struct {
	s16 xpos;
	s16 ypos;
	s8 dx;
	s8 dy;
	u8 spin;
	u8 frame;
	u8 range;
	
} frisbeeparms;

u8 MiniMode;
u8 force_jump;
s8 frisbeelaunched;
frisbeeparms Frisbee[4];
u32 lastsparesprite;
u32 spritesource[2];
const u32 SpriteBase[2][9];
u16 player_obj;
playerparms player;
Funcp player_state;
u32 player_sprite_source;
u8 Freeze_Player;
u8 CameraShake;
s16 CameraPush; // Camera 'push' based on player direction
u8 Player_Hurt;
u8 PickupItems;
u8	WhatPlayer;
u8 elem_power_level;

u8 Frisbee_Hit;
u8 Frisbee_Power;
s16 EnemyNearX;
s16 EnemyNearY;
u16 chasex[16];
u16 chasey[16];


const u16 PlayerEyePalette[5];
const u16 VFlashPalette[16];

void initplayer();
void player_state_swimming(void);
void player_state_walk(void);
void player_state_run(void);
void player_state_jump(void);
void player_state_jump_attack(void); // not available for chiefs
void player_state_land(void);

void player_state_attack(void);
void player_state_special(void);
void player_state_idle(void);
void player_state_duck(void);
void player_state_climb(void);
void player_state_notatalldead(void);
void UpdatePlayerSprite(void);
void LoadSpriteComp(u32  source, u32 dest,u32 length);
u8 HitPlayer(u8 damage);
void FireFrisbee(s16 xpos,s16 ypos,s8 dx);
void initfrisbee(void);
void HandleFrisbee(void);
u8 EnoughPower(void);
u8 FrisbeeHit(s16 tx,s16 ty,u8 range);
void DiscRebound(void);
void CheckEnemyNear(s16 enemyx, s16 enemyy, u8 BohrokOverride);

#endif
