/*********************************************/
/*  player.h  test player strat routine      */
/*********************************************/

#define MAX_SWITCHES 32
#define MAX_LADDERS 16

void initswitch();
void initsmash();
void initflamepit();
void initairvent();
void initrestartpoint();
void initladder();
void initslide();
void initl3remover();

void HandleSwitch();
void HandleSmash();
void HandleFlamePit();
void HandleAirVent();
void HandleRestartPoint();
void HandleLadder();
void HandleSlide();
void inittileswapsource(void);
void HandleTileSwapper(void);
void inittileswapper(void);
void initwaterarea(void);
void HandleWaterArea(void);
void Handlel3Remover(void);

void initmodeswitch(void);
void HandleModeSwitch(void);
void initareaswitch(void);
void HandleAreaSwitch(void);
void initpickupswitch(void);
void HandlePickupSwitch(void);
void initcrumbler(void);
void HandleCrumbler(void);

typedef struct {
	s16 xpos;
	s16 ypos;
	u8 frame;
	u8 state;
	u8 hide;
} switchparms;

typedef struct {
	s16 xpos;
	s16 ypos;
	u8 w;
	u8 h;
	u8 state;
} areaswitchparms;

typedef struct {
	s16 xpos;
	s16 ypos;
	s16 xpos2;
	s16 ypos2;
	u8 hits;
	u8 state;
	u8 type;
	u8 lastaction;
} smashparms;


typedef struct {
	s16 xpos;
	s16 ypos;
	u8 height;
	u16 clock;
	u16 time;
	u16 time2;
} flamepitparms;

typedef struct {
	s16 xpos;
	s16 ypos;
	u8  width;
	u8  height;
} ladderparms;

typedef struct {
	s16 xpos;
	s16 ypos;
	u8 width;
	u8 height;
	u8 switchnum;
	s16 sourcex;
	s16 sourcey;
} tileswapparms;

typedef struct {
	s16 xpos;
	s16 ypos;
	s16 brx;
	s16 bry;
} waterareaparms;

typedef struct {
	s16 xpos;
	s16 ypos;
	u8 mode;
} modeswitchparms;

typedef struct {
	s16 xpos;
	s16 ypos;
	u8 w;
	u8 h;
	u8 tswitch;
} l3removerparms;


extern switchparms tswitch[MAX_SWITCHES];
extern s16 Force_Scroll_xpos;
extern s8 Force_Scroll_dx;
