// Text routines.

// text is done as a 'map' on a front screen, overlaying all the others

#include <AGB.H>
#include "asldefines.h"
//#include "data.h"
#include "font.h"
#include "main.h"
#include "text.h"
#include "font16.h"
#include "menubutton.h"
#include "levelicons.h"

u16 agbstrlen(char * string);
OamData BigCharTemplate;
OamData BigIconTemplate;

bigstringparms BigString[12];
bigcharparms bigchar[MAX_BIGCHARS];
u8 TextAutoCentre;

const char charlist[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ .!?0123456789ab'def:hijklmnopqrs&tuvwxyz";

void TextOn(void)
{

	u16 * ptr;
	   
   *(vu16 *)REG_BG3CNT =                             // Set BG control for BG 3
            BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_0
            | 3 << BG_SCREEN_BASE_SHIFT | 0 << BG_CHAR_BASE_SHIFT ;  // font uses chars 512 - 1023
	Screen3(1);
	DmaArrayCopy(3,FontSprite,(u32)(BG_VRAM + 0x3000),32);
	DmaWait(3);
	*(vu16 *)REG_BG3VOFS = 0;
	*(vu16 *)REG_BG3HOFS = 0;

//	LoadFontPalette(FontPalette);
	ptr = BG_PLTT + 482;
	
	*ptr++ = FontPalette[1];
	*ptr = FontPalette[2]; 


}



void TextOff(void)
{
    *(vu16 *)REG_DISPCNT &= (~DISP_BG3_ON); // screen 3 off

}

void TextClear(void)
{
	u16 * dest;
	dest = (u16 *)( BG_VRAM + 3 * 2048);
	DmaArrayCopy(3,FontSprite,(u32)(BG_VRAM + 0x3000),32);
	
	DmaClear(3,384 + 26, dest,2048,16);
}

void Text(u8 x,u8 y,char * string)
{
	u8 a,b,n,l;
	u16 * dest;
	
	x >>= 3;
	y >>= 3;
	dest = (u16 *)( BG_VRAM + 3 * 2048);

	n = 0;
	l = agbstrlen(string);
	for(a = 0 ; a < l;a++)
	{
		for(b = 0; b < 60;b++)
			if(string[a] == charlist[b])
				*(dest + (x + a + (y * 32))   ) = (u16)(b + 384 + (15 << 12));
	}

}

void TextCentre(s8 x,u8 y,char * string)
{
	u8 a,b,n,l;
	u16 * dest;
	
	x >>= 3;
	y >>= 3;
	dest = (u16 *)( BG_VRAM + 3 * 2048);

	n = 0;
	l = agbstrlen(string);
	for(a = 0 ; a < l;a++)
	{
		for(b = 0; b < 60;b++)
			if(string[a] == charlist[b])
				*(dest + (max(0,15 - (l >> 1)) + x + a + (y * 32))   ) = (u16)(b + 384 + (15 << 12));
	}

}

void TextColour(u8 red, u8 green, u8 blue)
{
	u16 bgr;
	u16 * ptr;
	
	bgr = red + (green << 5) + (blue << 10);
	ptr = (u16 *)(BG_PLTT + (15 << 5) + 2);
	*ptr = bgr;
}

void TextColour2(u8 red, u8 green,u8 blue)
{
	u16 bgr;
	u16 * ptr;
	
	bgr = red + (green << 5) + (blue << 10);
	ptr = (u16 *)(BG_PLTT + (15 << 5) + 4);
	*ptr = bgr;

}

u16 agbstrlen(char * string)
{
	u8 a;
	a = 0;
	for(a = 0 ; a < 255; a++)
		if(string[a] == 0)
			return a;
	return 1;
}


void BigText(u8 textnum, s16 xpos,s16 ypos,char * string)
{
	u8 a,b;
	u8 l;
	s16 x;
	l = agbstrlen(string);
	BigString[textnum].xpos = xpos;
	BigString[textnum].ypos = ypos;
//	AGBPrintf("string = %s..\n",string);
//	AGBPrintFlush();
	x = 0;
	for(a = 0 ; a < l; a++)
	{
		
		if(string[a] >= 200) // level character 200 = new game
		{
		
			if(string[a] > 200)
			{
				b = string[a] - 201;
				spawn(initbigicon,x + 16,-8,(textnum << 8) + b);
				x += 80;
			}
		}
		else
		{
			for(b = 0; b < 67;b++)
			{
				if(string[a] == charlist[b])
				{
					spawn(initbigchar,x, 0,(textnum << 8) + b);
					//if(a == 0)
					//	x+= 16;
					//else
						x+= FontBigKern[b] + 1;
					b = 99;
				}	
				
			}
		}
		
	}	
	if(TextAutoCentre)
	{
		x = x / 2;
		BigString[textnum].xpos = 120 - x;
	}

}

u8 BigTextLen(char * string)
{
	u8 a,b;
	u8 l;
	u16 x;
	
	x = 0;
	l = agbstrlen(string);
	
	for(a = 0; a < l; a++)
	{
		if(string[a] >= 200) // special char
		{
			if(string[a] > 200)
				x+= 80;
		}
		else
		{
			for(b = 0; b < 67; b++)
			{
				if(string[a] == charlist[b])
				{
				//	if(a == 0)
				//		x+= 16;
				//	else
						x+= FontBigKern[b] + 1;
					b = 99;
				}
			}
		}
	}
	return x;
}


void BigTextMove(u8 textnum, s16 xpos,s16 ypos)
{
	BigString[textnum].xpos = xpos;
	BigString[textnum].ypos = ypos;
	
}

void BigTextRemove(u8 textnum)
{
	BigString[textnum].xpos = -999;
}

u8  NextBigChar(void)
{
	u8 a;
	for(a = 0; a < MAX_BIGCHARS;a++)
	{
		if(bigchar[a].active == 0)
		{
			bigchar[a].active = 1;
			return a;
		}
	}
	return 31;
}

void KillBigChars(void)
{
	u8 a;
	for(a = 0 ; a < MAX_BIGCHARS; a++)
		bigchar[a].active = 0;
}

void RemoveBigChar(void)
{
	u8 me;
	me = Object[current_strat].parameter;
	bigchar[me].active = 0;
}

void initbigchar(void)
{
	u8 me;
	me = NextBigChar();
	Object[num_strats].handle = HandleBigChar;
	Object[num_strats].remover = RemoveBigChar;
    bigchar[me].xpos = parm_xpos;
    bigchar[me].ypos = parm_ypos;
    bigchar[me].character = Object[num_strats].parameter & 0xff;
 
 	BigCharTemplate.CharNo = BIGTEXT_MSPRITE + BIGTEXT_MSPRITE_SIZE * bigchar[me].character ;
 	BigCharTemplate.Shape = FontBigSizeShape[1];
 	BigCharTemplate.Size = FontBigSizeShape[0];
 	BigCharTemplate.Pltt = 15;
 	BigCharTemplate.Priority = 0;
 	
 	LoadPalette(FontBigPalette,15);
 	
	Object[num_strats].parameter = me + (Object[num_strats].parameter & 0xff00);
}




void HandleBigChar(void)
{
	u8 me;
	u8 a;
	u8 mystring; 
	s16 sprx,spry;
	
	me = Object[current_strat].parameter & 0xff;
	mystring = Object[current_strat].parameter >> 8;
	if(BigString[mystring].xpos == -999) // remove all this string's characters
	{
		bigchar[me].active = 0;
		remove();
	}
	else
	{
		sprx = BigString[mystring].xpos + bigchar[me].xpos;
		spry = BigString[mystring].ypos + bigchar[me].ypos;

		if(sprx > -16 && sprx < 240 && spry > -16 && spry < 160)
		{
			mysprite = NextSprite++;
			a = 0;
			if(menuselect == mystring)
			{
				a = 1;
			}
			Sprite[mysprite] = BigCharTemplate;
			Sprite[mysprite].CharNo = BIGTEXT_MSPRITE +bigchar[me].character * 4;
			Sprite[mysprite].HPos = (sprx + a) & 511;
			Sprite[mysprite].VPos = (spry + 256 + a) & 255;
			Sprite[mysprite].Priority = 0;
			
		}
	}	
}

void initbigicon(void)
{
	u8 me;
	u8 a;
	u8 mystring;
	
	me = NextBigChar();
	
	Object[num_strats].handle = HandleBigIcon;
	Object[num_strats].remover = RemoveBigChar;
    bigchar[me].xpos = parm_xpos;
    bigchar[me].ypos = parm_ypos;
    bigchar[me].character = Object[num_strats].parameter & 0xff;
 
 	BigIconTemplate.CharNo = BIGICON_MSPRITE + bigchar[me].character * 32;
 	BigIconTemplate.Shape = LeIconSizeShape[1];
 	BigIconTemplate.Size = LeIconSizeShape[0];
 	BigIconTemplate.Priority = 0;
 	
 	
	Object[num_strats].parameter = me + (Object[num_strats].parameter & 0xff00);
	mystring = Object[current_strat].parameter >> 8;
	a = 13;
	if(BigString[mystring].ypos + bigchar[me].ypos > 80)
		a = 14;
 	LoadPalette(LeIconPalette[bigchar[me].character],a);
}

void HandleBigIcon(void)
{
	u8 me;
	u8 a;
	u8 mystring; 
	s16 sprx,spry;
	
	me = Object[current_strat].parameter & 0xff;
	mystring = Object[current_strat].parameter >> 8;
	if(BigString[mystring].xpos == -999) // remove all this string's characters
	{
		bigchar[me].active = 0;
		remove();
	}
	else
	{
		sprx = BigString[mystring].xpos + bigchar[me].xpos;
		spry = BigString[mystring].ypos + bigchar[me].ypos;

		if(sprx > -16 && sprx < 240 && spry > -16 && spry < 160)
		{
			mysprite = NextSprite++;
			a = 0;
			if(menuselect == mystring)
			{
				a = 1;
			}
			Sprite[mysprite] = BigIconTemplate;
			if(spry > 80)
				Sprite[mysprite].Pltt = 14;
			else
				Sprite[mysprite].Pltt = 13;
			Sprite[mysprite].CharNo = BIGICON_MSPRITE + bigchar[me].character * 32;
			Sprite[mysprite].HPos = (sprx + a) & 511;
			Sprite[mysprite].VPos = (spry + 256 + a) & 255;
			Sprite[mysprite].Priority = 0;
			
		}
	}	
}