#include <agb.h>
#include "Display.h"

Display gDisplay;

void Display::Init(void)
{
	mDoSwap = false;
	mDepth = 8;
	mWidth = 240;
	mHeight = 160;
	mBank = 0;

	mFrontScreenData = (void *)BG_BITMAP0_VRAM;
	mBackScreenData = (void *)BG_BITMAP1_VRAM;

	*(vu16 *)REG_DISPCNT = DISP_MODE_4 | DISP_BG2_ON;

	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2CNT) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2HOFS) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2VOFS) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PA) = 1<<8;
//	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PA) = 1<<7;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PB) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PC) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PD) = 1<<8;
//	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PD) = 1<<7;
	*(vu32 *)(REG_DISPCNT+OFFSET_REG_BG2X) = 0;
	*(vu32 *)(REG_DISPCNT+OFFSET_REG_BG2Y) = 0;
}

void Display::Clear(void)
{
	DmaClear(3,0,mBackScreenData,(mDepth/8)*mWidth*mHeight,32);
	DmaWait(3);
}

void Display::Swap(void)
{
	mDoSwap = true;
}

void Display::VSyncFunction(void)
{
	if (mDoSwap)
	{
		mDoSwap = false;
		mBank = !mBank;

		switch(mBank)
		{
			case 0:
			default:
				*(vu16 *)REG_DISPCNT &= ~DISP_BMP_FRAME_NO;
				mFrontScreenData = (void *)BG_BITMAP0_VRAM;
				mBackScreenData = (void *)BG_BITMAP1_VRAM;
				break;
			case 1:
				*(vu16 *)REG_DISPCNT |= DISP_BMP_FRAME_NO;
				mFrontScreenData = (void *)BG_BITMAP1_VRAM;
				mBackScreenData = (void *)BG_BITMAP0_VRAM;
				break;
		}
	}
}
