#ifndef __DISPLAY_H__
#define __DISPLAY_H__

#ifdef __cplusplus

typedef struct s_Display
{
public:
	void Init(void);
	void Clear(void);
	void Swap(void);		// Should be followed by a vsync wait
	void VSyncFunction(void);	// Should be near the start of the vsync interupt
	void *GetFrontScreen(void)
	{
		return mFrontScreenData;
	}
	void *GetBackScreen(void)
	{
		return mBackScreenData;
	}

private:
	int mWidth;
	int mHeight;
	int mDepth;
	void *mFrontScreenData;
	void *mBackScreenData;
	int mBank;
	bool mDoSwap;
	
} Display;

extern Display gDisplay;

#endif

#endif
