#include "DrawPoly.h"

#define SWAP(a,b) {int temp; temp = (a); (a)=(b); (b)=temp;};

void DrawPoly(void *screenmem,int *x,int *y,u8 colour)
{
	u32 wordcolour = colour | (colour<<8) | (colour<<16) | (colour<<24);

//	((u8*)screenmem)[x[0]+(y[0]*240)] = colour;
//	((u8*)screenmem)[x[1]+(y[1]*240)] = colour;
//	((u8*)screenmem)[x[2]+(y[2]*240)] = colour;

	int sx[3],sy[3];

	// Sort quickly
	sx[0] = x[0];	sy[0] = y[0];
	sx[1] = x[1];	sy[1] = y[1];
	sx[2] = x[2];	sy[2] = y[2];

	bool swapped;
	do
	{
		swapped = false;
		if (sy[0] > sy[1])
		{
			SWAP(sy[0],sy[1]);
			SWAP(sx[0],sx[1]);
			swapped = true;
		}
		if (sy[1] > sy[2])
		{
			SWAP(sy[1],sy[2]);
			SWAP(sx[1],sx[2]);
			swapped = true;
		}
	} while(swapped == true);

	int gradmajor = 0;
	int gradminor = 0; 
	int height = 0;
	int ypos = sy[0] * 240;
	height = (sy[2] - sy[0])+1;
	if ( height > 0)
	{
		gradmajor = ((sx[2] - sx[0])<<20) / height;
	}
	int tophalf = (sy[1] - sy[0]);
	if (tophalf > 0)
	{
		gradminor = ((sx[1] - sx[0])<<20) / tophalf;
	}
	int edge1 = sx[0]<<20;
	int edge2 = sx[0]<<20;

	while (height > 0)
	{
		if (tophalf <= 0 && height > 1)
		{
			tophalf = (sy[2] - sy[1]);
			if (tophalf > 0)
			{
				gradminor = ((sx[2] - sx[1])<<20) / tophalf;
			}
			else
			{
				gradminor = 0;
			}
			edge2 = sx[1]<<20;
		}

		int start,length;
		length = edge2 - edge1;
		if (length > 0)
		{
			start = edge1;
//			length += (1<<19);
		}
		else
		{
			start = edge2;
			length = -length;
//			length += (1<<19);
		}
		start = start >> 20;
		length = length >> 20;

		length++;
		u8 *wordspan;
		wordspan = (((u8*)screenmem)+start+ypos);

		while ( ( ((int)wordspan)&3) && length > 0)
		{
			*wordspan++ = colour;
			length--;
		}

		while(length >= 4)
		{
			
			*((u32*)wordspan)++ = wordcolour;
			length-=4;
		}

		while (length > 0)
		{
			*wordspan++ = colour;
			length--;
		}

		edge1 += gradmajor;
		edge2 += gradminor;

		ypos+=240;
		tophalf--;
		height--;
	}
}
