//#define CODE32
#include <agb.h>
#include "share.h"
#include "menu.h"
#include "menuitem.h"
#include "SampleManager.h"
#include "Display.h"
#include "FontPrn.h"
#include "Engine.h"

void mystrcpy(char *dest,const char *src)
{
	int i;
	i= 0;
	while (src[i])
	{
		dest[i] = src[i];
		i++;
	}
	dest[i] = 0;
}

//======================================================
//					 Main routine
//======================================================
void bgMain(void);
static void my_v_sync_fnc(void);
void DisplayNumber(int x,int y,int colour,int digits,int number);

const char buffer1[] = "Music track";
const char buffer2[] = "Sound effect";
const char buffer3[] = "Music Volume";
const char buffer4[] = "Sound Volume";
const char buffer5[] = "Stop Music";
const char buffer6[] = "Select mixer rate";

const char * const menuitems[] = {buffer1,buffer2,buffer3,buffer4,buffer5,buffer6};

const char abuffer3[] = "Processor 00\%";
const char abuffer4[] = "highest 00\%";


const char mixrate0[] = "Mixer rate = 5734 Hz ";
const char mixrate1[] = "Mixer rate = 10512 Hz";
const char mixrate2[] = "Mixer rate = 13378 Hz";
const char mixrate3[] = "Mixer rate = 16245 Hz";
const char mixrate4[] = "Mixer rate = 18157 Hz";
const char mixrate5[] = "Mixer rate = 21024 Hz";
const char mixrate6[] = "Mixer rate = 31536 Hz";
const char mixrate7[] = "Mixer rate = 36314 Hz";
const char mixrate8[] = "Mixer rate = 40134 Hz";
const char mixrate9[] = "Mixer rate = 42048 Hz";

char buffer[32];

#include "mod_boss1.h"
#include "mod_boss2.h"
#include "mod_boss3.h"
#include "mod_boss4.h"
#include "mod_ko_wahi.h"
#include "mod_le_wahi.h"
#include "mod_po_wahi.h"
#include "mod_ga_wahi.h"
#include "mod_onu_wahi.h"
#include "mod_ta_wahi.h"
#include "mod_title.h"
#include "mod_levelwin.h"
#include "mod_gamewin.h"
#include "mod_gameover.h"
#include "mod_loopintro1.h"
#include "mod_loopintro2.h"
#include "mod_dooropen.h"

#include "Thala.h"
#include "mod_klisje.h"
#include "mod_lab.h"
#include "mod_zak.h"
#include "mod_popcorn.h"
#include "mod_gsl.h"
#include "mod_7days.h"
#include "mod_bet.h"
#include "mod_jam.h"
#include "mod_jam2.h"
#include "mod_3k.h"
#include "mod_chu.h"
#include "mod_fin.h"
#include "mod_8chan.h"

#include "mod_kombat.h"
#include "mod_stars.h"
#include "mod_wild.h"
#include "mod_land.h"
#include "mod_mah.h"
#include "mod_delta.h"

#include "mod_uralvolg.h"
#include "mod_arcangl1.h"
#include "mod_bloodmon.h"
#include "mod_creamofe.h"
#include "mod_demomus.h"
#include "mod_dragnet.h"
#include "mod_equilogy.h"
#include "mod_flowerpo.h"
#include "mod_laidback.h"
#include "mod_lotus2.h"
#include "mod_oldtimer.h"
#include "mod_projectx.h"
#include "mod_smash.h"
#include "mod_space.h"
#include "mod_spaceson.h"
#include "mod_swtit.h"
#include "mod_titlemus.h"
#include "mod_tmnturtl.h"
#include "mod_turrican.h"
#include "mod_apache.h"

#include "testxm.h"
#include "testxm32.h"

const char *const musiclist_names[] =
{
	"Title",
	"Level win",
	"Game win",
	"Boss1",
	"Boss2",
	"Boss3",
	"Boss4",
	"Ga_wahi",
	"Onu wahi",
	"Ta wahi",
	"Le wahi",
	"Po wahi",
	"Ko wahi",
	"Game over",
	"Loop intro 1",
	"Loop intro 2",
	"Door Open",


	"8 Channel test",
	"Final rev",
	"3k",
	"Chuck Rock",
	"Guitar slinger",
	"Jam session",
	"Jam it to the wind",
	"Beethoven",
	"7 Days 1 week",
	"Thalamus",
	"Klisje",
	"Labrynth",
	"Zak",
	"Popcorn",

	"Mortal Kombat",
	"Stars",
	"Wild",
	"Land of feeling",
	"Mahoney",
	"Delta",

	"Ural volga",
	"Arc Angel",
	"Blood money",
	"Cream of the earth",
	"Demo music",
	"Dragnet",
	"Equilogy",
	"Flower power",
	"Laid back",
	"Lotus 2",
	"Old timer",
	"Project X",
	"Smash",
	"Space",
	"Space song",
	"SW Title",
	"Title music",
	"TMNT Title",
	"Turrican",
	"Apache",

	"TestXM 16 Chan",
	"TestXM 32 Chan",
};

const u32 *const musiclist[] =
{
	gmod_titlePatternList,gmod_titleSamples,0,
	gmod_levelwinPatternList,gmod_levelwinSamples,0,
	gmod_gamewinPatternList,gmod_gamewinSamples,0,
	gmod_boss1PatternList,gmod_boss1Samples,0,
	gmod_boss2PatternList,gmod_boss2Samples,0,
	gmod_boss3PatternList,gmod_boss3Samples,0,
	gmod_boss4PatternList,gmod_boss4Samples,0,
	gmod_ga_wahiPatternList,gmod_ga_wahiSamples,0,
	gmod_onu_wahiPatternList,gmod_onu_wahiSamples,0,
	gmod_ta_wahiPatternList,gmod_ta_wahiSamples,0,
	gmod_le_wahiPatternList,gmod_le_wahiSamples,0,
	gmod_po_wahiPatternList,gmod_po_wahiSamples,0,
	gmod_ko_wahiPatternList,gmod_ko_wahiSamples,0,
	gmod_gameoverPatternList,gmod_gameoverSamples,0,
	gmod_loopintro1PatternList,gmod_loopintro1Samples,0,
	gmod_loopintro2PatternList,gmod_loopintro2Samples,0,
	gmod_dooropenPatternList,gmod_dooropenSamples,0,


	gmod_8chanPatternList,gmod_8chanSamples,0,
	gmod_finPatternList,gmod_finSamples,0,
	gmod_3kPatternList,gmod_3kSamples,0,
	gmod_chuPatternList,gmod_chuSamples,0,
	gmod_gslPatternList,gmod_gslSamples,0,
	gmod_jam2PatternList,gmod_jam2Samples,0,
	gmod_jamPatternList,gmod_jamSamples,0,
	gmod_betPatternList,gmod_betSamples,0,
	gmod_7daysPatternList,gmod_7daysSamples,0,
	gThalamusPatternList,gThalamusSamples,0,
	gmod_klisjePatternList,gmod_klisjeSamples,0,
	gmod_labPatternList,gmod_labSamples,0,
	gmod_zakPatternList,gmod_zakSamples,0,
	gmod_popcornPatternList,gmod_popcornSamples,0,

	gmod_kombatPatternList,gmod_kombatSamples,0,
	gmod_starsPatternList,gmod_starsSamples,0,
	gmod_wildPatternList,gmod_wildSamples,0,
	gmod_landPatternList,gmod_landSamples,0,
	gmod_mahPatternList,gmod_mahSamples,0,
	gmod_deltaPatternList,gmod_deltaSamples,0,

	gmod_uralvolgPatternList,gmod_uralvolgSamples,0,
	gmod_arcangl1PatternList,gmod_arcangl1Samples,0,
	gmod_bloodmonPatternList,gmod_bloodmonSamples,0,
	gmod_creamofePatternList,gmod_creamofeSamples,0,
	gmod_demomusPatternList,gmod_demomusSamples,0,
	gmod_dragnetPatternList,gmod_dragnetSamples,0,
	gmod_equilogyPatternList,gmod_equilogySamples,0,
	gmod_flowerpoPatternList,gmod_flowerpoSamples,0,
	gmod_laidbackPatternList,gmod_laidbackSamples,0,
	gmod_lotus2PatternList,gmod_lotus2Samples,0,
	gmod_oldtimerPatternList,gmod_oldtimerSamples,0,
	gmod_projectxPatternList,gmod_projectxSamples,0,
	gmod_smashPatternList,gmod_smashSamples,0,
	gmod_spacePatternList,gmod_spaceSamples,0,
	gmod_spacesonPatternList,gmod_spacesonSamples,0,
	gmod_swtitPatternList,gmod_swtitSamples,0,
	gmod_titlemusPatternList,gmod_titlemusSamples,0,
	gmod_tmnturtlPatternList,gmod_tmnturtlSamples,0,
	gmod_turricanPatternList,gmod_turricanSamples,0,
	gmod_apachePatternList,gmod_apacheSamples,0,

	gtestxmPatternList,gtestxmSamples,gtestxmExtended,
	gtestxm32PatternList,gtestxm32Samples,gtestxm32Extended,
};


#define VCOUNT  (*(volatile unsigned short*)0x04000006)


#if 1
static volatile int PALETTE;
#else
#define PALETTE (*(volatile unsigned short*)0x05000000)
#endif

#define min(a, b)  (((a) < (b)) ? (a) : (b)) 
#define max(a, b)  (((a) > (b)) ? (a) : (b)) 

int menuline = 0;

void Engine_Entry(void)
{
	int music,soundeffect,mixrate,highest;
	int scanline;
	int colcyc;
	int musicvol;
	int soundvol;
	int i;
	int x,y;

	musicvol = 256;
	soundvol = 256;

	*(vu16 *)REG_WAITCNT = CST_ROM0_1ST_3WAIT | CST_ROM0_2ND_1WAIT
						 | CST_PREFETCH_ENABLE;			// Set up 3-1 wait access
	//  Clear RAM
	ClearRamAll();

	music = 0;
	music = 57;
	soundeffect = 0;
	mixrate = 5;
	scanline = 0;
	highest = 0;
	menuline = 0;
	colcyc = 0;

	SampleManager_Init(mixrate);

	//  Initialize V Blank 

	InitVBlank();

	*(vu16 *)REG_IE   = 0;//CASSETTE_INTR_FLAG;	 // Enable Game Pak Interrupt
	*(vu16 *)REG_IME  = 1;					  // Set IME 
	*(vu16 *)REG_STAT = STAT_V_BLANK_IF_ENABLE;	// V Blank interrupt request flag enabled 

	//  For debugging

//	AGBPrintInit();

	MenuInit();
	KeyInit();
	KeyRead();

	//  Set V Blank function 

	SetVBlankFunc( my_v_sync_fnc );

	// Initialize font

	FontPrintInit(0,0,30,20,OBJ_MODE4_VRAM+0x1000,15);
	FontPalletLoad(15);

	// Set display 
	// 1D mapping

	*(vu16 *)REG_DISPCNT = DISP_MODE_0 /*| DISP_OBJ_ON*/
			 | DISP_OBJ_CHAR_1D_MAP | DISP_BG2_ON;

//	*(vu16 *)REG_DISPCNT |= DISP_BMP_FRAME_NO;

/*
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2CNT) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2HOFS) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2VOFS) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PA) = 1<<8;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PB) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PC) = 0;
	*(vu16 *)(REG_DISPCNT+OFFSET_REG_BG2PD) = 1<<8;
	*(vu32 *)(REG_DISPCNT+OFFSET_REG_BG2X) = 0;
	*(vu32 *)(REG_DISPCNT+OFFSET_REG_BG2Y) = 0;
*/


	*(vu16 *)REG_IE |= V_BLANK_INTR_FLAG;

	XMMod_Init((u32 *) musiclist[music*3],(u32 *) musiclist[(music*3)+1],(u32 *) musiclist[(music*3)+2]);

//	Sample_PlayLoop(7);
//	Sample_PlayLoop(7);
//	Sample_PlayLoop(7);
//	Sample_PlayLoop(7);
//	Sample_PlayLoop(37);
//	Sample_PlayLoop(37);
//	Sample_PlayLoop(37);
//	Sample_PlayLoop(37);

	FontPrintCls();
	FontPrintC( 5,0,6,(u8*) "Argonaut Games plc." );
#if MAXCHANNELS == 8
	FontPrintC( 0,2,6,(u8*) "8 Channel music & sound player" );
#elif MAXCHANNELS == 16
	FontPrintC( 2,2,6,(u8*) "16 Channel  music & sound" );
#elif MAXCHANNELS == 32
	FontPrintC( 2,2,6,(u8*) "32 Channel  music & sound" );
#endif

#define STATUSLINE (16)
//#define STATUSLINE (0)

	FontPrintC( 0,4,4,(u8*) "Track name" );
	FontPrintC( 0,STATUSLINE+0,3,(u8*) "Tick rate 00 BPM rate 000" );
	FontPrintC( 0,STATUSLINE+1,3,(u8*) "Active channels" );

	SampleManager_SetMusicVolume(musicvol);
	SampleManager_SetEffectsVolume(soundvol);

	for (i=0;i<256;i++)
	{
		((u16 *)PLTT)[i] = (i&15) | ((i&15)<<5) | ((i&15)<<10);
	}

#if 0

	gDisplay.Init();

	i = 64;
	while(1)
	{
		PALETTE = 0x00;
		V_Wait();
		PALETTE = 0xff;

		KeyRead();

		if( Cont & A_BUTTON )
		{
			i++;
			if (i>=160)
			{
				i = 0;
			}
		}

//		for (y=0;y<160;y++)
		{
			for (x=0;x<240;x++)
			{
				((u8 *)BG_BITMAP0_VRAM)[x+(i*240)] = 0;
				((u8 *)BG_BITMAP0_VRAM)[x+((i+1)*240)] = 15;
//				((u8 *)BG_BITMAP1_VRAM)[x+(i*240)] = 0;
//				((u8 *)BG_BITMAP1_VRAM)[x+((i+1)*240)] = 15;
			}
		}

		PALETTE = 0xff;
	}
#endif

	while(1)
	{
		int i,chan;

		PALETTE = 0x00;
		V_Wait();

		scanline = VCOUNT;
		PALETTE = 0xff00;
		SampleManager_OnceAFrame();
		PALETTE = 0x0;
		PALETTE = 0xff0;
		scanline = VCOUNT - scanline;
		if (scanline < 0)
		{
			scanline = 228+scanline;
		}
		scanline = (scanline * 100) / 228;

		PALETTE = 0xff;
		DisplayNumber(10,STATUSLINE+0,3,2,sSeqLatch);
		DisplayNumber(22,STATUSLINE+0,3,3,sBPMMode);

		DisplayNumber(19,6,5,2,music);
		DisplayNumber(19,7,5,2,soundeffect);
		DisplayNumber(18,8,5,3,musicvol);
		DisplayNumber(18,9,5,3,soundvol);

		FontPrintC( 11,4,5,(u8*) musiclist_names[music]);

		for (i=0;i<sizeof(menuitems)/sizeof(menuitems[0]);i++)
		{
			if (menuline == i)
			{
				FontPrintC(4,6+i,colcyc++,(u8*) menuitems[i]);
				colcyc &= 7;
			}
			else
			{
				FontPrintC(4,6+i,3,(u8*) menuitems[i]);
			}
		}

		chan = 0;
		for (i=0;i<MAXCHANNELS;i++)
		{
			if (gDirectSound.DirectSoundX_ChannelMask & (1<<i))
			{
				chan++;
			}
		}
		buffer[1] = ' ';
		buffer[2] = 0;
		if (chan >= 10)
		{
			buffer[0] = '0' + (chan/10);
			buffer[1] = '0' + (chan%10);
		}
		else
		{
			buffer[0] = '0' + chan;
		}
		FontPrintC( 18,STATUSLINE+1,3,(u8*) buffer );

		switch(mixrate)
		{
			case 0:
				FontPrintC( 0,STATUSLINE+2,3,(u8*) mixrate0 );
				break;
			case 1:
				FontPrintC( 0,STATUSLINE+2,3,(u8*) mixrate1 );
				break;
			case 2:
				FontPrintC( 0,STATUSLINE+2,3,(u8*) mixrate2 );
				break;
			case 3:
				FontPrintC( 0,STATUSLINE+2,3,(u8*) mixrate3 );
				break;
			case 4:
				FontPrintC( 0,STATUSLINE+2,3,(u8*) mixrate4 );
				break;
			case 5:
				FontPrintC( 0,STATUSLINE+2,3,(u8*) mixrate5 );
				break;
			case 6:
				FontPrintC( 0,STATUSLINE+2,3,(u8*) mixrate6 );
				break;
			case 7:
				FontPrintC( 0,STATUSLINE+2,3,(u8*) mixrate7 );
				break;
			case 8:
				FontPrintC( 0,STATUSLINE+2,3,(u8*) mixrate8 );
				break;
			case 9:
				FontPrintC( 0,STATUSLINE+2,3,(u8*) mixrate9 );
				break;
		}

		if (scanline > highest)
		{
			highest = scanline;
		}
		mystrcpy(buffer,abuffer3);
		buffer[10] = '0' + ((scanline/10)%10);
		buffer[11] = '0' + (scanline%10);
		FontPrintC( 0,STATUSLINE+3,3,(u8 *) buffer );
		mystrcpy(buffer,abuffer4);
		buffer[8] = '0' + ((highest/10)%10);
		buffer[9] = '0' + (highest%10);
		FontPrintC( 16,STATUSLINE+3,3,(u8 *) buffer );

		KeyRead();

		if( Trg & A_BUTTON && (menuline == 0 || menuline == 2 || menuline == 5))
		{
			Mod_Stop();
			highest = 0;
			XMMod_Init((u32 *) musiclist[music*3],(u32 *) musiclist[(music*3)+1],(u32 *) musiclist[(music*3)+2]);
		}
		if( Trg & A_BUTTON && (menuline == 1 || menuline == 3))
		{
			Sample_Play(soundeffect);
//			Sample_PlayLoop(soundeffect);
		}
		if( Trg & A_BUTTON && menuline == 4)
		{
			Mod_Stop();
		}
		if ( Trg & U_KEY )
		{
			menuline--;
		}
		if ( Trg & D_KEY )
		{
			menuline++;
		}
		if (menuline < 0)
		{
			menuline = (sizeof(menuitems)/sizeof(menuitems[0]))-1;
		}
		if (menuline >= sizeof(menuitems)/sizeof(menuitems[0]))
		{
			menuline = 0;
		}

		if ( Trg & L_KEY && menuline == 0)
		{
			music--;
			if (music < 0)
			{
				music = ((sizeof(musiclist)/sizeof(musiclist[0]))/3)-1;
			}
			FontPrintC( 11,4,6,(u8 *) "                  " );
		}
		if ( Trg & R_KEY && menuline == 0)
		{
			music++;
			if (music >= (sizeof(musiclist)/sizeof(musiclist[0]))/3)
			{
				music = 0;
			}
			FontPrintC( 11,4,6,(u8 *) "                  " );
		}

		if ( Trg & L_KEY && menuline == 1)
		{
			soundeffect--;
			if (soundeffect < 0)
			{
				soundeffect = END_SMPL_END-1;
			}
		}
		if ( Trg & R_KEY && menuline == 1)
		{
			soundeffect++;
			if (soundeffect >= END_SMPL_END)
			{
				soundeffect = 0;
			}
		}
		if( Trg & L_KEY && menuline == 5)
		{
			mixrate--;
			if (mixrate < 0)
			{
				mixrate = 9;
			}
			SampleManager_SetMixRate(mixrate);
			highest = 0;
		}
		if( Trg & R_KEY && menuline == 5)
		{
			mixrate++;
			if (mixrate > 9)
			{
				mixrate = 0;
			}
			SampleManager_SetMixRate(mixrate);
			highest = 0;
		}
		if( Cont & L_KEY && menuline == 2)
		{
			musicvol--;
			if (musicvol < 0)
			{
				musicvol = 0;
			}
			SampleManager_SetMusicVolume(musicvol);
		}
		if( Cont & R_KEY && menuline == 2)
		{
			musicvol++;
			if (musicvol > 256)
			{
				musicvol = 256;
			}
			SampleManager_SetMusicVolume(musicvol);
		}
		if( Cont & L_KEY && menuline == 3)
		{
			soundvol--;
			if (soundvol < 0)
			{
				soundvol = 0;
			}
			SampleManager_SetEffectsVolume(soundvol);
		}
		if( Cont & R_KEY && menuline == 3)
		{
			soundvol++;
			if (soundvol > 256)
			{
				soundvol = 256;
			}
			SampleManager_SetEffectsVolume(soundvol);
		}
	}
}

static void my_v_sync_fnc(void)
{
	SampleManager_VSyncCode();
//	SampleManager_OnceAFrame();
	FontPrintSync();
}

int ipow(int base,int pow)
{
	int i;
	int total;
	if (pow <= 0)
	{
		return 1;
	}
	total = base;
	for (i=1;i<pow;i++)
	{
		total *= base;
	}
	return total;
}

void DisplayNumber(int x,int y,int colour,int digits,int number)
{
	int i;
	int pos;
	char buffer[16];

	if (digits < 1)
	{
		digits = 1;
	}

	if (digits > 15)
	{
		digits = 15;
	}

	buffer[digits] = 0;

	for (pos=0,i=digits-1;i>=0;i--,pos++)
	{
		int div;
		int n2;

		div = ipow(10,i);
		n2 = number / div;
		n2 = n2 % 10;

		buffer[pos] = '0' + n2;
	}

	FontPrintC( x,y,colour,(u8 *) buffer);
}
