#include "Pool.h"
#include "DrawPoly.h"
#include "Polys.h"
#include "Display.h"

void Polys::Init(int maxpolys)
{
	mMaxPolys = maxpolys;
	mSortBuffer = (SortTableEntry *) gPool.Allocate(maxpolys * sizeof(SortTableEntry));
	mScreenPolyList = (ScreenPoly *) gPool.Allocate(maxpolys * sizeof(ScreenPoly));
	Clear();
}

void Polys::Clear(void)
{
	mLastPoly = 0;
	mLastSortTablePoly = 0;
}

ScreenPoly *Polys::GetNewPoly(void)
{
	ScreenPoly *ret = mScreenPolyList + mLastPoly;
	mLastPoly++;
	if (mLastPoly >= mMaxPolys)
	{
		mLastPoly = mMaxPolys-1;
	}
	return ret;
}

void Polys::SubmitPoly(ScreenPoly *poly,int ZPos)
{
	if (mLastSortTablePoly >= mMaxPolys)
	{
		return;
	}

	mSortBuffer[mLastSortTablePoly].mZPos = ZPos;
	mSortBuffer[mLastSortTablePoly].mScreenPoly = poly;
	mLastSortTablePoly++;
}

void Polys::Sort(void)
{
	bool swapped;
	do
	{
		swapped = false;
		for (int i=0;i<mLastSortTablePoly-1;i++)
		{
			if (mSortBuffer[i].mZPos > mSortBuffer[i+1].mZPos)
			{
				swapped = true;
				int temp;
				temp = mSortBuffer[i].mZPos;
				mSortBuffer[i].mZPos = mSortBuffer[i+1].mZPos;
				mSortBuffer[i+1].mZPos = temp;
				ScreenPoly *temp2;
				temp2 = mSortBuffer[i].mScreenPoly;
				mSortBuffer[i].mScreenPoly = mSortBuffer[i+1].mScreenPoly;
				mSortBuffer[i+1].mScreenPoly = temp2;
			}
		}
	} while (swapped);
}

void Polys::Draw(void *screenmem)
{
	for (int i=0;i<mLastSortTablePoly;i++)
	{
		Draw(screenmem,mSortBuffer[i].mScreenPoly);
	}
}

void Polys::Draw(void *screenmem,ScreenPoly *poly)
{
	switch (poly->mType)
	{
		case ScreenPoly::kFlat:
		default:
			DrawPoly(screenmem,poly->mX,poly->mY,poly->mColours[0]);
			break;
	}
}

