#ifndef __POLYS_H__
#define __POLYS_H__

#include <agb.h>

typedef struct s_ScreenPoly
{
	enum
	{
		kFlat = 0,
		kGouraud,
		kTextured
	};
	int mX[3],mY[3];
	int mU[3],mV[3];
	u8 mType;
	u8 mColours[3];
} ScreenPoly;

typedef struct s_SortTableEntry
{
	int mZPos;
	ScreenPoly *mScreenPoly;
} SortTableEntry;

typedef struct s_Polys
{
public:
	void Init(int maxpolys);
	void Clear(void);
	ScreenPoly *GetNewPoly(void);
	void SubmitPoly(ScreenPoly *poly,int ZPos);
	void Sort(void);
	void Draw(void *screenmem);
	void Draw(void *screenmem,ScreenPoly *poly);

private:
	int mMaxPolys;
	int mLastPoly;
	int mLastSortTablePoly;
	SortTableEntry *mSortBuffer;
	ScreenPoly *mScreenPolyList;
} Polys;

#endif
